package attackTree.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

/**
 * @generated
 */
public class GoalNodeSuccessorReorientCommand extends EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject referenceOwner;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public GoalNodeSuccessorReorientCommand(
			ReorientReferenceRelationshipRequest request) {
		super(request.getLabel(), null, request);
		reorientDirection = request.getDirection();
		referenceOwner = request.getReferenceOwner();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (!(referenceOwner instanceof SeaMonster.GoalNode)) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof SeaMonster.AttackTreeComponent && newEnd instanceof SeaMonster.GoalNode)) {
			return false;
		}
		return attackTree.diagram.edit.policies.SeaMonsterBaseItemSemanticEditPolicy.LinkConstraints
				.canExistGoalNodePredecessor_3002(getNewSource(),
						getOldTarget());
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof SeaMonster.AttackTreeComponent && newEnd instanceof SeaMonster.AttackTreeComponent)) {
			return false;
		}
		return attackTree.diagram.edit.policies.SeaMonsterBaseItemSemanticEditPolicy.LinkConstraints
				.canExistGoalNodePredecessor_3002(getOldSource(),
						getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getOldSource().getPredecessor().remove(getOldTarget());
		getNewSource().getPredecessor().add(getOldTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getOldSource().getPredecessor().remove(getOldTarget());
		getOldSource().getPredecessor().add(getNewTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected SeaMonster.GoalNode getOldSource() {
		return (SeaMonster.GoalNode) referenceOwner;
	}

	/**
	 * @generated
	 */
	protected SeaMonster.GoalNode getNewSource() {
		return (SeaMonster.GoalNode) newEnd;
	}

	/**
	 * @generated
	 */
	protected SeaMonster.AttackTreeComponent getOldTarget() {
		return (SeaMonster.AttackTreeComponent) oldEnd;
	}

	/**
	 * @generated
	 */
	protected SeaMonster.AttackTreeComponent getNewTarget() {
		return (SeaMonster.AttackTreeComponent) newEnd;
	}
}
