package attackTree.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class SeaMonsterVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = attackTree.diagram.part.SeaMonsterDiagramEditorPlugin
			.getInstance().getBundle().getSymbolicName()
			+ "/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (attackTree.diagram.edit.parts.AttackTreeEditPart.MODEL_ID
					.equals(view.getType())) {
				return attackTree.diagram.edit.parts.AttackTreeEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return attackTree.diagram.part.SeaMonsterVisualIDRegistry
				.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				attackTree.diagram.part.SeaMonsterDiagramEditorPlugin
						.getInstance().logError(
								"Unable to parse view type as a visualID number: "
										+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return String.valueOf(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (SeaMonster.SeaMonsterPackage.eINSTANCE.getAttackTree()
				.isSuperTypeOf(domainElement.eClass())
				&& isDiagram((SeaMonster.AttackTree) domainElement)) {
			return attackTree.diagram.edit.parts.AttackTreeEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null
				|| !attackTree.diagram.edit.parts.AttackTreeEditPart.MODEL_ID
						.equals(attackTree.diagram.part.SeaMonsterVisualIDRegistry
								.getModelID(containerView))) {
			return -1;
		}
		switch (attackTree.diagram.part.SeaMonsterVisualIDRegistry
				.getVisualID(containerView)) {
		case attackTree.diagram.edit.parts.AttackTreeEditPart.VISUAL_ID:
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getAndNode()
					.isSuperTypeOf(domainElement.eClass())) {
				return attackTree.diagram.edit.parts.AndNodeEditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getGoalNode()
					.isSuperTypeOf(domainElement.eClass())) {
				return attackTree.diagram.edit.parts.GoalNodeEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = attackTree.diagram.part.SeaMonsterVisualIDRegistry
				.getModelID(containerView);
		if (!attackTree.diagram.edit.parts.AttackTreeEditPart.MODEL_ID
				.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (attackTree.diagram.edit.parts.AttackTreeEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = attackTree.diagram.part.SeaMonsterVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = attackTree.diagram.edit.parts.AttackTreeEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case attackTree.diagram.edit.parts.AndNodeEditPart.VISUAL_ID:
			if (attackTree.diagram.edit.parts.LabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case attackTree.diagram.edit.parts.GoalNodeEditPart.VISUAL_ID:
			if (attackTree.diagram.edit.parts.GoalNodeNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case attackTree.diagram.edit.parts.AttackTreeEditPart.VISUAL_ID:
			if (attackTree.diagram.edit.parts.AndNodeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (attackTree.diagram.edit.parts.GoalNodeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(SeaMonster.AttackTree element) {
		return true;
	}

	/**
	 * @generated
	 */
	private static class JavaConstraints {

	}

}
