package attackTree.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.diagram.core.providers.AbstractViewProvider;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.type.core.IHintedType;
import org.eclipse.gmf.runtime.notation.View;

/**
 * @generated
 */
public class SeaMonsterViewProvider extends AbstractViewProvider {

	/**
	 * @generated
	 */
	protected Class getDiagramViewClass(IAdaptable semanticAdapter,
			String diagramKind) {
		EObject semanticElement = getSemanticElement(semanticAdapter);
		if (attackTree.diagram.edit.parts.AttackTreeEditPart.MODEL_ID
				.equals(diagramKind)
				&& attackTree.diagram.part.SeaMonsterVisualIDRegistry
						.getDiagramVisualID(semanticElement) != -1) {
			return attackTree.diagram.view.factories.AttackTreeViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getNodeViewClass(IAdaptable semanticAdapter,
			View containerView, String semanticHint) {
		if (containerView == null) {
			return null;
		}
		IElementType elementType = getSemanticElementType(semanticAdapter);
		EObject domainElement = getSemanticElement(semanticAdapter);
		int visualID;
		if (semanticHint == null) {
			// Semantic hint is not specified. Can be a result of call from CanonicalEditPolicy.
			// In this situation there should be NO elementType, visualID will be determined
			// by VisualIDRegistry.getNodeVisualID() for domainElement.
			if (elementType != null || domainElement == null) {
				return null;
			}
			visualID = attackTree.diagram.part.SeaMonsterVisualIDRegistry
					.getNodeVisualID(containerView, domainElement);
		} else {
			visualID = attackTree.diagram.part.SeaMonsterVisualIDRegistry
					.getVisualID(semanticHint);
			if (elementType != null) {
				// Semantic hint is specified together with element type.
				// Both parameters should describe exactly the same diagram element.
				// In addition we check that visualID returned by VisualIDRegistry.getNodeVisualID() for
				// domainElement (if specified) is the same as in element type.
				if (!attackTree.diagram.providers.SeaMonsterElementTypes
						.isKnownElementType(elementType)
						|| (!(elementType instanceof IHintedType))) {
					return null; // foreign element type
				}
				String elementTypeHint = ((IHintedType) elementType)
						.getSemanticHint();
				if (!semanticHint.equals(elementTypeHint)) {
					return null; // if semantic hint is specified it should be the same as in element type
				}
				if (domainElement != null
						&& visualID != attackTree.diagram.part.SeaMonsterVisualIDRegistry
								.getNodeVisualID(containerView, domainElement)) {
					return null; // visual id for node EClass should match visual id from element type
				}
			} else {
				// Element type is not specified. Domain element should be present (except pure design elements).
				// This method is called with EObjectAdapter as parameter from:
				//   - ViewService.createNode(View container, EObject eObject, String type, PreferencesHint preferencesHint) 
				//   - generated ViewFactory.decorateView() for parent element
				if (!attackTree.diagram.edit.parts.AttackTreeEditPart.MODEL_ID
						.equals(attackTree.diagram.part.SeaMonsterVisualIDRegistry
								.getModelID(containerView))) {
					return null; // foreign diagram
				}
				switch (visualID) {
				case attackTree.diagram.edit.parts.AndNodeEditPart.VISUAL_ID:
				case attackTree.diagram.edit.parts.GoalNodeEditPart.VISUAL_ID:
					if (domainElement == null
							|| visualID != attackTree.diagram.part.SeaMonsterVisualIDRegistry
									.getNodeVisualID(containerView,
											domainElement)) {
						return null; // visual id in semantic hint should match visual id for domain element
					}
					break;
				case attackTree.diagram.edit.parts.LabelEditPart.VISUAL_ID:
					if (attackTree.diagram.edit.parts.AndNodeEditPart.VISUAL_ID != attackTree.diagram.part.SeaMonsterVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case attackTree.diagram.edit.parts.GoalNodeNameEditPart.VISUAL_ID:
					if (attackTree.diagram.edit.parts.GoalNodeEditPart.VISUAL_ID != attackTree.diagram.part.SeaMonsterVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				default:
					return null;
				}
			}
		}
		return getNodeViewClass(containerView, visualID);
	}

	/**
	 * @generated
	 */
	protected Class getNodeViewClass(View containerView, int visualID) {
		if (containerView == null
				|| !attackTree.diagram.part.SeaMonsterVisualIDRegistry
						.canCreateNode(containerView, visualID)) {
			return null;
		}
		switch (visualID) {
		case attackTree.diagram.edit.parts.AndNodeEditPart.VISUAL_ID:
			return attackTree.diagram.view.factories.AndNodeViewFactory.class;
		case attackTree.diagram.edit.parts.LabelEditPart.VISUAL_ID:
			return attackTree.diagram.view.factories.LabelViewFactory.class;
		case attackTree.diagram.edit.parts.GoalNodeEditPart.VISUAL_ID:
			return attackTree.diagram.view.factories.GoalNodeViewFactory.class;
		case attackTree.diagram.edit.parts.GoalNodeNameEditPart.VISUAL_ID:
			return attackTree.diagram.view.factories.GoalNodeNameViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getEdgeViewClass(IAdaptable semanticAdapter,
			View containerView, String semanticHint) {
		IElementType elementType = getSemanticElementType(semanticAdapter);
		if (!attackTree.diagram.providers.SeaMonsterElementTypes
				.isKnownElementType(elementType)
				|| (!(elementType instanceof IHintedType))) {
			return null; // foreign element type
		}
		String elementTypeHint = ((IHintedType) elementType).getSemanticHint();
		if (elementTypeHint == null) {
			return null; // our hint is visual id and must be specified
		}
		if (semanticHint != null && !semanticHint.equals(elementTypeHint)) {
			return null; // if semantic hint is specified it should be the same as in element type
		}
		int visualID = attackTree.diagram.part.SeaMonsterVisualIDRegistry
				.getVisualID(elementTypeHint);
		EObject domainElement = getSemanticElement(semanticAdapter);
		if (domainElement != null
				&& visualID != attackTree.diagram.part.SeaMonsterVisualIDRegistry
						.getLinkWithClassVisualID(domainElement)) {
			return null; // visual id for link EClass should match visual id from element type
		}
		return getEdgeViewClass(visualID);
	}

	/**
	 * @generated
	 */
	protected Class getEdgeViewClass(int visualID) {
		switch (visualID) {
		case attackTree.diagram.edit.parts.AndNodeSuccessorEditPart.VISUAL_ID:
			return attackTree.diagram.view.factories.AndNodeSuccessorViewFactory.class;
		case attackTree.diagram.edit.parts.GoalNodeSuccessorEditPart.VISUAL_ID:
			return attackTree.diagram.view.factories.GoalNodeSuccessorViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	private IElementType getSemanticElementType(IAdaptable semanticAdapter) {
		if (semanticAdapter == null) {
			return null;
		}
		return (IElementType) semanticAdapter.getAdapter(IElementType.class);
	}
}
