/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SeaMonster.provider;

import SeaMonster.util.SeaMonsterAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class SeaMonsterItemProviderAdapterFactory extends SeaMonsterAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SeaMonsterItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.SecurityModel} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SecurityModelItemProvider securityModelItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.SecurityModel}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSecurityModelAdapter() {
		if (securityModelItemProvider == null) {
			securityModelItemProvider = new SecurityModelItemProvider(this);
		}

		return securityModelItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.AttackTree} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AttackTreeItemProvider attackTreeItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.AttackTree}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAttackTreeAdapter() {
		if (attackTreeItemProvider == null) {
			attackTreeItemProvider = new AttackTreeItemProvider(this);
		}

		return attackTreeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.VCG} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected VCGItemProvider vcgItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.VCG}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createVCGAdapter() {
		if (vcgItemProvider == null) {
			vcgItemProvider = new VCGItemProvider(this);
		}

		return vcgItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.MisuseCase} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MisuseCaseItemProvider misuseCaseItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.MisuseCase}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMisuseCaseAdapter() {
		if (misuseCaseItemProvider == null) {
			misuseCaseItemProvider = new MisuseCaseItemProvider(this);
		}

		return misuseCaseItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.AndNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AndNodeItemProvider andNodeItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.AndNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAndNodeAdapter() {
		if (andNodeItemProvider == null) {
			andNodeItemProvider = new AndNodeItemProvider(this);
		}

		return andNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.GoalNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GoalNodeItemProvider goalNodeItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.GoalNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createGoalNodeAdapter() {
		if (goalNodeItemProvider == null) {
			goalNodeItemProvider = new GoalNodeItemProvider(this);
		}

		return goalNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.ExitNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExitNodeItemProvider exitNodeItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.ExitNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createExitNodeAdapter() {
		if (exitNodeItemProvider == null) {
			exitNodeItemProvider = new ExitNodeItemProvider(this);
		}

		return exitNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.CauseNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CauseNodeItemProvider causeNodeItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.CauseNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCauseNodeAdapter() {
		if (causeNodeItemProvider == null) {
			causeNodeItemProvider = new CauseNodeItemProvider(this);
		}

		return causeNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.CompoundNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CompoundNodeItemProvider compoundNodeItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.CompoundNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCompoundNodeAdapter() {
		if (compoundNodeItemProvider == null) {
			compoundNodeItemProvider = new CompoundNodeItemProvider(this);
		}

		return compoundNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.SimpleNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SimpleNodeItemProvider simpleNodeItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.SimpleNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSimpleNodeAdapter() {
		if (simpleNodeItemProvider == null) {
			simpleNodeItemProvider = new SimpleNodeItemProvider(this);
		}

		return simpleNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.ConjunctionNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConjunctionNodeItemProvider conjunctionNodeItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.ConjunctionNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createConjunctionNodeAdapter() {
		if (conjunctionNodeItemProvider == null) {
			conjunctionNodeItemProvider = new ConjunctionNodeItemProvider(this);
		}

		return conjunctionNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.GoodActor} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GoodActorItemProvider goodActorItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.GoodActor}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createGoodActorAdapter() {
		if (goodActorItemProvider == null) {
			goodActorItemProvider = new GoodActorItemProvider(this);
		}

		return goodActorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.BadActor} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BadActorItemProvider badActorItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.BadActor}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBadActorAdapter() {
		if (badActorItemProvider == null) {
			badActorItemProvider = new BadActorItemProvider(this);
		}

		return badActorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.InsiderActor} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InsiderActorItemProvider insiderActorItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.InsiderActor}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInsiderActorAdapter() {
		if (insiderActorItemProvider == null) {
			insiderActorItemProvider = new InsiderActorItemProvider(this);
		}

		return insiderActorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.Actor} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ActorItemProvider actorItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.Actor}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createActorAdapter() {
		if (actorItemProvider == null) {
			actorItemProvider = new ActorItemProvider(this);
		}

		return actorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.UseCase} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected UseCaseItemProvider useCaseItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.UseCase}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createUseCaseAdapter() {
		if (useCaseItemProvider == null) {
			useCaseItemProvider = new UseCaseItemProvider(this);
		}

		return useCaseItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.NormalCase} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NormalCaseItemProvider normalCaseItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.NormalCase}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createNormalCaseAdapter() {
		if (normalCaseItemProvider == null) {
			normalCaseItemProvider = new NormalCaseItemProvider(this);
		}

		return normalCaseItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.ThreatCase} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ThreatCaseItemProvider threatCaseItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.ThreatCase}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createThreatCaseAdapter() {
		if (threatCaseItemProvider == null) {
			threatCaseItemProvider = new ThreatCaseItemProvider(this);
		}

		return threatCaseItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.VulnerabilityCase} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected VulnerabilityCaseItemProvider vulnerabilityCaseItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.VulnerabilityCase}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createVulnerabilityCaseAdapter() {
		if (vulnerabilityCaseItemProvider == null) {
			vulnerabilityCaseItemProvider = new VulnerabilityCaseItemProvider(this);
		}

		return vulnerabilityCaseItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.SystemBox} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SystemBoxItemProvider systemBoxItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.SystemBox}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSystemBoxAdapter() {
		if (systemBoxItemProvider == null) {
			systemBoxItemProvider = new SystemBoxItemProvider(this);
		}

		return systemBoxItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.DocumentRoot} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DocumentRootItemProvider documentRootItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.DocumentRoot}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDocumentRootAdapter() {
		if (documentRootItemProvider == null) {
			documentRootItemProvider = new DocumentRootItemProvider(this);
		}

		return documentRootItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.SAG} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SAGItemProvider sagItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.SAG}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSAGAdapter() {
		if (sagItemProvider == null) {
			sagItemProvider = new SAGItemProvider(this);
		}

		return sagItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.Vulnerability} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected VulnerabilityItemProvider vulnerabilityItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.Vulnerability}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createVulnerabilityAdapter() {
		if (vulnerabilityItemProvider == null) {
			vulnerabilityItemProvider = new VulnerabilityItemProvider(this);
		}

		return vulnerabilityItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.SAGNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SAGNodeItemProvider sagNodeItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.SAGNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSAGNodeAdapter() {
		if (sagNodeItemProvider == null) {
			sagNodeItemProvider = new SAGNodeItemProvider(this);
		}

		return sagNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.ActivityNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ActivityNodeItemProvider activityNodeItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.ActivityNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createActivityNodeAdapter() {
		if (activityNodeItemProvider == null) {
			activityNodeItemProvider = new ActivityNodeItemProvider(this);
		}

		return activityNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.OrNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OrNodeItemProvider orNodeItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.OrNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createOrNodeAdapter() {
		if (orNodeItemProvider == null) {
			orNodeItemProvider = new OrNodeItemProvider(this);
		}

		return orNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.SagAndNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SagAndNodeItemProvider sagAndNodeItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.SagAndNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSagAndNodeAdapter() {
		if (sagAndNodeItemProvider == null) {
			sagAndNodeItemProvider = new SagAndNodeItemProvider(this);
		}

		return sagAndNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link SeaMonster.SplitNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SplitNodeItemProvider splitNodeItemProvider;

	/**
	 * This creates an adapter for a {@link SeaMonster.SplitNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSplitNodeAdapter() {
		if (splitNodeItemProvider == null) {
			splitNodeItemProvider = new SplitNodeItemProvider(this);
		}

		return splitNodeItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (securityModelItemProvider != null) securityModelItemProvider.dispose();
		if (attackTreeItemProvider != null) attackTreeItemProvider.dispose();
		if (vcgItemProvider != null) vcgItemProvider.dispose();
		if (misuseCaseItemProvider != null) misuseCaseItemProvider.dispose();
		if (andNodeItemProvider != null) andNodeItemProvider.dispose();
		if (goalNodeItemProvider != null) goalNodeItemProvider.dispose();
		if (exitNodeItemProvider != null) exitNodeItemProvider.dispose();
		if (causeNodeItemProvider != null) causeNodeItemProvider.dispose();
		if (compoundNodeItemProvider != null) compoundNodeItemProvider.dispose();
		if (simpleNodeItemProvider != null) simpleNodeItemProvider.dispose();
		if (conjunctionNodeItemProvider != null) conjunctionNodeItemProvider.dispose();
		if (goodActorItemProvider != null) goodActorItemProvider.dispose();
		if (badActorItemProvider != null) badActorItemProvider.dispose();
		if (insiderActorItemProvider != null) insiderActorItemProvider.dispose();
		if (actorItemProvider != null) actorItemProvider.dispose();
		if (useCaseItemProvider != null) useCaseItemProvider.dispose();
		if (normalCaseItemProvider != null) normalCaseItemProvider.dispose();
		if (threatCaseItemProvider != null) threatCaseItemProvider.dispose();
		if (vulnerabilityCaseItemProvider != null) vulnerabilityCaseItemProvider.dispose();
		if (systemBoxItemProvider != null) systemBoxItemProvider.dispose();
		if (documentRootItemProvider != null) documentRootItemProvider.dispose();
		if (sagItemProvider != null) sagItemProvider.dispose();
		if (vulnerabilityItemProvider != null) vulnerabilityItemProvider.dispose();
		if (sagNodeItemProvider != null) sagNodeItemProvider.dispose();
		if (orNodeItemProvider != null) orNodeItemProvider.dispose();
		if (sagAndNodeItemProvider != null) sagAndNodeItemProvider.dispose();
		if (splitNodeItemProvider != null) splitNodeItemProvider.dispose();
		if (activityNodeItemProvider != null) activityNodeItemProvider.dispose();
	}

}
