package misusecase.diagram.edit.commands;

import misusecase.diagram.edit.policies.SeaMonsterBaseItemSemanticEditPolicy;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

/**
 * @generated
 */
public class NormalCaseExtendsReorientCommand extends EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject referenceOwner;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public NormalCaseExtendsReorientCommand(
			ReorientReferenceRelationshipRequest request) {
		super(request.getLabel(), null, request);
		reorientDirection = request.getDirection();
		referenceOwner = request.getReferenceOwner();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (!(referenceOwner instanceof SeaMonster.NormalCase)) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof SeaMonster.NormalCase && newEnd instanceof SeaMonster.NormalCase)) {
			return false;
		}
		return SeaMonsterBaseItemSemanticEditPolicy.LinkConstraints
				.canExistNormalCaseExtends_3007(getNewSource(), getOldTarget());
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof SeaMonster.NormalCase && newEnd instanceof SeaMonster.NormalCase)) {
			return false;
		}
		return SeaMonsterBaseItemSemanticEditPolicy.LinkConstraints
				.canExistNormalCaseExtends_3007(getOldSource(), getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getOldSource().getExtends().remove(getOldTarget());
		getNewSource().getExtends().add(getOldTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getOldSource().getExtends().remove(getOldTarget());
		getOldSource().getExtends().add(getNewTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected SeaMonster.NormalCase getOldSource() {
		return (SeaMonster.NormalCase) referenceOwner;
	}

	/**
	 * @generated
	 */
	protected SeaMonster.NormalCase getNewSource() {
		return (SeaMonster.NormalCase) newEnd;
	}

	/**
	 * @generated
	 */
	protected SeaMonster.NormalCase getOldTarget() {
		return (SeaMonster.NormalCase) oldEnd;
	}

	/**
	 * @generated
	 */
	protected SeaMonster.NormalCase getNewTarget() {
		return (SeaMonster.NormalCase) newEnd;
	}
}
