package misusecase.diagram.edit.policies;

import misusecase.diagram.edit.commands.BadActorCreateCommand;
import misusecase.diagram.edit.commands.GoodActorCreateCommand;
import misusecase.diagram.edit.commands.InsiderActorCreateCommand;
import misusecase.diagram.edit.commands.NormalCaseCreateCommand;
import misusecase.diagram.edit.commands.SystemBoxCreateCommand;
import misusecase.diagram.edit.commands.ThreatCaseCreateCommand;
import misusecase.diagram.edit.commands.VulnerabilityCaseCreateCommand;
import misusecase.diagram.providers.SeaMonsterElementTypes;

import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.commands.core.commands.DuplicateEObjectsCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DuplicateElementsRequest;

/**
 * @generated
 */
public class MisuseCaseItemSemanticEditPolicy extends
		SeaMonsterBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		if (SeaMonsterElementTypes.ThreatCase_1001 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getMisuseCase_Usecases());
			}
			return getGEFWrapper(new ThreatCaseCreateCommand(req));
		}
		if (SeaMonsterElementTypes.VulnerabilityCase_1002 == req
				.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getMisuseCase_Usecases());
			}
			return getGEFWrapper(new VulnerabilityCaseCreateCommand(req));
		}
		if (SeaMonsterElementTypes.SystemBox_1003 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getMisuseCase_System());
			}
			return getGEFWrapper(new SystemBoxCreateCommand(req));
		}
		if (SeaMonsterElementTypes.GoodActor_1004 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getMisuseCase_Actors());
			}
			return getGEFWrapper(new GoodActorCreateCommand(req));
		}
		if (SeaMonsterElementTypes.InsiderActor_1005 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getMisuseCase_Actors());
			}
			return getGEFWrapper(new InsiderActorCreateCommand(req));
		}
		if (SeaMonsterElementTypes.BadActor_1006 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getMisuseCase_Actors());
			}
			return getGEFWrapper(new BadActorCreateCommand(req));
		}
		if (SeaMonsterElementTypes.NormalCase_1007 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getMisuseCase_Usecases());
			}
			return getGEFWrapper(new NormalCaseCreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getDuplicateCommand(DuplicateElementsRequest req) {
		TransactionalEditingDomain editingDomain = ((IGraphicalEditPart) getHost())
				.getEditingDomain();
		return getGEFWrapper(new DuplicateAnythingCommand(editingDomain, req));
	}

	/**
	 * @generated
	 */
	private static class DuplicateAnythingCommand extends
			DuplicateEObjectsCommand {

		/**
		 * @generated
		 */
		public DuplicateAnythingCommand(
				TransactionalEditingDomain editingDomain,
				DuplicateElementsRequest req) {
			super(editingDomain, req.getLabel(), req
					.getElementsToBeDuplicated(), req
					.getAllDuplicatedElementsMap());
		}

	}

}
