package misusecase.diagram.edit.policies;

import misusecase.diagram.edit.commands.GoodActorUsesCreateCommand;
import misusecase.diagram.edit.commands.GoodActorUsesReorientCommand;
import misusecase.diagram.edit.commands.InsiderActorUsesCreateCommand;
import misusecase.diagram.edit.commands.InsiderActorUsesReorientCommand;
import misusecase.diagram.edit.commands.NormalCaseDetectVulCreateCommand;
import misusecase.diagram.edit.commands.NormalCaseDetectVulReorientCommand;
import misusecase.diagram.edit.commands.NormalCaseExtendsCreateCommand;
import misusecase.diagram.edit.commands.NormalCaseExtendsReorientCommand;
import misusecase.diagram.edit.commands.NormalCaseGeneralizationCreateCommand;
import misusecase.diagram.edit.commands.NormalCaseGeneralizationReorientCommand;
import misusecase.diagram.edit.commands.NormalCaseIncludesCreateCommand;
import misusecase.diagram.edit.commands.NormalCaseIncludesReorientCommand;
import misusecase.diagram.edit.commands.NormalCaseMitigates2CreateCommand;
import misusecase.diagram.edit.commands.NormalCaseMitigates2ReorientCommand;
import misusecase.diagram.edit.commands.NormalCaseMitigatesCreateCommand;
import misusecase.diagram.edit.commands.NormalCaseMitigatesReorientCommand;
import misusecase.diagram.edit.commands.NormalCasePreventVulCreateCommand;
import misusecase.diagram.edit.commands.NormalCasePreventVulReorientCommand;
import misusecase.diagram.edit.commands.ThreatCaseThreatenCreateCommand;
import misusecase.diagram.edit.commands.ThreatCaseThreatenReorientCommand;
import misusecase.diagram.edit.parts.GoodActorUsesEditPart;
import misusecase.diagram.edit.parts.InsiderActorUsesEditPart;
import misusecase.diagram.edit.parts.NormalCaseDetectVulEditPart;
import misusecase.diagram.edit.parts.NormalCaseExtendsEditPart;
import misusecase.diagram.edit.parts.NormalCaseGeneralizationEditPart;
import misusecase.diagram.edit.parts.NormalCaseIncludesEditPart;
import misusecase.diagram.edit.parts.NormalCaseMitigates2EditPart;
import misusecase.diagram.edit.parts.NormalCaseMitigatesEditPart;
import misusecase.diagram.edit.parts.NormalCasePreventVulEditPart;
import misusecase.diagram.edit.parts.ThreatCaseThreatenEditPart;
import misusecase.diagram.providers.SeaMonsterElementTypes;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.notation.View;

/**
 * @generated
 */
public class NormalCaseItemSemanticEditPolicy extends
		SeaMonsterBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		CompoundCommand cc = getDestroyEdgesCommand();
		addDestroyShortcutsCommand(cc);
		View view = (View) getHost().getModel();
		if (view.getEAnnotation("Shortcut") != null) { //$NON-NLS-1$
			req.setElementToDestroy(view);
		}
		cc.add(getGEFWrapper(new DestroyElementCommand(req)));
		return cc.unwrap();
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		Command command = req.getTarget() == null ? getStartCreateRelationshipCommand(req)
				: getCompleteCreateRelationshipCommand(req);
		return command != null ? command : super
				.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getStartCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (SeaMonsterElementTypes.NormalCasePrevents_3001 == req
				.getElementType()) {
			return getGEFWrapper(new NormalCaseMitigatesCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (SeaMonsterElementTypes.NormalCaseIncludes_3002 == req
				.getElementType()) {
			return getGEFWrapper(new NormalCaseIncludesCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (SeaMonsterElementTypes.GoodActorUses_3003 == req.getElementType()) {
			return null;
		}
		if (SeaMonsterElementTypes.InsiderActorUses_3004 == req
				.getElementType()) {
			return null;
		}
		if (SeaMonsterElementTypes.NormalCaseDetects_3005 == req
				.getElementType()) {
			return getGEFWrapper(new NormalCaseMitigates2CreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (SeaMonsterElementTypes.NormalCaseExtends_3007 == req
				.getElementType()) {
			return getGEFWrapper(new NormalCaseExtendsCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (SeaMonsterElementTypes.ThreatCaseThreaten_3009 == req
				.getElementType()) {
			return null;
		}
		if (SeaMonsterElementTypes.NormalCaseGeneralization_3010 == req
				.getElementType()) {
			return getGEFWrapper(new NormalCaseGeneralizationCreateCommand(req,
					req.getSource(), req.getTarget()));
		}
		if (SeaMonsterElementTypes.NormalCasePreventVul_3011 == req
				.getElementType()) {
			return getGEFWrapper(new NormalCasePreventVulCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (SeaMonsterElementTypes.NormalCaseDetectVul_3012 == req
				.getElementType()) {
			return getGEFWrapper(new NormalCaseDetectVulCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCompleteCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (SeaMonsterElementTypes.NormalCasePrevents_3001 == req
				.getElementType()) {
			return null;
		}
		if (SeaMonsterElementTypes.NormalCaseIncludes_3002 == req
				.getElementType()) {
			return getGEFWrapper(new NormalCaseIncludesCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (SeaMonsterElementTypes.GoodActorUses_3003 == req.getElementType()) {
			return getGEFWrapper(new GoodActorUsesCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (SeaMonsterElementTypes.InsiderActorUses_3004 == req
				.getElementType()) {
			return getGEFWrapper(new InsiderActorUsesCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (SeaMonsterElementTypes.NormalCaseDetects_3005 == req
				.getElementType()) {
			return null;
		}
		if (SeaMonsterElementTypes.NormalCaseExtends_3007 == req
				.getElementType()) {
			return getGEFWrapper(new NormalCaseExtendsCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (SeaMonsterElementTypes.ThreatCaseThreaten_3009 == req
				.getElementType()) {
			return getGEFWrapper(new ThreatCaseThreatenCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (SeaMonsterElementTypes.NormalCaseGeneralization_3010 == req
				.getElementType()) {
			return getGEFWrapper(new NormalCaseGeneralizationCreateCommand(req,
					req.getSource(), req.getTarget()));
		}
		if (SeaMonsterElementTypes.NormalCasePreventVul_3011 == req
				.getElementType()) {
			return null;
		}
		if (SeaMonsterElementTypes.NormalCaseDetectVul_3012 == req
				.getElementType()) {
			return null;
		}
		return null;
	}

	/**
	 * Returns command to reorient EReference based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientReferenceRelationshipCommand(
			ReorientReferenceRelationshipRequest req) {
		switch (getVisualID(req)) {
		case NormalCaseMitigatesEditPart.VISUAL_ID:
			return getGEFWrapper(new NormalCaseMitigatesReorientCommand(req));
		case NormalCaseIncludesEditPart.VISUAL_ID:
			return getGEFWrapper(new NormalCaseIncludesReorientCommand(req));
		case GoodActorUsesEditPart.VISUAL_ID:
			return getGEFWrapper(new GoodActorUsesReorientCommand(req));
		case InsiderActorUsesEditPart.VISUAL_ID:
			return getGEFWrapper(new InsiderActorUsesReorientCommand(req));
		case NormalCaseMitigates2EditPart.VISUAL_ID:
			return getGEFWrapper(new NormalCaseMitigates2ReorientCommand(req));
		case NormalCaseExtendsEditPart.VISUAL_ID:
			return getGEFWrapper(new NormalCaseExtendsReorientCommand(req));
		case ThreatCaseThreatenEditPart.VISUAL_ID:
			return getGEFWrapper(new ThreatCaseThreatenReorientCommand(req));
		case NormalCaseGeneralizationEditPart.VISUAL_ID:
			return getGEFWrapper(new NormalCaseGeneralizationReorientCommand(
					req));
		case NormalCasePreventVulEditPart.VISUAL_ID:
			return getGEFWrapper(new NormalCasePreventVulReorientCommand(req));
		case NormalCaseDetectVulEditPart.VISUAL_ID:
			return getGEFWrapper(new NormalCaseDetectVulReorientCommand(req));
		}
		return super.getReorientReferenceRelationshipCommand(req);
	}

}
