package sag.diagram.edit.policies;

import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.commands.core.commands.DuplicateEObjectsCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DuplicateElementsRequest;

import sag.diagram.edit.commands.ActivityNodeCreateCommand;
import sag.diagram.edit.commands.OrNodeCreateCommand;
import sag.diagram.edit.commands.SagAndNodeCreateCommand;
import sag.diagram.edit.commands.SplitNodeCreateCommand;
import sag.diagram.edit.commands.VulnerabilityCreateCommand;
import sag.diagram.providers.SeaMonsterElementTypes;

/**
 * @generated
 */
public class SAGItemSemanticEditPolicy extends
		SeaMonsterBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		if (SeaMonsterElementTypes.Vulnerability_1001 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getSAG_SAGvulnerability());
			}
			return getGEFWrapper(new VulnerabilityCreateCommand(req));
		}
		if (SeaMonsterElementTypes.OrNode_1002 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getSAG_ActivityList());
			}
			return getGEFWrapper(new OrNodeCreateCommand(req));
		}
		if (SeaMonsterElementTypes.SagAndNode_1003 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getSAG_ActivityList());
			}
			return getGEFWrapper(new SagAndNodeCreateCommand(req));
		}
		if (SeaMonsterElementTypes.ActivityNode_1004 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getSAG_ActivityList());
			}
			return getGEFWrapper(new ActivityNodeCreateCommand(req));
		}
		if (SeaMonsterElementTypes.SplitNode_1005 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getSAG_ActivityList());
			}
			return getGEFWrapper(new SplitNodeCreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getDuplicateCommand(DuplicateElementsRequest req) {
		TransactionalEditingDomain editingDomain = ((IGraphicalEditPart) getHost())
				.getEditingDomain();
		return getGEFWrapper(new DuplicateAnythingCommand(editingDomain, req));
	}

	/**
	 * @generated
	 */
	private static class DuplicateAnythingCommand extends
			DuplicateEObjectsCommand {

		/**
		 * @generated
		 */
		public DuplicateAnythingCommand(
				TransactionalEditingDomain editingDomain,
				DuplicateElementsRequest req) {
			super(editingDomain, req.getLabel(), req
					.getElementsToBeDuplicated(), req
					.getAllDuplicatedElementsMap());
		}

	}

}
