package sag.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;

import sag.diagram.edit.parts.ActivityNodeEditPart;
import sag.diagram.edit.parts.OrNodeEditPart;
import sag.diagram.edit.parts.SAGEditPart;
import sag.diagram.edit.parts.SAGNodePreActivityEditPart;
import sag.diagram.edit.parts.SagAndNodeEditPart;
import sag.diagram.edit.parts.SplitNodeEditPart;
import sag.diagram.edit.parts.VulnerabilityEditPart;
import sag.diagram.edit.parts.VulnerabilityRootActivityEditPart;
import sag.diagram.providers.SeaMonsterElementTypes;

/**
 * @generated
 */
public class SeaMonsterDiagramUpdater {

	/**
	 * @generated
	 */
	public static List getSemanticChildren(View view) {
		switch (SeaMonsterVisualIDRegistry.getVisualID(view)) {
		case SAGEditPart.VISUAL_ID:
			return getSAG_79SemanticChildren(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getSAG_79SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		SeaMonster.SAG modelElement = (SeaMonster.SAG) view.getElement();
		List result = new LinkedList();
		{
			SeaMonster.Vulnerability childElement = modelElement
					.getSAGvulnerability();
			int visualID = SeaMonsterVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == VulnerabilityEditPart.VISUAL_ID) {
				result
						.add(new SeaMonsterNodeDescriptor(childElement,
								visualID));
			}
		}
		for (Iterator it = modelElement.getActivityList().iterator(); it
				.hasNext();) {
			SeaMonster.SAGNode childElement = (SeaMonster.SAGNode) it.next();
			int visualID = SeaMonsterVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == OrNodeEditPart.VISUAL_ID) {
				result
						.add(new SeaMonsterNodeDescriptor(childElement,
								visualID));
				continue;
			}
			if (visualID == SagAndNodeEditPart.VISUAL_ID) {
				result
						.add(new SeaMonsterNodeDescriptor(childElement,
								visualID));
				continue;
			}
			if (visualID == ActivityNodeEditPart.VISUAL_ID) {
				result
						.add(new SeaMonsterNodeDescriptor(childElement,
								visualID));
				continue;
			}
			if (visualID == SplitNodeEditPart.VISUAL_ID) {
				result
						.add(new SeaMonsterNodeDescriptor(childElement,
								visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getContainedLinks(View view) {
		switch (SeaMonsterVisualIDRegistry.getVisualID(view)) {
		case SAGEditPart.VISUAL_ID:
			return getSAG_79ContainedLinks(view);
		case VulnerabilityEditPart.VISUAL_ID:
			return getVulnerability_1001ContainedLinks(view);
		case OrNodeEditPart.VISUAL_ID:
			return getOrNode_1002ContainedLinks(view);
		case SagAndNodeEditPart.VISUAL_ID:
			return getSagAndNode_1003ContainedLinks(view);
		case ActivityNodeEditPart.VISUAL_ID:
			return getActivityNode_1004ContainedLinks(view);
		case SplitNodeEditPart.VISUAL_ID:
			return getSplitNode_1005ContainedLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getIncomingLinks(View view) {
		switch (SeaMonsterVisualIDRegistry.getVisualID(view)) {
		case VulnerabilityEditPart.VISUAL_ID:
			return getVulnerability_1001IncomingLinks(view);
		case OrNodeEditPart.VISUAL_ID:
			return getOrNode_1002IncomingLinks(view);
		case SagAndNodeEditPart.VISUAL_ID:
			return getSagAndNode_1003IncomingLinks(view);
		case ActivityNodeEditPart.VISUAL_ID:
			return getActivityNode_1004IncomingLinks(view);
		case SplitNodeEditPart.VISUAL_ID:
			return getSplitNode_1005IncomingLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOutgoingLinks(View view) {
		switch (SeaMonsterVisualIDRegistry.getVisualID(view)) {
		case VulnerabilityEditPart.VISUAL_ID:
			return getVulnerability_1001OutgoingLinks(view);
		case OrNodeEditPart.VISUAL_ID:
			return getOrNode_1002OutgoingLinks(view);
		case SagAndNodeEditPart.VISUAL_ID:
			return getSagAndNode_1003OutgoingLinks(view);
		case ActivityNodeEditPart.VISUAL_ID:
			return getActivityNode_1004OutgoingLinks(view);
		case SplitNodeEditPart.VISUAL_ID:
			return getSplitNode_1005OutgoingLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getSAG_79ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getVulnerability_1001ContainedLinks(View view) {
		SeaMonster.Vulnerability modelElement = (SeaMonster.Vulnerability) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Vulnerability_RootActivity_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getOrNode_1002ContainedLinks(View view) {
		SeaMonster.OrNode modelElement = (SeaMonster.OrNode) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_SAGNode_PreActivity_3002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getSagAndNode_1003ContainedLinks(View view) {
		SeaMonster.SagAndNode modelElement = (SeaMonster.SagAndNode) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_SAGNode_PreActivity_3002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getActivityNode_1004ContainedLinks(View view) {
		SeaMonster.ActivityNode modelElement = (SeaMonster.ActivityNode) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_SAGNode_PreActivity_3002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getSplitNode_1005ContainedLinks(View view) {
		SeaMonster.SplitNode modelElement = (SeaMonster.SplitNode) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_SAGNode_PreActivity_3002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getVulnerability_1001IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOrNode_1002IncomingLinks(View view) {
		SeaMonster.OrNode modelElement = (SeaMonster.OrNode) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Vulnerability_RootActivity_3001(
						modelElement, crossReferences));
		result
				.addAll(getIncomingFeatureModelFacetLinks_SAGNode_PreActivity_3002(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getSagAndNode_1003IncomingLinks(View view) {
		SeaMonster.SagAndNode modelElement = (SeaMonster.SagAndNode) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Vulnerability_RootActivity_3001(
						modelElement, crossReferences));
		result
				.addAll(getIncomingFeatureModelFacetLinks_SAGNode_PreActivity_3002(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getActivityNode_1004IncomingLinks(View view) {
		SeaMonster.ActivityNode modelElement = (SeaMonster.ActivityNode) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Vulnerability_RootActivity_3001(
						modelElement, crossReferences));
		result
				.addAll(getIncomingFeatureModelFacetLinks_SAGNode_PreActivity_3002(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getSplitNode_1005IncomingLinks(View view) {
		SeaMonster.SplitNode modelElement = (SeaMonster.SplitNode) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_Vulnerability_RootActivity_3001(
						modelElement, crossReferences));
		result
				.addAll(getIncomingFeatureModelFacetLinks_SAGNode_PreActivity_3002(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getVulnerability_1001OutgoingLinks(View view) {
		SeaMonster.Vulnerability modelElement = (SeaMonster.Vulnerability) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Vulnerability_RootActivity_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getOrNode_1002OutgoingLinks(View view) {
		SeaMonster.OrNode modelElement = (SeaMonster.OrNode) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_SAGNode_PreActivity_3002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getSagAndNode_1003OutgoingLinks(View view) {
		SeaMonster.SagAndNode modelElement = (SeaMonster.SagAndNode) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_SAGNode_PreActivity_3002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getActivityNode_1004OutgoingLinks(View view) {
		SeaMonster.ActivityNode modelElement = (SeaMonster.ActivityNode) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_SAGNode_PreActivity_3002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getSplitNode_1005OutgoingLinks(View view) {
		SeaMonster.SplitNode modelElement = (SeaMonster.SplitNode) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_SAGNode_PreActivity_3002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingFeatureModelFacetLinks_Vulnerability_RootActivity_3001(
			SeaMonster.SAGNode target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() == SeaMonster.SeaMonsterPackage.eINSTANCE
					.getVulnerability_RootActivity()) {
				result.add(new SeaMonsterLinkDescriptor(setting.getEObject(),
						target,
						SeaMonsterElementTypes.VulnerabilityRootActivity_3001,
						VulnerabilityRootActivityEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingFeatureModelFacetLinks_SAGNode_PreActivity_3002(
			SeaMonster.SAGNode target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() == SeaMonster.SeaMonsterPackage.eINSTANCE
					.getSAGNode_PreActivity()) {
				result.add(new SeaMonsterLinkDescriptor(setting.getEObject(),
						target, SeaMonsterElementTypes.SAGNodePreActivity_3002,
						SAGNodePreActivityEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_Vulnerability_RootActivity_3001(
			SeaMonster.Vulnerability source) {
		Collection result = new LinkedList();
		SeaMonster.SAGNode destination = source.getRootActivity();
		result.add(new SeaMonsterLinkDescriptor(source, destination,
				SeaMonsterElementTypes.VulnerabilityRootActivity_3001,
				VulnerabilityRootActivityEditPart.VISUAL_ID));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_SAGNode_PreActivity_3002(
			SeaMonster.SAGNode source) {
		Collection result = new LinkedList();
		for (Iterator destinations = source.getPreActivity().iterator(); destinations
				.hasNext();) {
			SeaMonster.SAGNode destination = (SeaMonster.SAGNode) destinations
					.next();
			result.add(new SeaMonsterLinkDescriptor(source, destination,
					SeaMonsterElementTypes.SAGNodePreActivity_3002,
					SAGNodePreActivityEditPart.VISUAL_ID));
		}
		return result;
	}

}
