package sag.diagram.part;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteGroup;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeConnectionTool;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeCreationTool;

import sag.diagram.providers.SeaMonsterElementTypes;

/**
 * @generated
 */
public class SeaMonsterPaletteFactory {

	/**
	 * @generated
	 */
	public void fillPalette(PaletteRoot paletteRoot) {
		paletteRoot.add(createSeaMonster1Group());
	}

	/**
	 * Creates "SeaMonster" palette tool group
	 * @generated
	 */
	private PaletteContainer createSeaMonster1Group() {
		PaletteGroup paletteContainer = new PaletteGroup(
				Messages.SeaMonster1Group_title);
		paletteContainer.add(createVulnerability1CreationTool());
		paletteContainer.add(createActivity2CreationTool());
		paletteContainer.add(createAndNode3CreationTool());
		paletteContainer.add(createOrNode4CreationTool());
		paletteContainer.add(createSplitNode5CreationTool());
		paletteContainer.add(createPredecessor6CreationTool());
		return paletteContainer;
	}

	/**
	 * @generated
	 */
	private ToolEntry createVulnerability1CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.Vulnerability_1001);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Vulnerability1CreationTool_title,
				Messages.Vulnerability1CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.sag/images/vulnerability.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createActivity2CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.ActivityNode_1004);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Activity2CreationTool_title,
				Messages.Activity2CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.sag/images/attacktree-goal.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createAndNode3CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.SagAndNode_1003);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.AndNode3CreationTool_title,
				Messages.AndNode3CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.sag/images/attacktree-and.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createOrNode4CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.OrNode_1002);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.OrNode4CreationTool_title,
				Messages.OrNode4CreationTool_desc, types);
		entry.setSmallIcon(SeaMonsterDiagramEditorPlugin
				.findImageDescriptor("/seaMonster.sag/images/or.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createSplitNode5CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.SplitNode_1005);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.SplitNode5CreationTool_title,
				Messages.SplitNode5CreationTool_desc, types);
		entry.setSmallIcon(SeaMonsterDiagramEditorPlugin
				.findImageDescriptor("/seaMonster.sag/images/split.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createPredecessor6CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(2);
		types.add(SeaMonsterElementTypes.VulnerabilityRootActivity_3001);
		types.add(SeaMonsterElementTypes.SAGNodePreActivity_3002);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Predecessor6CreationTool_title,
				Messages.Predecessor6CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.sag/images/attacktree-link.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private static class NodeToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List elementTypes;

		/**
		 * @generated
		 */
		private NodeToolEntry(String title, String description,
				List elementTypes) {
			super(title, description, null, null);
			this.elementTypes = elementTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeCreationTool(elementTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}

	/**
	 * @generated
	 */
	private static class LinkToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List relationshipTypes;

		/**
		 * @generated
		 */
		private LinkToolEntry(String title, String description,
				List relationshipTypes) {
			super(title, description, null, null);
			this.relationshipTypes = relationshipTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeConnectionTool(relationshipTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}
}
