package sag.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

import sag.diagram.edit.parts.ActivityNodeEditPart;
import sag.diagram.edit.parts.OrNodeEditPart;
import sag.diagram.edit.parts.SAGEditPart;
import sag.diagram.edit.parts.SagAndNodeEditPart;
import sag.diagram.edit.parts.SplitNodeEditPart;
import sag.diagram.edit.parts.VulnerabilityEditPart;
import sag.diagram.edit.parts.WrapLabel2EditPart;
import sag.diagram.edit.parts.WrapLabel3EditPart;
import sag.diagram.edit.parts.WrapLabel4EditPart;
import sag.diagram.edit.parts.WrapLabel5EditPart;
import sag.diagram.edit.parts.WrapLabelEditPart;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class SeaMonsterVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = SeaMonsterDiagramEditorPlugin
			.getInstance().getBundle().getSymbolicName()
			+ "/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (SAGEditPart.MODEL_ID.equals(view.getType())) {
				return SAGEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return sag.diagram.part.SeaMonsterVisualIDRegistry.getVisualID(view
				.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				SeaMonsterDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return String.valueOf(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (SeaMonster.SeaMonsterPackage.eINSTANCE.getSAG().isSuperTypeOf(
				domainElement.eClass())
				&& isDiagram((SeaMonster.SAG) domainElement)) {
			return SAGEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = sag.diagram.part.SeaMonsterVisualIDRegistry
				.getModelID(containerView);
		if (!SAGEditPart.MODEL_ID.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (SAGEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = sag.diagram.part.SeaMonsterVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = SAGEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case SAGEditPart.VISUAL_ID:
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getVulnerability()
					.isSuperTypeOf(domainElement.eClass())) {
				return VulnerabilityEditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getOrNode()
					.isSuperTypeOf(domainElement.eClass())) {
				return OrNodeEditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getSagAndNode()
					.isSuperTypeOf(domainElement.eClass())) {
				return SagAndNodeEditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getActivityNode()
					.isSuperTypeOf(domainElement.eClass())) {
				return ActivityNodeEditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getSplitNode()
					.isSuperTypeOf(domainElement.eClass())) {
				return SplitNodeEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = sag.diagram.part.SeaMonsterVisualIDRegistry
				.getModelID(containerView);
		if (!SAGEditPart.MODEL_ID.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (SAGEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = sag.diagram.part.SeaMonsterVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = SAGEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case VulnerabilityEditPart.VISUAL_ID:
			if (WrapLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case OrNodeEditPart.VISUAL_ID:
			if (WrapLabel2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SagAndNodeEditPart.VISUAL_ID:
			if (WrapLabel3EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ActivityNodeEditPart.VISUAL_ID:
			if (WrapLabel4EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SplitNodeEditPart.VISUAL_ID:
			if (WrapLabel5EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SAGEditPart.VISUAL_ID:
			if (VulnerabilityEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (OrNodeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SagAndNodeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ActivityNodeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SplitNodeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(SeaMonster.SAG element) {
		return true;
	}

	/**
	 * @generated
	 */
	private static class JavaConstraints {

	}

}
