package sag.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

import sag.diagram.part.SeaMonsterDiagramEditorPlugin;

/**
 * @generated
 */
public class SeaMonsterElementTypes extends ElementInitializers {

	/**
	 * @generated
	 */
	private SeaMonsterElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static Set KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType SAG_79 = getElementType("seaMonster.sag.SAG_79"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Vulnerability_1001 = getElementType("seaMonster.sag.Vulnerability_1001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType OrNode_1002 = getElementType("seaMonster.sag.OrNode_1002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType SagAndNode_1003 = getElementType("seaMonster.sag.SagAndNode_1003"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType ActivityNode_1004 = getElementType("seaMonster.sag.ActivityNode_1004"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType SplitNode_1005 = getElementType("seaMonster.sag.SplitNode_1005"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType VulnerabilityRootActivity_3001 = getElementType("seaMonster.sag.VulnerabilityRootActivity_3001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType SAGNodePreActivity_3002 = getElementType("seaMonster.sag.SAGNodePreActivity_3002"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(
			ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract()) {
				element = eContainingClass;
			} else if (eType instanceof EClass
					&& !((EClass) eType).isAbstract()) {
				element = eType;
			}
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return SeaMonsterDiagramEditorPlugin.getInstance()
						.getItemImageDescriptor(
								eClass.getEPackage().getEFactoryInstance()
										.create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap();

			elements.put(SAG_79, SeaMonster.SeaMonsterPackage.eINSTANCE
					.getSAG());

			elements.put(Vulnerability_1001,
					SeaMonster.SeaMonsterPackage.eINSTANCE.getVulnerability());

			elements.put(OrNode_1002, SeaMonster.SeaMonsterPackage.eINSTANCE
					.getOrNode());

			elements.put(SagAndNode_1003,
					SeaMonster.SeaMonsterPackage.eINSTANCE.getSagAndNode());

			elements.put(ActivityNode_1004,
					SeaMonster.SeaMonsterPackage.eINSTANCE.getActivityNode());

			elements.put(SplitNode_1005, SeaMonster.SeaMonsterPackage.eINSTANCE
					.getSplitNode());

			elements.put(VulnerabilityRootActivity_3001,
					SeaMonster.SeaMonsterPackage.eINSTANCE
							.getVulnerability_RootActivity());

			elements.put(SAGNodePreActivity_3002,
					SeaMonster.SeaMonsterPackage.eINSTANCE
							.getSAGNode_PreActivity());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet();
			KNOWN_ELEMENT_TYPES.add(SAG_79);
			KNOWN_ELEMENT_TYPES.add(Vulnerability_1001);
			KNOWN_ELEMENT_TYPES.add(OrNode_1002);
			KNOWN_ELEMENT_TYPES.add(SagAndNode_1003);
			KNOWN_ELEMENT_TYPES.add(ActivityNode_1004);
			KNOWN_ELEMENT_TYPES.add(SplitNode_1005);
			KNOWN_ELEMENT_TYPES.add(VulnerabilityRootActivity_3001);
			KNOWN_ELEMENT_TYPES.add(SAGNodePreActivity_3002);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

}
