package sag.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.service.AbstractProvider;
import org.eclipse.gmf.runtime.common.core.service.IOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.GetParserOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParserProvider;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.parser.ParserHintAdapter;
import org.eclipse.gmf.runtime.notation.View;

import sag.diagram.edit.parts.WrapLabel3EditPart;
import sag.diagram.edit.parts.WrapLabel4EditPart;
import sag.diagram.edit.parts.WrapLabelEditPart;
import sag.diagram.parsers.MessageFormatParser;
import sag.diagram.part.SeaMonsterVisualIDRegistry;

/**
 * @generated
 */
public class SeaMonsterParserProvider extends AbstractProvider implements
		IParserProvider {

	/**
	 * @generated
	 */
	private IParser vulnerabilityName_4001Parser;

	/**
	 * @generated
	 */
	private IParser getVulnerabilityName_4001Parser() {
		if (vulnerabilityName_4001Parser == null) {
			vulnerabilityName_4001Parser = createVulnerabilityName_4001Parser();
		}
		return vulnerabilityName_4001Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createVulnerabilityName_4001Parser() {
		EAttribute[] features = new EAttribute[] { SeaMonster.SeaMonsterPackage.eINSTANCE
				.getVulnerability_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser activityNodeName_4004Parser;

	/**
	 * @generated
	 */
	private IParser getActivityNodeName_4004Parser() {
		if (activityNodeName_4004Parser == null) {
			activityNodeName_4004Parser = createActivityNodeName_4004Parser();
		}
		return activityNodeName_4004Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createActivityNodeName_4004Parser() {
		EAttribute[] features = new EAttribute[] { SeaMonster.SeaMonsterPackage.eINSTANCE
				.getSAGNode_Name(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	protected IParser getParser(int visualID) {
		switch (visualID) {
		case WrapLabelEditPart.VISUAL_ID:
			return getVulnerabilityName_4001Parser();
		case WrapLabel4EditPart.VISUAL_ID:
			return getActivityNodeName_4004Parser();
		}
		return null;
	}

	/**
	 * @generated
	 */
	public IParser getParser(IAdaptable hint) {
		String vid = (String) hint.getAdapter(String.class);
		if (vid != null) {
			return getParser(SeaMonsterVisualIDRegistry.getVisualID(vid));
		}
		View view = (View) hint.getAdapter(View.class);
		if (view != null) {
			return getParser(SeaMonsterVisualIDRegistry.getVisualID(view));
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean provides(IOperation operation) {
		if (operation instanceof GetParserOperation) {
			IAdaptable hint = ((GetParserOperation) operation).getHint();
			if (SeaMonsterElementTypes.getElement(hint) == null) {
				return false;
			}
			return getParser(hint) != null;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static class HintAdapter extends ParserHintAdapter {

		/**
		 * @generated
		 */
		private final IElementType elementType;

		/**
		 * @generated
		 */
		public HintAdapter(IElementType type, EObject object, String parserHint) {
			super(object, parserHint);
			assert type != null;
			elementType = type;
		}

		/**
		 * @generated
		 */
		public Object getAdapter(Class adapter) {
			if (IElementType.class.equals(adapter)) {
				return elementType;
			}
			return super.getAdapter(adapter);
		}
	}

}
