package sag.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.diagram.core.providers.AbstractViewProvider;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.type.core.IHintedType;
import org.eclipse.gmf.runtime.notation.View;

import sag.diagram.edit.parts.ActivityNodeEditPart;
import sag.diagram.edit.parts.OrNodeEditPart;
import sag.diagram.edit.parts.SAGEditPart;
import sag.diagram.edit.parts.SAGNodePreActivityEditPart;
import sag.diagram.edit.parts.SagAndNodeEditPart;
import sag.diagram.edit.parts.SplitNodeEditPart;
import sag.diagram.edit.parts.VulnerabilityEditPart;
import sag.diagram.edit.parts.VulnerabilityRootActivityEditPart;
import sag.diagram.edit.parts.WrapLabel2EditPart;
import sag.diagram.edit.parts.WrapLabel3EditPart;
import sag.diagram.edit.parts.WrapLabel4EditPart;
import sag.diagram.edit.parts.WrapLabel5EditPart;
import sag.diagram.edit.parts.WrapLabelEditPart;
import sag.diagram.part.SeaMonsterVisualIDRegistry;
import sag.diagram.view.factories.ActivityNodeViewFactory;
import sag.diagram.view.factories.OrNodeViewFactory;
import sag.diagram.view.factories.SAGNodePreActivityViewFactory;
import sag.diagram.view.factories.SAGViewFactory;
import sag.diagram.view.factories.SagAndNodeViewFactory;
import sag.diagram.view.factories.SplitNodeViewFactory;
import sag.diagram.view.factories.VulnerabilityRootActivityViewFactory;
import sag.diagram.view.factories.VulnerabilityViewFactory;
import sag.diagram.view.factories.WrapLabel2ViewFactory;
import sag.diagram.view.factories.WrapLabel3ViewFactory;
import sag.diagram.view.factories.WrapLabel4ViewFactory;
import sag.diagram.view.factories.WrapLabel5ViewFactory;
import sag.diagram.view.factories.WrapLabelViewFactory;

/**
 * @generated
 */
public class SeaMonsterViewProvider extends AbstractViewProvider {

	/**
	 * @generated
	 */
	protected Class getDiagramViewClass(IAdaptable semanticAdapter,
			String diagramKind) {
		EObject semanticElement = getSemanticElement(semanticAdapter);
		if (SAGEditPart.MODEL_ID.equals(diagramKind)
				&& SeaMonsterVisualIDRegistry
						.getDiagramVisualID(semanticElement) != -1) {
			return SAGViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getNodeViewClass(IAdaptable semanticAdapter,
			View containerView, String semanticHint) {
		if (containerView == null) {
			return null;
		}
		IElementType elementType = getSemanticElementType(semanticAdapter);
		EObject domainElement = getSemanticElement(semanticAdapter);
		int visualID;
		if (semanticHint == null) {
			// Semantic hint is not specified. Can be a result of call from CanonicalEditPolicy.
			// In this situation there should be NO elementType, visualID will be determined
			// by VisualIDRegistry.getNodeVisualID() for domainElement.
			if (elementType != null || domainElement == null) {
				return null;
			}
			visualID = SeaMonsterVisualIDRegistry.getNodeVisualID(
					containerView, domainElement);
		} else {
			visualID = SeaMonsterVisualIDRegistry.getVisualID(semanticHint);
			if (elementType != null) {
				// Semantic hint is specified together with element type.
				// Both parameters should describe exactly the same diagram element.
				// In addition we check that visualID returned by VisualIDRegistry.getNodeVisualID() for
				// domainElement (if specified) is the same as in element type.
				if (!SeaMonsterElementTypes.isKnownElementType(elementType)
						|| (!(elementType instanceof IHintedType))) {
					return null; // foreign element type
				}
				String elementTypeHint = ((IHintedType) elementType)
						.getSemanticHint();
				if (!semanticHint.equals(elementTypeHint)) {
					return null; // if semantic hint is specified it should be the same as in element type
				}
				if (domainElement != null
						&& visualID != SeaMonsterVisualIDRegistry
								.getNodeVisualID(containerView, domainElement)) {
					return null; // visual id for node EClass should match visual id from element type
				}
			} else {
				// Element type is not specified. Domain element should be present (except pure design elements).
				// This method is called with EObjectAdapter as parameter from:
				//   - ViewService.createNode(View container, EObject eObject, String type, PreferencesHint preferencesHint) 
				//   - generated ViewFactory.decorateView() for parent element
				if (!SAGEditPart.MODEL_ID.equals(SeaMonsterVisualIDRegistry
						.getModelID(containerView))) {
					return null; // foreign diagram
				}
				switch (visualID) {
				case VulnerabilityEditPart.VISUAL_ID:
				case OrNodeEditPart.VISUAL_ID:
				case SagAndNodeEditPart.VISUAL_ID:
				case ActivityNodeEditPart.VISUAL_ID:
				case SplitNodeEditPart.VISUAL_ID:
					if (domainElement == null
							|| visualID != SeaMonsterVisualIDRegistry
									.getNodeVisualID(containerView,
											domainElement)) {
						return null; // visual id in semantic hint should match visual id for domain element
					}
					break;
				case WrapLabelEditPart.VISUAL_ID:
					if (VulnerabilityEditPart.VISUAL_ID != SeaMonsterVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case WrapLabel2EditPart.VISUAL_ID:
					if (OrNodeEditPart.VISUAL_ID != SeaMonsterVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case WrapLabel3EditPart.VISUAL_ID:
					if (SagAndNodeEditPart.VISUAL_ID != SeaMonsterVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case WrapLabel4EditPart.VISUAL_ID:
					if (ActivityNodeEditPart.VISUAL_ID != SeaMonsterVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case WrapLabel5EditPart.VISUAL_ID:
					if (SplitNodeEditPart.VISUAL_ID != SeaMonsterVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				default:
					return null;
				}
			}
		}
		return getNodeViewClass(containerView, visualID);
	}

	/**
	 * @generated
	 */
	protected Class getNodeViewClass(View containerView, int visualID) {
		if (containerView == null
				|| !SeaMonsterVisualIDRegistry.canCreateNode(containerView,
						visualID)) {
			return null;
		}
		switch (visualID) {
		case VulnerabilityEditPart.VISUAL_ID:
			return VulnerabilityViewFactory.class;
		case WrapLabelEditPart.VISUAL_ID:
			return WrapLabelViewFactory.class;
		case OrNodeEditPart.VISUAL_ID:
			return OrNodeViewFactory.class;
		case WrapLabel2EditPart.VISUAL_ID:
			return WrapLabel2ViewFactory.class;
		case SagAndNodeEditPart.VISUAL_ID:
			return SagAndNodeViewFactory.class;
		case WrapLabel3EditPart.VISUAL_ID:
			return WrapLabel3ViewFactory.class;
		case ActivityNodeEditPart.VISUAL_ID:
			return ActivityNodeViewFactory.class;
		case WrapLabel4EditPart.VISUAL_ID:
			return WrapLabel4ViewFactory.class;
		case SplitNodeEditPart.VISUAL_ID:
			return SplitNodeViewFactory.class;
		case WrapLabel5EditPart.VISUAL_ID:
			return WrapLabel5ViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getEdgeViewClass(IAdaptable semanticAdapter,
			View containerView, String semanticHint) {
		IElementType elementType = getSemanticElementType(semanticAdapter);
		if (!SeaMonsterElementTypes.isKnownElementType(elementType)
				|| (!(elementType instanceof IHintedType))) {
			return null; // foreign element type
		}
		String elementTypeHint = ((IHintedType) elementType).getSemanticHint();
		if (elementTypeHint == null) {
			return null; // our hint is visual id and must be specified
		}
		if (semanticHint != null && !semanticHint.equals(elementTypeHint)) {
			return null; // if semantic hint is specified it should be the same as in element type
		}
		int visualID = SeaMonsterVisualIDRegistry.getVisualID(elementTypeHint);
		EObject domainElement = getSemanticElement(semanticAdapter);
		if (domainElement != null
				&& visualID != SeaMonsterVisualIDRegistry
						.getLinkWithClassVisualID(domainElement)) {
			return null; // visual id for link EClass should match visual id from element type
		}
		return getEdgeViewClass(visualID);
	}

	/**
	 * @generated
	 */
	protected Class getEdgeViewClass(int visualID) {
		switch (visualID) {
		case VulnerabilityRootActivityEditPart.VISUAL_ID:
			return VulnerabilityRootActivityViewFactory.class;
		case SAGNodePreActivityEditPart.VISUAL_ID:
			return SAGNodePreActivityViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	private IElementType getSemanticElementType(IAdaptable semanticAdapter) {
		if (semanticAdapter == null) {
			return null;
		}
		return (IElementType) semanticAdapter.getAdapter(IElementType.class);
	}
}
