package secmod.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

import secmod.diagram.edit.policies.SeaMonsterBaseItemSemanticEditPolicy;

/**
 * @generated
 */
public class SubDiagramRelationReorientCommand extends EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject referenceOwner;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public SubDiagramRelationReorientCommand(
			ReorientReferenceRelationshipRequest request) {
		super(request.getLabel(), null, request);
		reorientDirection = request.getDirection();
		referenceOwner = request.getReferenceOwner();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (!(referenceOwner instanceof SeaMonster.SubDiagram)) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof SeaMonster.SubDiagram && newEnd instanceof SeaMonster.SubDiagram)) {
			return false;
		}
		return SeaMonsterBaseItemSemanticEditPolicy.LinkConstraints
				.canExistSubDiagramRelation_3001(getNewSource(), getOldTarget());
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof SeaMonster.SubDiagram && newEnd instanceof SeaMonster.SubDiagram)) {
			return false;
		}
		return SeaMonsterBaseItemSemanticEditPolicy.LinkConstraints
				.canExistSubDiagramRelation_3001(getOldSource(), getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getOldSource().getRelation().remove(getOldTarget());
		getNewSource().getRelation().add(getOldTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getOldSource().getRelation().remove(getOldTarget());
		getOldSource().getRelation().add(getNewTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected SeaMonster.SubDiagram getOldSource() {
		return (SeaMonster.SubDiagram) referenceOwner;
	}

	/**
	 * @generated
	 */
	protected SeaMonster.SubDiagram getNewSource() {
		return (SeaMonster.SubDiagram) newEnd;
	}

	/**
	 * @generated
	 */
	protected SeaMonster.SubDiagram getOldTarget() {
		return (SeaMonster.SubDiagram) oldEnd;
	}

	/**
	 * @generated
	 */
	protected SeaMonster.SubDiagram getNewTarget() {
		return (SeaMonster.SubDiagram) newEnd;
	}
}
