package secmod.diagram.edit.policies;

import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.commands.core.commands.DuplicateEObjectsCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DuplicateElementsRequest;

import secmod.diagram.edit.commands.AttackTreeCreateCommand;
import secmod.diagram.edit.commands.MisuseCaseCreateCommand;
import secmod.diagram.edit.commands.SAGCreateCommand;
import secmod.diagram.edit.commands.VCGCreateCommand;
import secmod.diagram.providers.SeaMonsterElementTypes;

/**
 * @generated
 */
public class SecurityModelItemSemanticEditPolicy extends
		SeaMonsterBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		if (SeaMonsterElementTypes.MisuseCase_1001 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getSecurityModel_Contains());
			}
			return getGEFWrapper(new MisuseCaseCreateCommand(req));
		}
		if (SeaMonsterElementTypes.AttackTree_1002 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getSecurityModel_Contains());
			}
			return getGEFWrapper(new AttackTreeCreateCommand(req));
		}
		if (SeaMonsterElementTypes.VCG_1003 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getSecurityModel_Contains());
			}
			return getGEFWrapper(new VCGCreateCommand(req));
		}
		if (SeaMonsterElementTypes.SAG_1004 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getSecurityModel_Contains());
			}
			return getGEFWrapper(new SAGCreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getDuplicateCommand(DuplicateElementsRequest req) {
		TransactionalEditingDomain editingDomain = ((IGraphicalEditPart) getHost())
				.getEditingDomain();
		return getGEFWrapper(new DuplicateAnythingCommand(editingDomain, req));
	}

	/**
	 * @generated
	 */
	private static class DuplicateAnythingCommand extends
			DuplicateEObjectsCommand {

		/**
		 * @generated
		 */
		public DuplicateAnythingCommand(
				TransactionalEditingDomain editingDomain,
				DuplicateElementsRequest req) {
			super(editingDomain, req.getLabel(), req
					.getElementsToBeDuplicated(), req
					.getAllDuplicatedElementsMap());
		}

	}

}
