package secmod.diagram.part;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;

import secmod.diagram.edit.parts.SecurityModelEditPart;

/**
 * @generated
 */
public class SeaMonsterCreateShortcutAction implements IObjectActionDelegate {

	/**
	 * @generated
	 */
	private SecurityModelEditPart mySelectedElement;

	/**
	 * @generated
	 */
	private Shell myShell;

	/**
	 * @generated
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
		myShell = targetPart.getSite().getShell();
	}

	/**
	 * @generated
	 */
	public void selectionChanged(IAction action, ISelection selection) {
		mySelectedElement = null;
		if (selection instanceof IStructuredSelection) {
			IStructuredSelection structuredSelection = (IStructuredSelection) selection;
			if (structuredSelection.size() == 1
					&& structuredSelection.getFirstElement() instanceof SecurityModelEditPart) {
				mySelectedElement = (SecurityModelEditPart) structuredSelection
						.getFirstElement();
			}
		}
		action.setEnabled(isEnabled());
	}

	/**
	 * @generated
	 */
	private boolean isEnabled() {
		return mySelectedElement != null;
	}

	/**
	 * @generated
	 */
	public void run(IAction action) {
		final View view = (View) mySelectedElement.getModel();
		Resource resource = SeaMonsterDiagramEditorUtil.openModel(myShell,
				Messages.SeaMonsterCreateShortcutAction_OpenModelTitle,
				mySelectedElement.getEditingDomain());
		if (resource == null || resource.getContents().isEmpty()) {
			return;
		}
		ShortcutCreationWizard wizard = new ShortcutCreationWizard(
				(EObject) resource.getContents().get(0), view,
				mySelectedElement.getEditingDomain());
		wizard
				.setWindowTitle(Messages.SeaMonsterCreateShortcutAction_CreateShortcutTitle);
		SeaMonsterDiagramEditorUtil
				.runWizard(myShell, wizard, "CreateShortcut"); //$NON-NLS-1$
	}

}
