package secmod.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;

import secmod.diagram.edit.parts.AttackTreeEditPart;
import secmod.diagram.edit.parts.MisuseCaseEditPart;
import secmod.diagram.edit.parts.SAGEditPart;
import secmod.diagram.edit.parts.SecurityModelEditPart;
import secmod.diagram.edit.parts.SubDiagramRelationEditPart;
import secmod.diagram.edit.parts.VCGEditPart;
import secmod.diagram.providers.SeaMonsterElementTypes;

/**
 * @generated
 */
public class SeaMonsterDiagramUpdater {

	/**
	 * @generated
	 */
	public static List getSemanticChildren(View view) {
		switch (SeaMonsterVisualIDRegistry.getVisualID(view)) {
		case SecurityModelEditPart.VISUAL_ID:
			return getSecurityModel_79SemanticChildren(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getSecurityModel_79SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		SeaMonster.SecurityModel modelElement = (SeaMonster.SecurityModel) view
				.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getContains().iterator(); it.hasNext();) {
			SeaMonster.SubDiagram childElement = (SeaMonster.SubDiagram) it
					.next();
			int visualID = SeaMonsterVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == MisuseCaseEditPart.VISUAL_ID) {
				result
						.add(new SeaMonsterNodeDescriptor(childElement,
								visualID));
				continue;
			}
			if (visualID == AttackTreeEditPart.VISUAL_ID) {
				result
						.add(new SeaMonsterNodeDescriptor(childElement,
								visualID));
				continue;
			}
			if (visualID == VCGEditPart.VISUAL_ID) {
				result
						.add(new SeaMonsterNodeDescriptor(childElement,
								visualID));
				continue;
			}
			if (visualID == SAGEditPart.VISUAL_ID) {
				result
						.add(new SeaMonsterNodeDescriptor(childElement,
								visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getContainedLinks(View view) {
		switch (SeaMonsterVisualIDRegistry.getVisualID(view)) {
		case SecurityModelEditPart.VISUAL_ID:
			return getSecurityModel_79ContainedLinks(view);
		case MisuseCaseEditPart.VISUAL_ID:
			return getMisuseCase_1001ContainedLinks(view);
		case AttackTreeEditPart.VISUAL_ID:
			return getAttackTree_1002ContainedLinks(view);
		case VCGEditPart.VISUAL_ID:
			return getVCG_1003ContainedLinks(view);
		case SAGEditPart.VISUAL_ID:
			return getSAG_1004ContainedLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getIncomingLinks(View view) {
		switch (SeaMonsterVisualIDRegistry.getVisualID(view)) {
		case MisuseCaseEditPart.VISUAL_ID:
			return getMisuseCase_1001IncomingLinks(view);
		case AttackTreeEditPart.VISUAL_ID:
			return getAttackTree_1002IncomingLinks(view);
		case VCGEditPart.VISUAL_ID:
			return getVCG_1003IncomingLinks(view);
		case SAGEditPart.VISUAL_ID:
			return getSAG_1004IncomingLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOutgoingLinks(View view) {
		switch (SeaMonsterVisualIDRegistry.getVisualID(view)) {
		case MisuseCaseEditPart.VISUAL_ID:
			return getMisuseCase_1001OutgoingLinks(view);
		case AttackTreeEditPart.VISUAL_ID:
			return getAttackTree_1002OutgoingLinks(view);
		case VCGEditPart.VISUAL_ID:
			return getVCG_1003OutgoingLinks(view);
		case SAGEditPart.VISUAL_ID:
			return getSAG_1004OutgoingLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getSecurityModel_79ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getMisuseCase_1001ContainedLinks(View view) {
		SeaMonster.MisuseCase modelElement = (SeaMonster.MisuseCase) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_SubDiagram_Relation_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAttackTree_1002ContainedLinks(View view) {
		SeaMonster.AttackTree modelElement = (SeaMonster.AttackTree) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_SubDiagram_Relation_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getVCG_1003ContainedLinks(View view) {
		SeaMonster.VCG modelElement = (SeaMonster.VCG) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_SubDiagram_Relation_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getSAG_1004ContainedLinks(View view) {
		SeaMonster.SAG modelElement = (SeaMonster.SAG) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_SubDiagram_Relation_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getMisuseCase_1001IncomingLinks(View view) {
		SeaMonster.MisuseCase modelElement = (SeaMonster.MisuseCase) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_SubDiagram_Relation_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAttackTree_1002IncomingLinks(View view) {
		SeaMonster.AttackTree modelElement = (SeaMonster.AttackTree) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_SubDiagram_Relation_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getVCG_1003IncomingLinks(View view) {
		SeaMonster.VCG modelElement = (SeaMonster.VCG) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_SubDiagram_Relation_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getSAG_1004IncomingLinks(View view) {
		SeaMonster.SAG modelElement = (SeaMonster.SAG) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_SubDiagram_Relation_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getMisuseCase_1001OutgoingLinks(View view) {
		SeaMonster.MisuseCase modelElement = (SeaMonster.MisuseCase) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_SubDiagram_Relation_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAttackTree_1002OutgoingLinks(View view) {
		SeaMonster.AttackTree modelElement = (SeaMonster.AttackTree) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_SubDiagram_Relation_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getVCG_1003OutgoingLinks(View view) {
		SeaMonster.VCG modelElement = (SeaMonster.VCG) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_SubDiagram_Relation_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getSAG_1004OutgoingLinks(View view) {
		SeaMonster.SAG modelElement = (SeaMonster.SAG) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_SubDiagram_Relation_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingFeatureModelFacetLinks_SubDiagram_Relation_3001(
			SeaMonster.SubDiagram target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() == SeaMonster.SeaMonsterPackage.eINSTANCE
					.getSubDiagram_Relation()) {
				result.add(new SeaMonsterLinkDescriptor(setting.getEObject(),
						target, SeaMonsterElementTypes.SubDiagramRelation_3001,
						SubDiagramRelationEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_SubDiagram_Relation_3001(
			SeaMonster.SubDiagram source) {
		Collection result = new LinkedList();
		for (Iterator destinations = source.getRelation().iterator(); destinations
				.hasNext();) {
			SeaMonster.SubDiagram destination = (SeaMonster.SubDiagram) destinations
					.next();
			result.add(new SeaMonsterLinkDescriptor(source, destination,
					SeaMonsterElementTypes.SubDiagramRelation_3001,
					SubDiagramRelationEditPart.VISUAL_ID));
		}
		return result;
	}

}
