package secmod.diagram.part;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteGroup;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeConnectionTool;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeCreationTool;

import secmod.diagram.providers.SeaMonsterElementTypes;

/**
 * @generated
 */
public class SeaMonsterPaletteFactory {

	/**
	 * @generated
	 */
	public void fillPalette(PaletteRoot paletteRoot) {
		paletteRoot.add(createSeaMonster1Group());
	}

	/**
	 * Creates "SeaMonster" palette tool group
	 * @generated
	 */
	private PaletteContainer createSeaMonster1Group() {
		PaletteGroup paletteContainer = new PaletteGroup(
				Messages.SeaMonster1Group_title);
		paletteContainer.add(createAttackTree1CreationTool());
		paletteContainer.add(createRelation2CreationTool());
		paletteContainer.add(createVCG3CreationTool());
		paletteContainer.add(createMisuseCase4CreationTool());
		paletteContainer.add(createSAG5CreationTool());
		return paletteContainer;
	}

	/**
	 * @generated
	 */
	private ToolEntry createAttackTree1CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.AttackTree_1002);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.AttackTree1CreationTool_title,
				Messages.AttackTree1CreationTool_desc, types);
		entry.setSmallIcon(SeaMonsterElementTypes
				.getImageDescriptor(SeaMonsterElementTypes.AttackTree_1002));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createRelation2CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.SubDiagramRelation_3001);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Relation2CreationTool_title,
				Messages.Relation2CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterElementTypes
						.getImageDescriptor(SeaMonsterElementTypes.SubDiagramRelation_3001));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createVCG3CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.VCG_1003);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.VCG3CreationTool_title,
				Messages.VCG3CreationTool_desc, types);
		entry.setSmallIcon(SeaMonsterElementTypes
				.getImageDescriptor(SeaMonsterElementTypes.VCG_1003));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createMisuseCase4CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.MisuseCase_1001);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.MisuseCase4CreationTool_title,
				Messages.MisuseCase4CreationTool_desc, types);
		entry.setSmallIcon(SeaMonsterElementTypes
				.getImageDescriptor(SeaMonsterElementTypes.MisuseCase_1001));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createSAG5CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.SAG_1004);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.SAG5CreationTool_title,
				Messages.SAG5CreationTool_desc, types);
		entry.setSmallIcon(SeaMonsterElementTypes
				.getImageDescriptor(SeaMonsterElementTypes.SAG_1004));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private static class NodeToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List elementTypes;

		/**
		 * @generated
		 */
		private NodeToolEntry(String title, String description,
				List elementTypes) {
			super(title, description, null, null);
			this.elementTypes = elementTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeCreationTool(elementTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}

	/**
	 * @generated
	 */
	private static class LinkToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List relationshipTypes;

		/**
		 * @generated
		 */
		private LinkToolEntry(String title, String description,
				List relationshipTypes) {
			super(title, description, null, null);
			this.relationshipTypes = relationshipTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeConnectionTool(relationshipTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}
}
