package secmod.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

import secmod.diagram.edit.parts.AttackTreeEditPart;
import secmod.diagram.edit.parts.AttackTreeTitleEditPart;
import secmod.diagram.edit.parts.MisuseCaseEditPart;
import secmod.diagram.edit.parts.MisuseCaseTitleEditPart;
import secmod.diagram.edit.parts.SAGEditPart;
import secmod.diagram.edit.parts.SAGTitleEditPart;
import secmod.diagram.edit.parts.SecurityModelEditPart;
import secmod.diagram.edit.parts.VCGEditPart;
import secmod.diagram.edit.parts.VCGTitleEditPart;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class SeaMonsterVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = SeaMonsterDiagramEditorPlugin
			.getInstance().getBundle().getSymbolicName()
			+ "/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (SecurityModelEditPart.MODEL_ID.equals(view.getType())) {
				return SecurityModelEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return secmod.diagram.part.SeaMonsterVisualIDRegistry.getVisualID(view
				.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				SeaMonsterDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return String.valueOf(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (SeaMonster.SeaMonsterPackage.eINSTANCE.getSecurityModel()
				.isSuperTypeOf(domainElement.eClass())
				&& isDiagram((SeaMonster.SecurityModel) domainElement)) {
			return SecurityModelEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = secmod.diagram.part.SeaMonsterVisualIDRegistry
				.getModelID(containerView);
		if (!SecurityModelEditPart.MODEL_ID.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (SecurityModelEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = secmod.diagram.part.SeaMonsterVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = SecurityModelEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case SecurityModelEditPart.VISUAL_ID:
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getMisuseCase()
					.isSuperTypeOf(domainElement.eClass())) {
				return MisuseCaseEditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getAttackTree()
					.isSuperTypeOf(domainElement.eClass())) {
				return AttackTreeEditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getVCG().isSuperTypeOf(
					domainElement.eClass())) {
				return VCGEditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getSAG().isSuperTypeOf(
					domainElement.eClass())) {
				return SAGEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = secmod.diagram.part.SeaMonsterVisualIDRegistry
				.getModelID(containerView);
		if (!SecurityModelEditPart.MODEL_ID.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (SecurityModelEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = secmod.diagram.part.SeaMonsterVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = SecurityModelEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case MisuseCaseEditPart.VISUAL_ID:
			if (MisuseCaseTitleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case AttackTreeEditPart.VISUAL_ID:
			if (AttackTreeTitleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case VCGEditPart.VISUAL_ID:
			if (VCGTitleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SAGEditPart.VISUAL_ID:
			if (SAGTitleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SecurityModelEditPart.VISUAL_ID:
			if (MisuseCaseEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (AttackTreeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (VCGEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SAGEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(SeaMonster.SecurityModel element) {
		return true;
	}

}
