package secmod.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.service.AbstractProvider;
import org.eclipse.gmf.runtime.common.core.service.IOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.GetParserOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParserProvider;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.parser.ParserHintAdapter;
import org.eclipse.gmf.runtime.notation.View;

import secmod.diagram.edit.parts.AttackTreeTitleEditPart;
import secmod.diagram.edit.parts.MisuseCaseTitleEditPart;
import secmod.diagram.edit.parts.SAGTitleEditPart;
import secmod.diagram.edit.parts.VCGTitleEditPart;
import secmod.diagram.parsers.MessageFormatParser;
import secmod.diagram.part.SeaMonsterVisualIDRegistry;

/**
 * @generated
 */
public class SeaMonsterParserProvider extends AbstractProvider implements
		IParserProvider {

	/**
	 * @generated
	 */
	private IParser misuseCaseTitle_4001Parser;

	/**
	 * @generated
	 */
	private IParser getMisuseCaseTitle_4001Parser() {
		if (misuseCaseTitle_4001Parser == null) {
			misuseCaseTitle_4001Parser = createMisuseCaseTitle_4001Parser();
		}
		return misuseCaseTitle_4001Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createMisuseCaseTitle_4001Parser() {
		EAttribute[] features = new EAttribute[] { SeaMonster.SeaMonsterPackage.eINSTANCE
				.getSubDiagram_Title(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser attackTreeTitle_4002Parser;

	/**
	 * @generated
	 */
	private IParser getAttackTreeTitle_4002Parser() {
		if (attackTreeTitle_4002Parser == null) {
			attackTreeTitle_4002Parser = createAttackTreeTitle_4002Parser();
		}
		return attackTreeTitle_4002Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createAttackTreeTitle_4002Parser() {
		EAttribute[] features = new EAttribute[] { SeaMonster.SeaMonsterPackage.eINSTANCE
				.getSubDiagram_Title(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser vCGTitle_4003Parser;

	/**
	 * @generated
	 */
	private IParser getVCGTitle_4003Parser() {
		if (vCGTitle_4003Parser == null) {
			vCGTitle_4003Parser = createVCGTitle_4003Parser();
		}
		return vCGTitle_4003Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createVCGTitle_4003Parser() {
		EAttribute[] features = new EAttribute[] { SeaMonster.SeaMonsterPackage.eINSTANCE
				.getSubDiagram_Title(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	private IParser sAGTitle_4004Parser;

	/**
	 * @generated
	 */
	private IParser getSAGTitle_4004Parser() {
		if (sAGTitle_4004Parser == null) {
			sAGTitle_4004Parser = createSAGTitle_4004Parser();
		}
		return sAGTitle_4004Parser;
	}

	/**
	 * @generated
	 */
	protected IParser createSAGTitle_4004Parser() {
		EAttribute[] features = new EAttribute[] { SeaMonster.SeaMonsterPackage.eINSTANCE
				.getSubDiagram_Title(), };
		MessageFormatParser parser = new MessageFormatParser(features);
		return parser;
	}

	/**
	 * @generated
	 */
	protected IParser getParser(int visualID) {
		switch (visualID) {
		case MisuseCaseTitleEditPart.VISUAL_ID:
			return getMisuseCaseTitle_4001Parser();
		case AttackTreeTitleEditPart.VISUAL_ID:
			return getAttackTreeTitle_4002Parser();
		case VCGTitleEditPart.VISUAL_ID:
			return getVCGTitle_4003Parser();
		case SAGTitleEditPart.VISUAL_ID:
			return getSAGTitle_4004Parser();
		}
		return null;
	}

	/**
	 * @generated
	 */
	public IParser getParser(IAdaptable hint) {
		String vid = (String) hint.getAdapter(String.class);
		if (vid != null) {
			return getParser(SeaMonsterVisualIDRegistry.getVisualID(vid));
		}
		View view = (View) hint.getAdapter(View.class);
		if (view != null) {
			return getParser(SeaMonsterVisualIDRegistry.getVisualID(view));
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean provides(IOperation operation) {
		if (operation instanceof GetParserOperation) {
			IAdaptable hint = ((GetParserOperation) operation).getHint();
			if (SeaMonsterElementTypes.getElement(hint) == null) {
				return false;
			}
			return getParser(hint) != null;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static class HintAdapter extends ParserHintAdapter {

		/**
		 * @generated
		 */
		private final IElementType elementType;

		/**
		 * @generated
		 */
		public HintAdapter(IElementType type, EObject object, String parserHint) {
			super(object, parserHint);
			assert type != null;
			elementType = type;
		}

		/**
		 * @generated
		 */
		public Object getAdapter(Class adapter) {
			if (IElementType.class.equals(adapter)) {
				return elementType;
			}
			return super.getAdapter(adapter);
		}
	}

}
