package secmod.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.diagram.core.providers.AbstractViewProvider;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.type.core.IHintedType;
import org.eclipse.gmf.runtime.notation.View;

import secmod.diagram.edit.parts.AttackTreeEditPart;
import secmod.diagram.edit.parts.AttackTreeTitleEditPart;
import secmod.diagram.edit.parts.MisuseCaseEditPart;
import secmod.diagram.edit.parts.MisuseCaseTitleEditPart;
import secmod.diagram.edit.parts.SAGEditPart;
import secmod.diagram.edit.parts.SAGTitleEditPart;
import secmod.diagram.edit.parts.SecurityModelEditPart;
import secmod.diagram.edit.parts.SubDiagramRelationEditPart;
import secmod.diagram.edit.parts.VCGEditPart;
import secmod.diagram.edit.parts.VCGTitleEditPart;
import secmod.diagram.part.SeaMonsterVisualIDRegistry;
import secmod.diagram.view.factories.AttackTreeTitleViewFactory;
import secmod.diagram.view.factories.AttackTreeViewFactory;
import secmod.diagram.view.factories.MisuseCaseTitleViewFactory;
import secmod.diagram.view.factories.MisuseCaseViewFactory;
import secmod.diagram.view.factories.SAGTitleViewFactory;
import secmod.diagram.view.factories.SAGViewFactory;
import secmod.diagram.view.factories.SecurityModelViewFactory;
import secmod.diagram.view.factories.SubDiagramRelationViewFactory;
import secmod.diagram.view.factories.VCGTitleViewFactory;
import secmod.diagram.view.factories.VCGViewFactory;

/**
 * @generated
 */
public class SeaMonsterViewProvider extends AbstractViewProvider {

	/**
	 * @generated
	 */
	protected Class getDiagramViewClass(IAdaptable semanticAdapter,
			String diagramKind) {
		EObject semanticElement = getSemanticElement(semanticAdapter);
		if (SecurityModelEditPart.MODEL_ID.equals(diagramKind)
				&& SeaMonsterVisualIDRegistry
						.getDiagramVisualID(semanticElement) != -1) {
			return SecurityModelViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getNodeViewClass(IAdaptable semanticAdapter,
			View containerView, String semanticHint) {
		if (containerView == null) {
			return null;
		}
		IElementType elementType = getSemanticElementType(semanticAdapter);
		EObject domainElement = getSemanticElement(semanticAdapter);
		int visualID;
		if (semanticHint == null) {
			// Semantic hint is not specified. Can be a result of call from CanonicalEditPolicy.
			// In this situation there should be NO elementType, visualID will be determined
			// by VisualIDRegistry.getNodeVisualID() for domainElement.
			if (elementType != null || domainElement == null) {
				return null;
			}
			visualID = SeaMonsterVisualIDRegistry.getNodeVisualID(
					containerView, domainElement);
		} else {
			visualID = SeaMonsterVisualIDRegistry.getVisualID(semanticHint);
			if (elementType != null) {
				// Semantic hint is specified together with element type.
				// Both parameters should describe exactly the same diagram element.
				// In addition we check that visualID returned by VisualIDRegistry.getNodeVisualID() for
				// domainElement (if specified) is the same as in element type.
				if (!SeaMonsterElementTypes.isKnownElementType(elementType)
						|| (!(elementType instanceof IHintedType))) {
					return null; // foreign element type
				}
				String elementTypeHint = ((IHintedType) elementType)
						.getSemanticHint();
				if (!semanticHint.equals(elementTypeHint)) {
					return null; // if semantic hint is specified it should be the same as in element type
				}
				if (domainElement != null
						&& visualID != SeaMonsterVisualIDRegistry
								.getNodeVisualID(containerView, domainElement)) {
					return null; // visual id for node EClass should match visual id from element type
				}
			} else {
				// Element type is not specified. Domain element should be present (except pure design elements).
				// This method is called with EObjectAdapter as parameter from:
				//   - ViewService.createNode(View container, EObject eObject, String type, PreferencesHint preferencesHint) 
				//   - generated ViewFactory.decorateView() for parent element
				if (!SecurityModelEditPart.MODEL_ID
						.equals(SeaMonsterVisualIDRegistry
								.getModelID(containerView))) {
					return null; // foreign diagram
				}
				switch (visualID) {
				case MisuseCaseEditPart.VISUAL_ID:
				case AttackTreeEditPart.VISUAL_ID:
				case VCGEditPart.VISUAL_ID:
				case SAGEditPart.VISUAL_ID:
					if (domainElement == null
							|| visualID != SeaMonsterVisualIDRegistry
									.getNodeVisualID(containerView,
											domainElement)) {
						return null; // visual id in semantic hint should match visual id for domain element
					}
					break;
				case MisuseCaseTitleEditPart.VISUAL_ID:
					if (MisuseCaseEditPart.VISUAL_ID != SeaMonsterVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case AttackTreeTitleEditPart.VISUAL_ID:
					if (AttackTreeEditPart.VISUAL_ID != SeaMonsterVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case VCGTitleEditPart.VISUAL_ID:
					if (VCGEditPart.VISUAL_ID != SeaMonsterVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case SAGTitleEditPart.VISUAL_ID:
					if (SAGEditPart.VISUAL_ID != SeaMonsterVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				default:
					return null;
				}
			}
		}
		return getNodeViewClass(containerView, visualID);
	}

	/**
	 * @generated
	 */
	protected Class getNodeViewClass(View containerView, int visualID) {
		if (containerView == null
				|| !SeaMonsterVisualIDRegistry.canCreateNode(containerView,
						visualID)) {
			return null;
		}
		switch (visualID) {
		case MisuseCaseEditPart.VISUAL_ID:
			return MisuseCaseViewFactory.class;
		case MisuseCaseTitleEditPart.VISUAL_ID:
			return MisuseCaseTitleViewFactory.class;
		case AttackTreeEditPart.VISUAL_ID:
			return AttackTreeViewFactory.class;
		case AttackTreeTitleEditPart.VISUAL_ID:
			return AttackTreeTitleViewFactory.class;
		case VCGEditPart.VISUAL_ID:
			return VCGViewFactory.class;
		case VCGTitleEditPart.VISUAL_ID:
			return VCGTitleViewFactory.class;
		case SAGEditPart.VISUAL_ID:
			return SAGViewFactory.class;
		case SAGTitleEditPart.VISUAL_ID:
			return SAGTitleViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getEdgeViewClass(IAdaptable semanticAdapter,
			View containerView, String semanticHint) {
		IElementType elementType = getSemanticElementType(semanticAdapter);
		if (!SeaMonsterElementTypes.isKnownElementType(elementType)
				|| (!(elementType instanceof IHintedType))) {
			return null; // foreign element type
		}
		String elementTypeHint = ((IHintedType) elementType).getSemanticHint();
		if (elementTypeHint == null) {
			return null; // our hint is visual id and must be specified
		}
		if (semanticHint != null && !semanticHint.equals(elementTypeHint)) {
			return null; // if semantic hint is specified it should be the same as in element type
		}
		int visualID = SeaMonsterVisualIDRegistry.getVisualID(elementTypeHint);
		EObject domainElement = getSemanticElement(semanticAdapter);
		if (domainElement != null
				&& visualID != SeaMonsterVisualIDRegistry
						.getLinkWithClassVisualID(domainElement)) {
			return null; // visual id for link EClass should match visual id from element type
		}
		return getEdgeViewClass(visualID);
	}

	/**
	 * @generated
	 */
	protected Class getEdgeViewClass(int visualID) {
		switch (visualID) {
		case SubDiagramRelationEditPart.VISUAL_ID:
			return SubDiagramRelationViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	private IElementType getSemanticElementType(IAdaptable semanticAdapter) {
		if (semanticAdapter == null) {
			return null;
		}
		return (IElementType) semanticAdapter.getAdapter(IElementType.class);
	}
}
