package vcg.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

import vcg.diagram.edit.policies.SeaMonsterBaseItemSemanticEditPolicy;

/**
 * @generated
 */
public class CauseNodeSuccessorReorientCommand extends EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject referenceOwner;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public CauseNodeSuccessorReorientCommand(
			ReorientReferenceRelationshipRequest request) {
		super(request.getLabel(), null, request);
		reorientDirection = request.getDirection();
		referenceOwner = request.getReferenceOwner();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (!(referenceOwner instanceof SeaMonster.CauseNode)) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof SeaMonster.Node && newEnd instanceof SeaMonster.CauseNode)) {
			return false;
		}
		return SeaMonsterBaseItemSemanticEditPolicy.LinkConstraints
				.canExistCauseNodeSuccessor_3001(getNewSource(), getOldTarget());
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof SeaMonster.Node && newEnd instanceof SeaMonster.Node)) {
			return false;
		}
		return SeaMonsterBaseItemSemanticEditPolicy.LinkConstraints
				.canExistCauseNodeSuccessor_3001(getOldSource(), getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getOldSource().getSuccessor().remove(getOldTarget());
		getNewSource().getSuccessor().add(getOldTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getOldSource().getSuccessor().remove(getOldTarget());
		getOldSource().getSuccessor().add(getNewTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected SeaMonster.CauseNode getOldSource() {
		return (SeaMonster.CauseNode) referenceOwner;
	}

	/**
	 * @generated
	 */
	protected SeaMonster.CauseNode getNewSource() {
		return (SeaMonster.CauseNode) newEnd;
	}

	/**
	 * @generated
	 */
	protected SeaMonster.Node getOldTarget() {
		return (SeaMonster.Node) oldEnd;
	}

	/**
	 * @generated
	 */
	protected SeaMonster.Node getNewTarget() {
		return (SeaMonster.Node) newEnd;
	}
}
