package vcg.diagram.edit.parts;

import org.eclipse.draw2d.FigureUtilities;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrapLabel;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Text;

import vcg.diagram.part.SeaMonsterVisualIDRegistry;

/**
 * @generated
 */
public class SeaMonsterEditPartFactory implements EditPartFactory {

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			switch (SeaMonsterVisualIDRegistry.getVisualID(view)) {

			case VCGEditPart.VISUAL_ID:
				return new VCGEditPart(view);

			case ExitNodeEditPart.VISUAL_ID:
				return new ExitNodeEditPart(view);

			case ExitNodeNameEditPart.VISUAL_ID:
				return new ExitNodeNameEditPart(view);

			case CompoundNodeEditPart.VISUAL_ID:
				return new CompoundNodeEditPart(view);

			case CompoundNodeNameEditPart.VISUAL_ID:
				return new CompoundNodeNameEditPart(view);

			case SimpleNodeEditPart.VISUAL_ID:
				return new SimpleNodeEditPart(view);

			case SimpleNodeNameEditPart.VISUAL_ID:
				return new SimpleNodeNameEditPart(view);

			case ConjunctionNodeEditPart.VISUAL_ID:
				return new ConjunctionNodeEditPart(view);

			case ConjunctionNodeNameEditPart.VISUAL_ID:
				return new ConjunctionNodeNameEditPart(view);

			case SimpleNode2EditPart.VISUAL_ID:
				return new SimpleNode2EditPart(view);

			case SimpleNodeName2EditPart.VISUAL_ID:
				return new SimpleNodeName2EditPart(view);

			case CompoundNode2EditPart.VISUAL_ID:
				return new CompoundNode2EditPart(view);

			case CompoundNodeName2EditPart.VISUAL_ID:
				return new CompoundNodeName2EditPart(view);

			case ConjunctionNodeConjunctionCompartmentEditPart.VISUAL_ID:
				return new ConjunctionNodeConjunctionCompartmentEditPart(view);

			case CauseNodeSuccessorEditPart.VISUAL_ID:
				return new CauseNodeSuccessorEditPart(view);
			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	 * @generated
	 */
	public static CellEditorLocator getTextCellEditorLocator(
			ITextAwareEditPart source) {
		if (source.getFigure() instanceof WrapLabel)
			return new TextCellEditorLocator((WrapLabel) source.getFigure());
		else {
			return new LabelCellEditorLocator((Label) source.getFigure());
		}
	}

	/**
	 * @generated
	 */
	static private class TextCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private WrapLabel wrapLabel;

		/**
		 * @generated
		 */
		public TextCellEditorLocator(WrapLabel wrapLabel) {
			this.wrapLabel = wrapLabel;
		}

		/**
		 * @generated
		 */
		public WrapLabel getWrapLabel() {
			return wrapLabel;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getWrapLabel().getTextBounds().getCopy();
			getWrapLabel().translateToAbsolute(rect);
			if (getWrapLabel().isTextWrapped()
					&& getWrapLabel().getText().length() > 0) {
				rect.setSize(new Dimension(text.computeSize(rect.width,
						SWT.DEFAULT)));
			} else {
				int avr = FigureUtilities.getFontMetrics(text.getFont())
						.getAverageCharWidth();
				rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
						SWT.DEFAULT)).expand(avr * 2, 0));
			}
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}

	}

	/**
	 * @generated
	 */
	private static class LabelCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private Label label;

		/**
		 * @generated
		 */
		public LabelCellEditorLocator(Label label) {
			this.label = label;
		}

		/**
		 * @generated
		 */
		public Label getLabel() {
			return label;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getLabel().getTextBounds().getCopy();
			getLabel().translateToAbsolute(rect);
			int avr = FigureUtilities.getFontMetrics(text.getFont())
					.getAverageCharWidth();
			rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
					SWT.DEFAULT)).expand(avr * 2, 0));
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}
	}
}
