package vcg.diagram.edit.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;

import vcg.diagram.edit.commands.CauseNodeSuccessorCreateCommand;
import vcg.diagram.edit.commands.CauseNodeSuccessorReorientCommand;
import vcg.diagram.edit.parts.CauseNodeSuccessorEditPart;
import vcg.diagram.providers.SeaMonsterElementTypes;

/**
 * @generated
 */
public class CompoundNode2ItemSemanticEditPolicy extends
		SeaMonsterBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		CompoundCommand cc = getDestroyEdgesCommand();
		addDestroyShortcutsCommand(cc);
		cc.add(getGEFWrapper(new DestroyElementCommand(req)));
		return cc.unwrap();
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		Command command = req.getTarget() == null ? getStartCreateRelationshipCommand(req)
				: getCompleteCreateRelationshipCommand(req);
		return command != null ? command : super
				.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getStartCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (SeaMonsterElementTypes.CauseNodeSuccessor_3001 == req
				.getElementType()) {
			return getGEFWrapper(new CauseNodeSuccessorCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCompleteCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (SeaMonsterElementTypes.CauseNodeSuccessor_3001 == req
				.getElementType()) {
			return getGEFWrapper(new CauseNodeSuccessorCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * Returns command to reorient EReference based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientReferenceRelationshipCommand(
			ReorientReferenceRelationshipRequest req) {
		switch (getVisualID(req)) {
		case CauseNodeSuccessorEditPart.VISUAL_ID:
			return getGEFWrapper(new CauseNodeSuccessorReorientCommand(req));
		}
		return super.getReorientReferenceRelationshipCommand(req);
	}

}
