package vcg.diagram.edit.policies;

import java.util.Iterator;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;

import vcg.diagram.edit.commands.CauseNodeSuccessorCreateCommand;
import vcg.diagram.edit.commands.CauseNodeSuccessorReorientCommand;
import vcg.diagram.edit.parts.CauseNodeSuccessorEditPart;
import vcg.diagram.edit.parts.CompoundNode2EditPart;
import vcg.diagram.edit.parts.ConjunctionNodeConjunctionCompartmentEditPart;
import vcg.diagram.edit.parts.SimpleNode2EditPart;
import vcg.diagram.part.SeaMonsterVisualIDRegistry;
import vcg.diagram.providers.SeaMonsterElementTypes;

/**
 * @generated
 */
public class ConjunctionNodeItemSemanticEditPolicy extends
		SeaMonsterBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		CompoundCommand cc = getDestroyEdgesCommand();
		addDestroyChildNodesCommand(cc);
		addDestroyShortcutsCommand(cc);
		View view = (View) getHost().getModel();
		if (view.getEAnnotation("Shortcut") != null) { //$NON-NLS-1$
			req.setElementToDestroy(view);
		}
		cc.add(getGEFWrapper(new DestroyElementCommand(req)));
		return cc.unwrap();
	}

	/**
	 * @generated
	 */
	protected void addDestroyChildNodesCommand(CompoundCommand cmd) {
		View view = (View) getHost().getModel();
		EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
		if (annotation != null) {
			return;
		}
		for (Iterator it = view.getChildren().iterator(); it.hasNext();) {
			Node node = (Node) it.next();
			switch (SeaMonsterVisualIDRegistry.getVisualID(node)) {
			case ConjunctionNodeConjunctionCompartmentEditPart.VISUAL_ID:
				for (Iterator cit = node.getChildren().iterator(); cit
						.hasNext();) {
					Node cnode = (Node) cit.next();
					switch (SeaMonsterVisualIDRegistry.getVisualID(cnode)) {
					case SimpleNode2EditPart.VISUAL_ID:
						cmd.add(getDestroyElementCommand(cnode));
						break;
					case CompoundNode2EditPart.VISUAL_ID:
						cmd.add(getDestroyElementCommand(cnode));
						break;
					}
				}
				break;
			}
		}
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		Command command = req.getTarget() == null ? getStartCreateRelationshipCommand(req)
				: getCompleteCreateRelationshipCommand(req);
		return command != null ? command : super
				.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getStartCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (SeaMonsterElementTypes.CauseNodeSuccessor_3001 == req
				.getElementType()) {
			return getGEFWrapper(new CauseNodeSuccessorCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCompleteCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (SeaMonsterElementTypes.CauseNodeSuccessor_3001 == req
				.getElementType()) {
			return getGEFWrapper(new CauseNodeSuccessorCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * Returns command to reorient EReference based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientReferenceRelationshipCommand(
			ReorientReferenceRelationshipRequest req) {
		switch (getVisualID(req)) {
		case CauseNodeSuccessorEditPart.VISUAL_ID:
			return getGEFWrapper(new CauseNodeSuccessorReorientCommand(req));
		}
		return super.getReorientReferenceRelationshipCommand(req);
	}

}
