package vcg.diagram.edit.policies;

import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.commands.core.commands.DuplicateEObjectsCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DuplicateElementsRequest;

import vcg.diagram.edit.commands.CompoundNodeCreateCommand;
import vcg.diagram.edit.commands.ConjunctionNodeCreateCommand;
import vcg.diagram.edit.commands.ExitNodeCreateCommand;
import vcg.diagram.edit.commands.SimpleNodeCreateCommand;
import vcg.diagram.providers.SeaMonsterElementTypes;

/**
 * @generated
 */
public class VCGItemSemanticEditPolicy extends
		SeaMonsterBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		if (SeaMonsterElementTypes.ExitNode_1001 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getVCG_Vulnerability());
			}
			return getGEFWrapper(new ExitNodeCreateCommand(req));
		}
		if (SeaMonsterElementTypes.CompoundNode_1002 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getVCG_CauseList());
			}
			return getGEFWrapper(new CompoundNodeCreateCommand(req));
		}
		if (SeaMonsterElementTypes.SimpleNode_1003 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getVCG_CauseList());
			}
			return getGEFWrapper(new SimpleNodeCreateCommand(req));
		}
		if (SeaMonsterElementTypes.ConjunctionNode_1004 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req
						.setContainmentFeature(SeaMonster.SeaMonsterPackage.eINSTANCE
								.getVCG_CauseList());
			}
			return getGEFWrapper(new ConjunctionNodeCreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getDuplicateCommand(DuplicateElementsRequest req) {
		TransactionalEditingDomain editingDomain = ((IGraphicalEditPart) getHost())
				.getEditingDomain();
		return getGEFWrapper(new DuplicateAnythingCommand(editingDomain, req));
	}

	/**
	 * @generated
	 */
	private static class DuplicateAnythingCommand extends
			DuplicateEObjectsCommand {

		/**
		 * @generated
		 */
		public DuplicateAnythingCommand(
				TransactionalEditingDomain editingDomain,
				DuplicateElementsRequest req) {
			super(editingDomain, req.getLabel(), req
					.getElementsToBeDuplicated(), req
					.getAllDuplicatedElementsMap());
		}

	}

}
