package vcg.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;

import vcg.diagram.edit.parts.CauseNodeSuccessorEditPart;
import vcg.diagram.edit.parts.CompoundNode2EditPart;
import vcg.diagram.edit.parts.CompoundNodeEditPart;
import vcg.diagram.edit.parts.ConjunctionNodeConjunctionCompartmentEditPart;
import vcg.diagram.edit.parts.ConjunctionNodeEditPart;
import vcg.diagram.edit.parts.ExitNodeEditPart;
import vcg.diagram.edit.parts.SimpleNode2EditPart;
import vcg.diagram.edit.parts.SimpleNodeEditPart;
import vcg.diagram.edit.parts.VCGEditPart;
import vcg.diagram.providers.SeaMonsterElementTypes;

/**
 * @generated
 */
public class SeaMonsterDiagramUpdater {

	/**
	 * @generated
	 */
	public static List getSemanticChildren(View view) {
		switch (SeaMonsterVisualIDRegistry.getVisualID(view)) {
		case ConjunctionNodeConjunctionCompartmentEditPart.VISUAL_ID:
			return getConjunctionNodeConjunctionCompartment_5001SemanticChildren(view);
		case VCGEditPart.VISUAL_ID:
			return getVCG_79SemanticChildren(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getConjunctionNodeConjunctionCompartment_5001SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		SeaMonster.ConjunctionNode modelElement = (SeaMonster.ConjunctionNode) containerView
				.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getConjunctionCauses().iterator(); it
				.hasNext();) {
			SeaMonster.CauseNode childElement = (SeaMonster.CauseNode) it
					.next();
			int visualID = SeaMonsterVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == SimpleNode2EditPart.VISUAL_ID) {
				result
						.add(new SeaMonsterNodeDescriptor(childElement,
								visualID));
				continue;
			}
			if (visualID == CompoundNode2EditPart.VISUAL_ID) {
				result
						.add(new SeaMonsterNodeDescriptor(childElement,
								visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getVCG_79SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		SeaMonster.VCG modelElement = (SeaMonster.VCG) view.getElement();
		List result = new LinkedList();
		{
			SeaMonster.ExitNode childElement = modelElement.getVulnerability();
			int visualID = SeaMonsterVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == ExitNodeEditPart.VISUAL_ID) {
				result
						.add(new SeaMonsterNodeDescriptor(childElement,
								visualID));
			}
		}
		for (Iterator it = modelElement.getCauseList().iterator(); it.hasNext();) {
			SeaMonster.CauseNode childElement = (SeaMonster.CauseNode) it
					.next();
			int visualID = SeaMonsterVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == CompoundNodeEditPart.VISUAL_ID) {
				result
						.add(new SeaMonsterNodeDescriptor(childElement,
								visualID));
				continue;
			}
			if (visualID == SimpleNodeEditPart.VISUAL_ID) {
				result
						.add(new SeaMonsterNodeDescriptor(childElement,
								visualID));
				continue;
			}
			if (visualID == ConjunctionNodeEditPart.VISUAL_ID) {
				result
						.add(new SeaMonsterNodeDescriptor(childElement,
								visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getContainedLinks(View view) {
		switch (SeaMonsterVisualIDRegistry.getVisualID(view)) {
		case VCGEditPart.VISUAL_ID:
			return getVCG_79ContainedLinks(view);
		case ExitNodeEditPart.VISUAL_ID:
			return getExitNode_1001ContainedLinks(view);
		case CompoundNodeEditPart.VISUAL_ID:
			return getCompoundNode_1002ContainedLinks(view);
		case SimpleNodeEditPart.VISUAL_ID:
			return getSimpleNode_1003ContainedLinks(view);
		case ConjunctionNodeEditPart.VISUAL_ID:
			return getConjunctionNode_1004ContainedLinks(view);
		case SimpleNode2EditPart.VISUAL_ID:
			return getSimpleNode_2001ContainedLinks(view);
		case CompoundNode2EditPart.VISUAL_ID:
			return getCompoundNode_2002ContainedLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getIncomingLinks(View view) {
		switch (SeaMonsterVisualIDRegistry.getVisualID(view)) {
		case ExitNodeEditPart.VISUAL_ID:
			return getExitNode_1001IncomingLinks(view);
		case CompoundNodeEditPart.VISUAL_ID:
			return getCompoundNode_1002IncomingLinks(view);
		case SimpleNodeEditPart.VISUAL_ID:
			return getSimpleNode_1003IncomingLinks(view);
		case ConjunctionNodeEditPart.VISUAL_ID:
			return getConjunctionNode_1004IncomingLinks(view);
		case SimpleNode2EditPart.VISUAL_ID:
			return getSimpleNode_2001IncomingLinks(view);
		case CompoundNode2EditPart.VISUAL_ID:
			return getCompoundNode_2002IncomingLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOutgoingLinks(View view) {
		switch (SeaMonsterVisualIDRegistry.getVisualID(view)) {
		case ExitNodeEditPart.VISUAL_ID:
			return getExitNode_1001OutgoingLinks(view);
		case CompoundNodeEditPart.VISUAL_ID:
			return getCompoundNode_1002OutgoingLinks(view);
		case SimpleNodeEditPart.VISUAL_ID:
			return getSimpleNode_1003OutgoingLinks(view);
		case ConjunctionNodeEditPart.VISUAL_ID:
			return getConjunctionNode_1004OutgoingLinks(view);
		case SimpleNode2EditPart.VISUAL_ID:
			return getSimpleNode_2001OutgoingLinks(view);
		case CompoundNode2EditPart.VISUAL_ID:
			return getCompoundNode_2002OutgoingLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getVCG_79ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getExitNode_1001ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getCompoundNode_1002ContainedLinks(View view) {
		SeaMonster.CompoundNode modelElement = (SeaMonster.CompoundNode) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_CauseNode_Successor_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getSimpleNode_1003ContainedLinks(View view) {
		SeaMonster.SimpleNode modelElement = (SeaMonster.SimpleNode) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_CauseNode_Successor_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getConjunctionNode_1004ContainedLinks(View view) {
		SeaMonster.ConjunctionNode modelElement = (SeaMonster.ConjunctionNode) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_CauseNode_Successor_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getSimpleNode_2001ContainedLinks(View view) {
		SeaMonster.SimpleNode modelElement = (SeaMonster.SimpleNode) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_CauseNode_Successor_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getCompoundNode_2002ContainedLinks(View view) {
		SeaMonster.CompoundNode modelElement = (SeaMonster.CompoundNode) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_CauseNode_Successor_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getExitNode_1001IncomingLinks(View view) {
		SeaMonster.ExitNode modelElement = (SeaMonster.ExitNode) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_CauseNode_Successor_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getCompoundNode_1002IncomingLinks(View view) {
		SeaMonster.CompoundNode modelElement = (SeaMonster.CompoundNode) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_CauseNode_Successor_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getSimpleNode_1003IncomingLinks(View view) {
		SeaMonster.SimpleNode modelElement = (SeaMonster.SimpleNode) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_CauseNode_Successor_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getConjunctionNode_1004IncomingLinks(View view) {
		SeaMonster.ConjunctionNode modelElement = (SeaMonster.ConjunctionNode) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_CauseNode_Successor_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getSimpleNode_2001IncomingLinks(View view) {
		SeaMonster.SimpleNode modelElement = (SeaMonster.SimpleNode) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_CauseNode_Successor_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getCompoundNode_2002IncomingLinks(View view) {
		SeaMonster.CompoundNode modelElement = (SeaMonster.CompoundNode) view
				.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result
				.addAll(getIncomingFeatureModelFacetLinks_CauseNode_Successor_3001(
						modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getExitNode_1001OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getCompoundNode_1002OutgoingLinks(View view) {
		SeaMonster.CompoundNode modelElement = (SeaMonster.CompoundNode) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_CauseNode_Successor_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getSimpleNode_1003OutgoingLinks(View view) {
		SeaMonster.SimpleNode modelElement = (SeaMonster.SimpleNode) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_CauseNode_Successor_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getConjunctionNode_1004OutgoingLinks(View view) {
		SeaMonster.ConjunctionNode modelElement = (SeaMonster.ConjunctionNode) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_CauseNode_Successor_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getSimpleNode_2001OutgoingLinks(View view) {
		SeaMonster.SimpleNode modelElement = (SeaMonster.SimpleNode) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_CauseNode_Successor_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getCompoundNode_2002OutgoingLinks(View view) {
		SeaMonster.CompoundNode modelElement = (SeaMonster.CompoundNode) view
				.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_CauseNode_Successor_3001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingFeatureModelFacetLinks_CauseNode_Successor_3001(
			SeaMonster.Node target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() == SeaMonster.SeaMonsterPackage.eINSTANCE
					.getCauseNode_Successor()) {
				result.add(new SeaMonsterLinkDescriptor(setting.getEObject(),
						target, SeaMonsterElementTypes.CauseNodeSuccessor_3001,
						CauseNodeSuccessorEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_CauseNode_Successor_3001(
			SeaMonster.CauseNode source) {
		Collection result = new LinkedList();
		for (Iterator destinations = source.getSuccessor().iterator(); destinations
				.hasNext();) {
			SeaMonster.Node destination = (SeaMonster.Node) destinations.next();
			result.add(new SeaMonsterLinkDescriptor(source, destination,
					SeaMonsterElementTypes.CauseNodeSuccessor_3001,
					CauseNodeSuccessorEditPart.VISUAL_ID));
		}
		return result;
	}

}
