package vcg.diagram.part;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteGroup;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeConnectionTool;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeCreationTool;

import vcg.diagram.providers.SeaMonsterElementTypes;

/**
 * @generated
 */
public class SeaMonsterPaletteFactory {

	/**
	 * @generated
	 */
	public void fillPalette(PaletteRoot paletteRoot) {
		paletteRoot.add(createSeaMonster1Group());
	}

	/**
	 * Creates "SeaMonster" palette tool group
	 * @generated
	 */
	private PaletteContainer createSeaMonster1Group() {
		PaletteGroup paletteContainer = new PaletteGroup(
				Messages.SeaMonster1Group_title);
		paletteContainer.add(createExitNode1CreationTool());
		paletteContainer.add(createCompoundNode2CreationTool());
		paletteContainer.add(createSimpleNode3CreationTool());
		paletteContainer.add(createConjunctionNode4CreationTool());
		paletteContainer.add(createSuccessor5CreationTool());
		return paletteContainer;
	}

	/**
	 * @generated
	 */
	private ToolEntry createExitNode1CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.ExitNode_1001);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.ExitNode1CreationTool_title,
				Messages.ExitNode1CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.vcg/images/vcg-exitnode.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCompoundNode2CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(2);
		types.add(SeaMonsterElementTypes.CompoundNode_1002);
		types.add(SeaMonsterElementTypes.CompoundNode_2002);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.CompoundNode2CreationTool_title,
				Messages.CompoundNode2CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.vcg/images/vcg-compoundnode.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createSimpleNode3CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(2);
		types.add(SeaMonsterElementTypes.SimpleNode_1003);
		types.add(SeaMonsterElementTypes.SimpleNode_2001);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.SimpleNode3CreationTool_title,
				Messages.SimpleNode3CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.vcg/images/misuse-system.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createConjunctionNode4CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.ConjunctionNode_1004);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.ConjunctionNode4CreationTool_title,
				Messages.ConjunctionNode4CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.vcg/images/vcg-dottedrectangle.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createSuccessor5CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.CauseNodeSuccessor_3001);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Successor5CreationTool_title,
				Messages.Successor5CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.vcg/images/misuse-usesline.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private static class NodeToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List elementTypes;

		/**
		 * @generated
		 */
		private NodeToolEntry(String title, String description,
				List elementTypes) {
			super(title, description, null, null);
			this.elementTypes = elementTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeCreationTool(elementTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}

	/**
	 * @generated
	 */
	private static class LinkToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List relationshipTypes;

		/**
		 * @generated
		 */
		private LinkToolEntry(String title, String description,
				List relationshipTypes) {
			super(title, description, null, null);
			this.relationshipTypes = relationshipTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeConnectionTool(relationshipTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}
}
