package vcg.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

import vcg.diagram.edit.parts.CompoundNode2EditPart;
import vcg.diagram.edit.parts.CompoundNodeEditPart;
import vcg.diagram.edit.parts.CompoundNodeName2EditPart;
import vcg.diagram.edit.parts.CompoundNodeNameEditPart;
import vcg.diagram.edit.parts.ConjunctionNodeConjunctionCompartmentEditPart;
import vcg.diagram.edit.parts.ConjunctionNodeEditPart;
import vcg.diagram.edit.parts.ConjunctionNodeNameEditPart;
import vcg.diagram.edit.parts.ExitNodeCVElinkEditPart;
import vcg.diagram.edit.parts.ExitNodeEditPart;
import vcg.diagram.edit.parts.ExitNodeNameEditPart;
import vcg.diagram.edit.parts.SimpleNode2EditPart;
import vcg.diagram.edit.parts.SimpleNodeEditPart;
import vcg.diagram.edit.parts.SimpleNodeName2EditPart;
import vcg.diagram.edit.parts.SimpleNodeNameEditPart;
import vcg.diagram.edit.parts.VCGEditPart;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class SeaMonsterVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = SeaMonsterDiagramEditorPlugin
			.getInstance().getBundle().getSymbolicName()
			+ "/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (VCGEditPart.MODEL_ID.equals(view.getType())) {
				return VCGEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return vcg.diagram.part.SeaMonsterVisualIDRegistry.getVisualID(view
				.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				SeaMonsterDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return String.valueOf(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (SeaMonster.SeaMonsterPackage.eINSTANCE.getVCG().isSuperTypeOf(
				domainElement.eClass())
				&& isDiagram((SeaMonster.VCG) domainElement)) {
			return VCGEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null
				|| !VCGEditPart.MODEL_ID
						.equals(vcg.diagram.part.SeaMonsterVisualIDRegistry
								.getModelID(containerView))) {
			return -1;
		}
		switch (vcg.diagram.part.SeaMonsterVisualIDRegistry
				.getVisualID(containerView)) {
		case ConjunctionNodeConjunctionCompartmentEditPart.VISUAL_ID:
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getSimpleNode()
					.isSuperTypeOf(domainElement.eClass())) {
				return SimpleNode2EditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getCompoundNode()
					.isSuperTypeOf(domainElement.eClass())) {
				return CompoundNode2EditPart.VISUAL_ID;
			}
			break;
		case VCGEditPart.VISUAL_ID:
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getExitNode()
					.isSuperTypeOf(domainElement.eClass())) {
				return ExitNodeEditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getCompoundNode()
					.isSuperTypeOf(domainElement.eClass())) {
				return CompoundNodeEditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getSimpleNode()
					.isSuperTypeOf(domainElement.eClass())) {
				return SimpleNodeEditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getConjunctionNode()
					.isSuperTypeOf(domainElement.eClass())) {
				return ConjunctionNodeEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = vcg.diagram.part.SeaMonsterVisualIDRegistry
				.getModelID(containerView);
		if (!VCGEditPart.MODEL_ID.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (VCGEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = vcg.diagram.part.SeaMonsterVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = VCGEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case ExitNodeEditPart.VISUAL_ID:
			if (ExitNodeNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case CompoundNodeEditPart.VISUAL_ID:
			if (CompoundNodeNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SimpleNodeEditPart.VISUAL_ID:
			if (SimpleNodeNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ConjunctionNodeEditPart.VISUAL_ID:
			if (ConjunctionNodeNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ConjunctionNodeConjunctionCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SimpleNode2EditPart.VISUAL_ID:
			if (SimpleNodeName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case CompoundNode2EditPart.VISUAL_ID:
			if (CompoundNodeName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ConjunctionNodeConjunctionCompartmentEditPart.VISUAL_ID:
			if (SimpleNode2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (CompoundNode2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case VCGEditPart.VISUAL_ID:
			if (ExitNodeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (CompoundNodeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SimpleNodeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ConjunctionNodeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(SeaMonster.VCG element) {
		return true;
	}

}
