package vcg.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

import vcg.diagram.part.SeaMonsterDiagramEditorPlugin;

/**
 * @generated
 */
public class SeaMonsterElementTypes extends ElementInitializers {

	/**
	 * @generated
	 */
	private SeaMonsterElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static Set KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType VCG_79 = getElementType("seaMonster.vcg.VCG_79"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType ExitNode_1001 = getElementType("seaMonster.vcg.ExitNode_1001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType CompoundNode_1002 = getElementType("seaMonster.vcg.CompoundNode_1002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType SimpleNode_1003 = getElementType("seaMonster.vcg.SimpleNode_1003"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType ConjunctionNode_1004 = getElementType("seaMonster.vcg.ConjunctionNode_1004"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType SimpleNode_2001 = getElementType("seaMonster.vcg.SimpleNode_2001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType CompoundNode_2002 = getElementType("seaMonster.vcg.CompoundNode_2002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType CauseNodeSuccessor_3001 = getElementType("seaMonster.vcg.CauseNodeSuccessor_3001"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(
			ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract()) {
				element = eContainingClass;
			} else if (eType instanceof EClass
					&& !((EClass) eType).isAbstract()) {
				element = eType;
			}
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return SeaMonsterDiagramEditorPlugin.getInstance()
						.getItemImageDescriptor(
								eClass.getEPackage().getEFactoryInstance()
										.create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap();

			elements.put(VCG_79, SeaMonster.SeaMonsterPackage.eINSTANCE
					.getVCG());

			elements.put(ExitNode_1001, SeaMonster.SeaMonsterPackage.eINSTANCE
					.getExitNode());

			elements.put(CompoundNode_1002,
					SeaMonster.SeaMonsterPackage.eINSTANCE.getCompoundNode());

			elements.put(SimpleNode_1003,
					SeaMonster.SeaMonsterPackage.eINSTANCE.getSimpleNode());

			elements
					.put(ConjunctionNode_1004,
							SeaMonster.SeaMonsterPackage.eINSTANCE
									.getConjunctionNode());

			elements.put(SimpleNode_2001,
					SeaMonster.SeaMonsterPackage.eINSTANCE.getSimpleNode());

			elements.put(CompoundNode_2002,
					SeaMonster.SeaMonsterPackage.eINSTANCE.getCompoundNode());

			elements.put(CauseNodeSuccessor_3001,
					SeaMonster.SeaMonsterPackage.eINSTANCE
							.getCauseNode_Successor());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet();
			KNOWN_ELEMENT_TYPES.add(VCG_79);
			KNOWN_ELEMENT_TYPES.add(ExitNode_1001);
			KNOWN_ELEMENT_TYPES.add(CompoundNode_1002);
			KNOWN_ELEMENT_TYPES.add(SimpleNode_1003);
			KNOWN_ELEMENT_TYPES.add(ConjunctionNode_1004);
			KNOWN_ELEMENT_TYPES.add(SimpleNode_2001);
			KNOWN_ELEMENT_TYPES.add(CompoundNode_2002);
			KNOWN_ELEMENT_TYPES.add(CauseNodeSuccessor_3001);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

}
