package vcg.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.diagram.core.providers.AbstractViewProvider;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.type.core.IHintedType;
import org.eclipse.gmf.runtime.notation.View;

import vcg.diagram.edit.parts.CauseNodeSuccessorEditPart;
import vcg.diagram.edit.parts.CompoundNode2EditPart;
import vcg.diagram.edit.parts.CompoundNodeEditPart;
import vcg.diagram.edit.parts.CompoundNodeName2EditPart;
import vcg.diagram.edit.parts.CompoundNodeNameEditPart;
import vcg.diagram.edit.parts.ConjunctionNodeConjunctionCompartmentEditPart;
import vcg.diagram.edit.parts.ConjunctionNodeEditPart;
import vcg.diagram.edit.parts.ConjunctionNodeNameEditPart;
import vcg.diagram.edit.parts.ExitNodeCVElinkEditPart;
import vcg.diagram.edit.parts.ExitNodeEditPart;
import vcg.diagram.edit.parts.ExitNodeNameEditPart;
import vcg.diagram.edit.parts.SimpleNode2EditPart;
import vcg.diagram.edit.parts.SimpleNodeEditPart;
import vcg.diagram.edit.parts.SimpleNodeName2EditPart;
import vcg.diagram.edit.parts.SimpleNodeNameEditPart;
import vcg.diagram.edit.parts.VCGEditPart;
import vcg.diagram.part.SeaMonsterVisualIDRegistry;
import vcg.diagram.view.factories.CauseNodeSuccessorViewFactory;
import vcg.diagram.view.factories.CompoundNode2ViewFactory;
import vcg.diagram.view.factories.CompoundNodeName2ViewFactory;
import vcg.diagram.view.factories.CompoundNodeNameViewFactory;
import vcg.diagram.view.factories.CompoundNodeViewFactory;
import vcg.diagram.view.factories.ConjunctionNodeConjunctionCompartmentViewFactory;
import vcg.diagram.view.factories.ConjunctionNodeNameViewFactory;
import vcg.diagram.view.factories.ConjunctionNodeViewFactory;
import vcg.diagram.view.factories.ExitNodeCVElinkViewFactory;
import vcg.diagram.view.factories.ExitNodeNameViewFactory;
import vcg.diagram.view.factories.ExitNodeViewFactory;
import vcg.diagram.view.factories.SimpleNode2ViewFactory;
import vcg.diagram.view.factories.SimpleNodeName2ViewFactory;
import vcg.diagram.view.factories.SimpleNodeNameViewFactory;
import vcg.diagram.view.factories.SimpleNodeViewFactory;
import vcg.diagram.view.factories.VCGViewFactory;

/**
 * @generated
 */
public class SeaMonsterViewProvider extends AbstractViewProvider {

	/**
	 * @generated
	 */
	protected Class getDiagramViewClass(IAdaptable semanticAdapter,
			String diagramKind) {
		EObject semanticElement = getSemanticElement(semanticAdapter);
		if (VCGEditPart.MODEL_ID.equals(diagramKind)
				&& SeaMonsterVisualIDRegistry
						.getDiagramVisualID(semanticElement) != -1) {
			return VCGViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getNodeViewClass(IAdaptable semanticAdapter,
			View containerView, String semanticHint) {
		if (containerView == null) {
			return null;
		}
		IElementType elementType = getSemanticElementType(semanticAdapter);
		EObject domainElement = getSemanticElement(semanticAdapter);
		int visualID;
		if (semanticHint == null) {
			// Semantic hint is not specified. Can be a result of call from CanonicalEditPolicy.
			// In this situation there should be NO elementType, visualID will be determined
			// by VisualIDRegistry.getNodeVisualID() for domainElement.
			if (elementType != null || domainElement == null) {
				return null;
			}
			visualID = SeaMonsterVisualIDRegistry.getNodeVisualID(
					containerView, domainElement);
		} else {
			visualID = SeaMonsterVisualIDRegistry.getVisualID(semanticHint);
			if (elementType != null) {
				// Semantic hint is specified together with element type.
				// Both parameters should describe exactly the same diagram element.
				// In addition we check that visualID returned by VisualIDRegistry.getNodeVisualID() for
				// domainElement (if specified) is the same as in element type.
				if (!SeaMonsterElementTypes.isKnownElementType(elementType)
						|| (!(elementType instanceof IHintedType))) {
					return null; // foreign element type
				}
				String elementTypeHint = ((IHintedType) elementType)
						.getSemanticHint();
				if (!semanticHint.equals(elementTypeHint)) {
					return null; // if semantic hint is specified it should be the same as in element type
				}
				if (domainElement != null
						&& visualID != SeaMonsterVisualIDRegistry
								.getNodeVisualID(containerView, domainElement)) {
					return null; // visual id for node EClass should match visual id from element type
				}
			} else {
				// Element type is not specified. Domain element should be present (except pure design elements).
				// This method is called with EObjectAdapter as parameter from:
				//   - ViewService.createNode(View container, EObject eObject, String type, PreferencesHint preferencesHint) 
				//   - generated ViewFactory.decorateView() for parent element
				if (!VCGEditPart.MODEL_ID.equals(SeaMonsterVisualIDRegistry
						.getModelID(containerView))) {
					return null; // foreign diagram
				}
				switch (visualID) {
				case ExitNodeEditPart.VISUAL_ID:
				case CompoundNodeEditPart.VISUAL_ID:
				case SimpleNodeEditPart.VISUAL_ID:
				case ConjunctionNodeEditPart.VISUAL_ID:
				case SimpleNode2EditPart.VISUAL_ID:
				case CompoundNode2EditPart.VISUAL_ID:
					if (domainElement == null
							|| visualID != SeaMonsterVisualIDRegistry
									.getNodeVisualID(containerView,
											domainElement)) {
						return null; // visual id in semantic hint should match visual id for domain element
					}
					break;
				case ExitNodeNameEditPart.VISUAL_ID:
					if (ExitNodeEditPart.VISUAL_ID != SeaMonsterVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case CompoundNodeNameEditPart.VISUAL_ID:
					if (CompoundNodeEditPart.VISUAL_ID != SeaMonsterVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case SimpleNodeNameEditPart.VISUAL_ID:
					if (SimpleNodeEditPart.VISUAL_ID != SeaMonsterVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case ConjunctionNodeNameEditPart.VISUAL_ID:
				case ConjunctionNodeConjunctionCompartmentEditPart.VISUAL_ID:
					if (ConjunctionNodeEditPart.VISUAL_ID != SeaMonsterVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case SimpleNodeName2EditPart.VISUAL_ID:
					if (SimpleNode2EditPart.VISUAL_ID != SeaMonsterVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				case CompoundNodeName2EditPart.VISUAL_ID:
					if (CompoundNode2EditPart.VISUAL_ID != SeaMonsterVisualIDRegistry
							.getVisualID(containerView)
							|| containerView.getElement() != domainElement) {
						return null; // wrong container
					}
					break;
				default:
					return null;
				}
			}
		}
		return getNodeViewClass(containerView, visualID);
	}

	/**
	 * @generated
	 */
	protected Class getNodeViewClass(View containerView, int visualID) {
		if (containerView == null
				|| !SeaMonsterVisualIDRegistry.canCreateNode(containerView,
						visualID)) {
			return null;
		}
		switch (visualID) {
		case ExitNodeEditPart.VISUAL_ID:
			return ExitNodeViewFactory.class;
		case ExitNodeNameEditPart.VISUAL_ID:
			return ExitNodeNameViewFactory.class;
		case CompoundNodeEditPart.VISUAL_ID:
			return CompoundNodeViewFactory.class;
		case CompoundNodeNameEditPart.VISUAL_ID:
			return CompoundNodeNameViewFactory.class;
		case SimpleNodeEditPart.VISUAL_ID:
			return SimpleNodeViewFactory.class;
		case SimpleNodeNameEditPart.VISUAL_ID:
			return SimpleNodeNameViewFactory.class;
		case ConjunctionNodeEditPart.VISUAL_ID:
			return ConjunctionNodeViewFactory.class;
		case ConjunctionNodeNameEditPart.VISUAL_ID:
			return ConjunctionNodeNameViewFactory.class;
		case SimpleNode2EditPart.VISUAL_ID:
			return SimpleNode2ViewFactory.class;
		case SimpleNodeName2EditPart.VISUAL_ID:
			return SimpleNodeName2ViewFactory.class;
		case CompoundNode2EditPart.VISUAL_ID:
			return CompoundNode2ViewFactory.class;
		case CompoundNodeName2EditPart.VISUAL_ID:
			return CompoundNodeName2ViewFactory.class;
		case ConjunctionNodeConjunctionCompartmentEditPart.VISUAL_ID:
			return ConjunctionNodeConjunctionCompartmentViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getEdgeViewClass(IAdaptable semanticAdapter,
			View containerView, String semanticHint) {
		IElementType elementType = getSemanticElementType(semanticAdapter);
		if (!SeaMonsterElementTypes.isKnownElementType(elementType)
				|| (!(elementType instanceof IHintedType))) {
			return null; // foreign element type
		}
		String elementTypeHint = ((IHintedType) elementType).getSemanticHint();
		if (elementTypeHint == null) {
			return null; // our hint is visual id and must be specified
		}
		if (semanticHint != null && !semanticHint.equals(elementTypeHint)) {
			return null; // if semantic hint is specified it should be the same as in element type
		}
		int visualID = SeaMonsterVisualIDRegistry.getVisualID(elementTypeHint);
		EObject domainElement = getSemanticElement(semanticAdapter);
		if (domainElement != null
				&& visualID != SeaMonsterVisualIDRegistry
						.getLinkWithClassVisualID(domainElement)) {
			return null; // visual id for link EClass should match visual id from element type
		}
		return getEdgeViewClass(visualID);
	}

	/**
	 * @generated
	 */
	protected Class getEdgeViewClass(int visualID) {
		switch (visualID) {
		case CauseNodeSuccessorEditPart.VISUAL_ID:
			return CauseNodeSuccessorViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	private IElementType getSemanticElementType(IAdaptable semanticAdapter) {
		if (semanticAdapter == null) {
			return null;
		}
		return (IElementType) semanticAdapter.getAdapter(IElementType.class);
	}
}
