/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SeaMonster;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see SeaMonster.SeaMonsterPackage
 * @generated
 */
public interface SeaMonsterFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	SeaMonsterFactory eINSTANCE = SeaMonster.impl.SeaMonsterFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Security Model</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Security Model</em>'.
	 * @generated
	 */
	SecurityModel createSecurityModel();

	/**
	 * Returns a new object of class '<em>Attack Tree</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Attack Tree</em>'.
	 * @generated
	 */
	AttackTree createAttackTree();

	/**
	 * Returns a new object of class '<em>VCG</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>VCG</em>'.
	 * @generated
	 */
	VCG createVCG();

	/**
	 * Returns a new object of class '<em>Misuse Case</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Misuse Case</em>'.
	 * @generated
	 */
	MisuseCase createMisuseCase();

	/**
	 * Returns a new object of class '<em>And Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>And Node</em>'.
	 * @generated
	 */
	AndNode createAndNode();

	/**
	 * Returns a new object of class '<em>Goal Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Goal Node</em>'.
	 * @generated
	 */
	GoalNode createGoalNode();

	/**
	 * Returns a new object of class '<em>Exit Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Exit Node</em>'.
	 * @generated
	 */
	ExitNode createExitNode();

	/**
	 * Returns a new object of class '<em>Cause Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Cause Node</em>'.
	 * @generated
	 */
	CauseNode createCauseNode();

	/**
	 * Returns a new object of class '<em>Compound Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Compound Node</em>'.
	 * @generated
	 */
	CompoundNode createCompoundNode();

	/**
	 * Returns a new object of class '<em>Simple Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Simple Node</em>'.
	 * @generated
	 */
	SimpleNode createSimpleNode();

	/**
	 * Returns a new object of class '<em>Conjunction Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Conjunction Node</em>'.
	 * @generated
	 */
	ConjunctionNode createConjunctionNode();

	/**
	 * Returns a new object of class '<em>Good Actor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Good Actor</em>'.
	 * @generated
	 */
	GoodActor createGoodActor();

	/**
	 * Returns a new object of class '<em>Bad Actor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Bad Actor</em>'.
	 * @generated
	 */
	BadActor createBadActor();

	/**
	 * Returns a new object of class '<em>Insider Actor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Insider Actor</em>'.
	 * @generated
	 */
	InsiderActor createInsiderActor();

	/**
	 * Returns a new object of class '<em>Actor</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Actor</em>'.
	 * @generated
	 */
	Actor createActor();

	/**
	 * Returns a new object of class '<em>Use Case</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Use Case</em>'.
	 * @generated
	 */
	UseCase createUseCase();

	/**
	 * Returns a new object of class '<em>Normal Case</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Normal Case</em>'.
	 * @generated
	 */
	NormalCase createNormalCase();

	/**
	 * Returns a new object of class '<em>Threat Case</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Threat Case</em>'.
	 * @generated
	 */
	ThreatCase createThreatCase();

	/**
	 * Returns a new object of class '<em>Vulnerability Case</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Vulnerability Case</em>'.
	 * @generated
	 */
	VulnerabilityCase createVulnerabilityCase();

	/**
	 * Returns a new object of class '<em>System Box</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>System Box</em>'.
	 * @generated
	 */
	SystemBox createSystemBox();

	/**
	 * Returns a new object of class '<em>Document Root</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Document Root</em>'.
	 * @generated
	 */
	DocumentRoot createDocumentRoot();

	/**
	 * Returns a new object of class '<em>SAG</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>SAG</em>'.
	 * @generated
	 */
	SAG createSAG();

	/**
	 * Returns a new object of class '<em>Vulnerability</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Vulnerability</em>'.
	 * @generated
	 */
	Vulnerability createVulnerability();

	/**
	 * Returns a new object of class '<em>SAG Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>SAG Node</em>'.
	 * @generated
	 */
	SAGNode createSAGNode();

	/**
	 * Returns a new object of class '<em>Activity Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Activity Node</em>'.
	 * @generated
	 */
	ActivityNode createActivityNode();

	/**
	 * Returns a new object of class '<em>Or Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Or Node</em>'.
	 * @generated
	 */
	OrNode createOrNode();

	/**
	 * Returns a new object of class '<em>Sag And Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Sag And Node</em>'.
	 * @generated
	 */
	SagAndNode createSagAndNode();

	/**
	 * Returns a new object of class '<em>Split Node</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Split Node</em>'.
	 * @generated
	 */
	SplitNode createSplitNode();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	SeaMonsterPackage getSeaMonsterPackage();

} //SeaMonsterFactory
