/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SeaMonster.impl;

import SeaMonster.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class SeaMonsterFactoryImpl extends EFactoryImpl implements SeaMonsterFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static SeaMonsterFactory init() {
		try {
			SeaMonsterFactory theSeaMonsterFactory = (SeaMonsterFactory)EPackage.Registry.INSTANCE.getEFactory("http://www.example.org/seaMonster"); 
			if (theSeaMonsterFactory != null) {
				return theSeaMonsterFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new SeaMonsterFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SeaMonsterFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case SeaMonsterPackage.SECURITY_MODEL: return createSecurityModel();
			case SeaMonsterPackage.ATTACK_TREE: return createAttackTree();
			case SeaMonsterPackage.VCG: return createVCG();
			case SeaMonsterPackage.MISUSE_CASE: return createMisuseCase();
			case SeaMonsterPackage.AND_NODE: return createAndNode();
			case SeaMonsterPackage.GOAL_NODE: return createGoalNode();
			case SeaMonsterPackage.EXIT_NODE: return createExitNode();
			case SeaMonsterPackage.CAUSE_NODE: return createCauseNode();
			case SeaMonsterPackage.COMPOUND_NODE: return createCompoundNode();
			case SeaMonsterPackage.SIMPLE_NODE: return createSimpleNode();
			case SeaMonsterPackage.CONJUNCTION_NODE: return createConjunctionNode();
			case SeaMonsterPackage.GOOD_ACTOR: return createGoodActor();
			case SeaMonsterPackage.BAD_ACTOR: return createBadActor();
			case SeaMonsterPackage.INSIDER_ACTOR: return createInsiderActor();
			case SeaMonsterPackage.ACTOR: return createActor();
			case SeaMonsterPackage.USE_CASE: return createUseCase();
			case SeaMonsterPackage.NORMAL_CASE: return createNormalCase();
			case SeaMonsterPackage.THREAT_CASE: return createThreatCase();
			case SeaMonsterPackage.VULNERABILITY_CASE: return createVulnerabilityCase();
			case SeaMonsterPackage.SYSTEM_BOX: return createSystemBox();
			case SeaMonsterPackage.DOCUMENT_ROOT: return createDocumentRoot();
			case SeaMonsterPackage.SAG: return createSAG();
			case SeaMonsterPackage.VULNERABILITY: return createVulnerability();
			case SeaMonsterPackage.SAG_NODE: return createSAGNode();
			case SeaMonsterPackage.OR_NODE: return createOrNode();
			case SeaMonsterPackage.SAG_AND_NODE: return createSagAndNode();
			case SeaMonsterPackage.SPLIT_NODE: return createSplitNode();
			case SeaMonsterPackage.ACTIVITY_NODE: return createActivityNode();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SecurityModel createSecurityModel() {
		SecurityModelImpl securityModel = new SecurityModelImpl();
		return securityModel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AttackTree createAttackTree() {
		AttackTreeImpl attackTree = new AttackTreeImpl();
		return attackTree;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VCG createVCG() {
		VCGImpl vcg = new VCGImpl();
		return vcg;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MisuseCase createMisuseCase() {
		MisuseCaseImpl misuseCase = new MisuseCaseImpl();
		return misuseCase;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AndNode createAndNode() {
		AndNodeImpl andNode = new AndNodeImpl();
		return andNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GoalNode createGoalNode() {
		GoalNodeImpl goalNode = new GoalNodeImpl();
		return goalNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExitNode createExitNode() {
		ExitNodeImpl exitNode = new ExitNodeImpl();
		return exitNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CauseNode createCauseNode() {
		CauseNodeImpl causeNode = new CauseNodeImpl();
		return causeNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CompoundNode createCompoundNode() {
		CompoundNodeImpl compoundNode = new CompoundNodeImpl();
		return compoundNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SimpleNode createSimpleNode() {
		SimpleNodeImpl simpleNode = new SimpleNodeImpl();
		return simpleNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConjunctionNode createConjunctionNode() {
		ConjunctionNodeImpl conjunctionNode = new ConjunctionNodeImpl();
		return conjunctionNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GoodActor createGoodActor() {
		GoodActorImpl goodActor = new GoodActorImpl();
		return goodActor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BadActor createBadActor() {
		BadActorImpl badActor = new BadActorImpl();
		return badActor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InsiderActor createInsiderActor() {
		InsiderActorImpl insiderActor = new InsiderActorImpl();
		return insiderActor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Actor createActor() {
		ActorImpl actor = new ActorImpl();
		return actor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UseCase createUseCase() {
		UseCaseImpl useCase = new UseCaseImpl();
		return useCase;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NormalCase createNormalCase() {
		NormalCaseImpl normalCase = new NormalCaseImpl();
		return normalCase;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ThreatCase createThreatCase() {
		ThreatCaseImpl threatCase = new ThreatCaseImpl();
		return threatCase;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VulnerabilityCase createVulnerabilityCase() {
		VulnerabilityCaseImpl vulnerabilityCase = new VulnerabilityCaseImpl();
		return vulnerabilityCase;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SystemBox createSystemBox() {
		SystemBoxImpl systemBox = new SystemBoxImpl();
		return systemBox;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DocumentRoot createDocumentRoot() {
		DocumentRootImpl documentRoot = new DocumentRootImpl();
		return documentRoot;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SAG createSAG() {
		SAGImpl sag = new SAGImpl();
		return sag;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Vulnerability createVulnerability() {
		VulnerabilityImpl vulnerability = new VulnerabilityImpl();
		return vulnerability;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SAGNode createSAGNode() {
		SAGNodeImpl sagNode = new SAGNodeImpl();
		return sagNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ActivityNode createActivityNode() {
		ActivityNodeImpl activityNode = new ActivityNodeImpl();
		return activityNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OrNode createOrNode() {
		OrNodeImpl orNode = new OrNodeImpl();
		return orNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SagAndNode createSagAndNode() {
		SagAndNodeImpl sagAndNode = new SagAndNodeImpl();
		return sagAndNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SplitNode createSplitNode() {
		SplitNodeImpl splitNode = new SplitNodeImpl();
		return splitNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SeaMonsterPackage getSeaMonsterPackage() {
		return (SeaMonsterPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static SeaMonsterPackage getPackage() {
		return SeaMonsterPackage.eINSTANCE;
	}

} //SeaMonsterFactoryImpl
