/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SeaMonster.util;

import SeaMonster.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see SeaMonster.SeaMonsterPackage
 * @generated
 */
public class SeaMonsterAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static SeaMonsterPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SeaMonsterAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = SeaMonsterPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch the delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SeaMonsterSwitch<Adapter> modelSwitch =
		new SeaMonsterSwitch<Adapter>() {
			@Override
			public Adapter caseSecurityModel(SecurityModel object) {
				return createSecurityModelAdapter();
			}
			@Override
			public Adapter caseAttackTree(AttackTree object) {
				return createAttackTreeAdapter();
			}
			@Override
			public Adapter caseVCG(VCG object) {
				return createVCGAdapter();
			}
			@Override
			public Adapter caseMisuseCase(MisuseCase object) {
				return createMisuseCaseAdapter();
			}
			@Override
			public Adapter caseAttackTreeComponent(AttackTreeComponent object) {
				return createAttackTreeComponentAdapter();
			}
			@Override
			public Adapter caseAndNode(AndNode object) {
				return createAndNodeAdapter();
			}
			@Override
			public Adapter caseGoalNode(GoalNode object) {
				return createGoalNodeAdapter();
			}
			@Override
			public Adapter caseNode(Node object) {
				return createNodeAdapter();
			}
			@Override
			public Adapter caseExitNode(ExitNode object) {
				return createExitNodeAdapter();
			}
			@Override
			public Adapter caseCauseNode(CauseNode object) {
				return createCauseNodeAdapter();
			}
			@Override
			public Adapter caseCompoundNode(CompoundNode object) {
				return createCompoundNodeAdapter();
			}
			@Override
			public Adapter caseSimpleNode(SimpleNode object) {
				return createSimpleNodeAdapter();
			}
			@Override
			public Adapter caseConjunctionNode(ConjunctionNode object) {
				return createConjunctionNodeAdapter();
			}
			@Override
			public Adapter caseGoodActor(GoodActor object) {
				return createGoodActorAdapter();
			}
			@Override
			public Adapter caseBadActor(BadActor object) {
				return createBadActorAdapter();
			}
			@Override
			public Adapter caseInsiderActor(InsiderActor object) {
				return createInsiderActorAdapter();
			}
			@Override
			public Adapter caseActor(Actor object) {
				return createActorAdapter();
			}
			@Override
			public Adapter caseUseCase(UseCase object) {
				return createUseCaseAdapter();
			}
			@Override
			public Adapter caseNormalCase(NormalCase object) {
				return createNormalCaseAdapter();
			}
			@Override
			public Adapter caseThreatCase(ThreatCase object) {
				return createThreatCaseAdapter();
			}
			@Override
			public Adapter caseVulnerabilityCase(VulnerabilityCase object) {
				return createVulnerabilityCaseAdapter();
			}
			@Override
			public Adapter caseSystemBox(SystemBox object) {
				return createSystemBoxAdapter();
			}
			@Override
			public Adapter caseSubDiagram(SubDiagram object) {
				return createSubDiagramAdapter();
			}
			@Override
			public Adapter caseDocumentRoot(DocumentRoot object) {
				return createDocumentRootAdapter();
			}
			@Override
			public Adapter caseSAG(SAG object) {
				return createSAGAdapter();
			}
			@Override
			public Adapter caseVulnerability(Vulnerability object) {
				return createVulnerabilityAdapter();
			}
			@Override
			public Adapter caseSAGNode(SAGNode object) {
				return createSAGNodeAdapter();
			}
			@Override
			public Adapter caseOrNode(OrNode object) {
				return createOrNodeAdapter();
			}
			@Override
			public Adapter caseSagAndNode(SagAndNode object) {
				return createSagAndNodeAdapter();
			}
			@Override
			public Adapter caseSplitNode(SplitNode object) {
				return createSplitNodeAdapter();
			}
			@Override
			public Adapter caseActivityNode(ActivityNode object) {
				return createActivityNodeAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.SecurityModel <em>Security Model</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.SecurityModel
	 * @generated
	 */
	public Adapter createSecurityModelAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.AttackTree <em>Attack Tree</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.AttackTree
	 * @generated
	 */
	public Adapter createAttackTreeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.VCG <em>VCG</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.VCG
	 * @generated
	 */
	public Adapter createVCGAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.MisuseCase <em>Misuse Case</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.MisuseCase
	 * @generated
	 */
	public Adapter createMisuseCaseAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.AttackTreeComponent <em>Attack Tree Component</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.AttackTreeComponent
	 * @generated
	 */
	public Adapter createAttackTreeComponentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.AndNode <em>And Node</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.AndNode
	 * @generated
	 */
	public Adapter createAndNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.GoalNode <em>Goal Node</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.GoalNode
	 * @generated
	 */
	public Adapter createGoalNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.Node <em>Node</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.Node
	 * @generated
	 */
	public Adapter createNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.ExitNode <em>Exit Node</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.ExitNode
	 * @generated
	 */
	public Adapter createExitNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.CauseNode <em>Cause Node</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.CauseNode
	 * @generated
	 */
	public Adapter createCauseNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.CompoundNode <em>Compound Node</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.CompoundNode
	 * @generated
	 */
	public Adapter createCompoundNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.SimpleNode <em>Simple Node</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.SimpleNode
	 * @generated
	 */
	public Adapter createSimpleNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.ConjunctionNode <em>Conjunction Node</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.ConjunctionNode
	 * @generated
	 */
	public Adapter createConjunctionNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.GoodActor <em>Good Actor</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.GoodActor
	 * @generated
	 */
	public Adapter createGoodActorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.BadActor <em>Bad Actor</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.BadActor
	 * @generated
	 */
	public Adapter createBadActorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.InsiderActor <em>Insider Actor</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.InsiderActor
	 * @generated
	 */
	public Adapter createInsiderActorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.Actor <em>Actor</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.Actor
	 * @generated
	 */
	public Adapter createActorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.UseCase <em>Use Case</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.UseCase
	 * @generated
	 */
	public Adapter createUseCaseAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.NormalCase <em>Normal Case</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.NormalCase
	 * @generated
	 */
	public Adapter createNormalCaseAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.ThreatCase <em>Threat Case</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.ThreatCase
	 * @generated
	 */
	public Adapter createThreatCaseAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.VulnerabilityCase <em>Vulnerability Case</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.VulnerabilityCase
	 * @generated
	 */
	public Adapter createVulnerabilityCaseAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.SystemBox <em>System Box</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.SystemBox
	 * @generated
	 */
	public Adapter createSystemBoxAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.SubDiagram <em>Sub Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.SubDiagram
	 * @generated
	 */
	public Adapter createSubDiagramAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.DocumentRoot <em>Document Root</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.DocumentRoot
	 * @generated
	 */
	public Adapter createDocumentRootAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.SAG <em>SAG</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.SAG
	 * @generated
	 */
	public Adapter createSAGAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.Vulnerability <em>Vulnerability</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.Vulnerability
	 * @generated
	 */
	public Adapter createVulnerabilityAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.SAGNode <em>SAG Node</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.SAGNode
	 * @generated
	 */
	public Adapter createSAGNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.ActivityNode <em>Activity Node</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.ActivityNode
	 * @generated
	 */
	public Adapter createActivityNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.OrNode <em>Or Node</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.OrNode
	 * @generated
	 */
	public Adapter createOrNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.SagAndNode <em>Sag And Node</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.SagAndNode
	 * @generated
	 */
	public Adapter createSagAndNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link SeaMonster.SplitNode <em>Split Node</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see SeaMonster.SplitNode
	 * @generated
	 */
	public Adapter createSplitNodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //SeaMonsterAdapterFactory
