/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package SeaMonster.util;

import SeaMonster.*;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see SeaMonster.SeaMonsterPackage
 * @generated
 */
public class SeaMonsterSwitch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static SeaMonsterPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SeaMonsterSwitch() {
		if (modelPackage == null) {
			modelPackage = SeaMonsterPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public T doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List<EClass> eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch(eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case SeaMonsterPackage.SECURITY_MODEL: {
				SecurityModel securityModel = (SecurityModel)theEObject;
				T result = caseSecurityModel(securityModel);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.ATTACK_TREE: {
				AttackTree attackTree = (AttackTree)theEObject;
				T result = caseAttackTree(attackTree);
				if (result == null) result = caseSubDiagram(attackTree);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.VCG: {
				VCG vcg = (VCG)theEObject;
				T result = caseVCG(vcg);
				if (result == null) result = caseSubDiagram(vcg);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.MISUSE_CASE: {
				MisuseCase misuseCase = (MisuseCase)theEObject;
				T result = caseMisuseCase(misuseCase);
				if (result == null) result = caseSubDiagram(misuseCase);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.ATTACK_TREE_COMPONENT: {
				AttackTreeComponent attackTreeComponent = (AttackTreeComponent)theEObject;
				T result = caseAttackTreeComponent(attackTreeComponent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.AND_NODE: {
				AndNode andNode = (AndNode)theEObject;
				T result = caseAndNode(andNode);
				if (result == null) result = caseAttackTreeComponent(andNode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.GOAL_NODE: {
				GoalNode goalNode = (GoalNode)theEObject;
				T result = caseGoalNode(goalNode);
				if (result == null) result = caseAttackTreeComponent(goalNode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.NODE: {
				Node node = (Node)theEObject;
				T result = caseNode(node);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.EXIT_NODE: {
				ExitNode exitNode = (ExitNode)theEObject;
				T result = caseExitNode(exitNode);
				if (result == null) result = caseNode(exitNode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.CAUSE_NODE: {
				CauseNode causeNode = (CauseNode)theEObject;
				T result = caseCauseNode(causeNode);
				if (result == null) result = caseNode(causeNode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.COMPOUND_NODE: {
				CompoundNode compoundNode = (CompoundNode)theEObject;
				T result = caseCompoundNode(compoundNode);
				if (result == null) result = caseCauseNode(compoundNode);
				if (result == null) result = caseNode(compoundNode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.SIMPLE_NODE: {
				SimpleNode simpleNode = (SimpleNode)theEObject;
				T result = caseSimpleNode(simpleNode);
				if (result == null) result = caseCauseNode(simpleNode);
				if (result == null) result = caseNode(simpleNode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.CONJUNCTION_NODE: {
				ConjunctionNode conjunctionNode = (ConjunctionNode)theEObject;
				T result = caseConjunctionNode(conjunctionNode);
				if (result == null) result = caseCauseNode(conjunctionNode);
				if (result == null) result = caseNode(conjunctionNode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.GOOD_ACTOR: {
				GoodActor goodActor = (GoodActor)theEObject;
				T result = caseGoodActor(goodActor);
				if (result == null) result = caseActor(goodActor);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.BAD_ACTOR: {
				BadActor badActor = (BadActor)theEObject;
				T result = caseBadActor(badActor);
				if (result == null) result = caseActor(badActor);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.INSIDER_ACTOR: {
				InsiderActor insiderActor = (InsiderActor)theEObject;
				T result = caseInsiderActor(insiderActor);
				if (result == null) result = caseActor(insiderActor);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.ACTOR: {
				Actor actor = (Actor)theEObject;
				T result = caseActor(actor);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.USE_CASE: {
				UseCase useCase = (UseCase)theEObject;
				T result = caseUseCase(useCase);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.NORMAL_CASE: {
				NormalCase normalCase = (NormalCase)theEObject;
				T result = caseNormalCase(normalCase);
				if (result == null) result = caseUseCase(normalCase);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.THREAT_CASE: {
				ThreatCase threatCase = (ThreatCase)theEObject;
				T result = caseThreatCase(threatCase);
				if (result == null) result = caseUseCase(threatCase);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.VULNERABILITY_CASE: {
				VulnerabilityCase vulnerabilityCase = (VulnerabilityCase)theEObject;
				T result = caseVulnerabilityCase(vulnerabilityCase);
				if (result == null) result = caseNormalCase(vulnerabilityCase);
				if (result == null) result = caseUseCase(vulnerabilityCase);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.SYSTEM_BOX: {
				SystemBox systemBox = (SystemBox)theEObject;
				T result = caseSystemBox(systemBox);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.SUB_DIAGRAM: {
				SubDiagram subDiagram = (SubDiagram)theEObject;
				T result = caseSubDiagram(subDiagram);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.DOCUMENT_ROOT: {
				DocumentRoot documentRoot = (DocumentRoot)theEObject;
				T result = caseDocumentRoot(documentRoot);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.SAG: {
				SAG sag = (SAG)theEObject;
				T result = caseSAG(sag);
				if (result == null) result = caseSubDiagram(sag);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.VULNERABILITY: {
				Vulnerability vulnerability = (Vulnerability)theEObject;
				T result = caseVulnerability(vulnerability);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.SAG_NODE: {
				SAGNode sagNode = (SAGNode)theEObject;
				T result = caseSAGNode(sagNode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.OR_NODE: {
				OrNode orNode = (OrNode)theEObject;
				T result = caseOrNode(orNode);
				if (result == null) result = caseSAGNode(orNode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.SAG_AND_NODE: {
				SagAndNode sagAndNode = (SagAndNode)theEObject;
				T result = caseSagAndNode(sagAndNode);
				if (result == null) result = caseSAGNode(sagAndNode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.SPLIT_NODE: {
				SplitNode splitNode = (SplitNode)theEObject;
				T result = caseSplitNode(splitNode);
				if (result == null) result = caseSAGNode(splitNode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SeaMonsterPackage.ACTIVITY_NODE: {
				ActivityNode activityNode = (ActivityNode)theEObject;
				T result = caseActivityNode(activityNode);
				if (result == null) result = caseSAGNode(activityNode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Security Model</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Security Model</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSecurityModel(SecurityModel object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Attack Tree</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Attack Tree</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAttackTree(AttackTree object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>VCG</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>VCG</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseVCG(VCG object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Misuse Case</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Misuse Case</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMisuseCase(MisuseCase object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Attack Tree Component</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Attack Tree Component</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAttackTreeComponent(AttackTreeComponent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>And Node</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>And Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAndNode(AndNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Goal Node</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Goal Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGoalNode(GoalNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Node</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNode(Node object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Exit Node</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Exit Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseExitNode(ExitNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Cause Node</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Cause Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCauseNode(CauseNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Compound Node</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Compound Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCompoundNode(CompoundNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Simple Node</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Simple Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSimpleNode(SimpleNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Conjunction Node</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Conjunction Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseConjunctionNode(ConjunctionNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Good Actor</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Good Actor</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGoodActor(GoodActor object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Bad Actor</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Bad Actor</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseBadActor(BadActor object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Insider Actor</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Insider Actor</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseInsiderActor(InsiderActor object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Actor</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Actor</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseActor(Actor object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Use Case</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Use Case</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseUseCase(UseCase object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Normal Case</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Normal Case</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNormalCase(NormalCase object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Threat Case</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Threat Case</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseThreatCase(ThreatCase object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Vulnerability Case</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Vulnerability Case</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseVulnerabilityCase(VulnerabilityCase object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>System Box</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>System Box</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSystemBox(SystemBox object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Sub Diagram</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Sub Diagram</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSubDiagram(SubDiagram object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Document Root</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Document Root</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDocumentRoot(DocumentRoot object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SAG</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SAG</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSAG(SAG object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Vulnerability</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Vulnerability</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseVulnerability(Vulnerability object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>SAG Node</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>SAG Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSAGNode(SAGNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Activity Node</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Activity Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseActivityNode(ActivityNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Or Node</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Or Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseOrNode(OrNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Sag And Node</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Sag And Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSagAndNode(SagAndNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Split Node</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Split Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSplitNode(SplitNode object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public T defaultCase(EObject object) {
		return null;
	}

} //SeaMonsterSwitch
