package misusecase.diagram.edit.parts;

import misusecase.diagram.part.SeaMonsterVisualIDRegistry;

import org.eclipse.draw2d.FigureUtilities;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrapLabel;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Text;

/**
 * @generated
 */
public class SeaMonsterEditPartFactory implements EditPartFactory {

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			switch (SeaMonsterVisualIDRegistry.getVisualID(view)) {

			case MisuseCaseEditPart.VISUAL_ID:
				return new MisuseCaseEditPart(view);

			case ThreatCaseEditPart.VISUAL_ID:
				return new ThreatCaseEditPart(view);

			case ThreatCaseNameEditPart.VISUAL_ID:
				return new ThreatCaseNameEditPart(view);

			case VulnerabilityCaseEditPart.VISUAL_ID:
				return new VulnerabilityCaseEditPart(view);

			case VulnerabilityCaseNameEditPart.VISUAL_ID:
				return new VulnerabilityCaseNameEditPart(view);

			case SystemBoxEditPart.VISUAL_ID:
				return new SystemBoxEditPart(view);

			case LabelEditPart.VISUAL_ID:
				return new LabelEditPart(view);

			case GoodActorEditPart.VISUAL_ID:
				return new GoodActorEditPart(view);

			case GoodActorNameEditPart.VISUAL_ID:
				return new GoodActorNameEditPart(view);

			case InsiderActorEditPart.VISUAL_ID:
				return new InsiderActorEditPart(view);

			case InsiderActorNameEditPart.VISUAL_ID:
				return new InsiderActorNameEditPart(view);

			case BadActorEditPart.VISUAL_ID:
				return new BadActorEditPart(view);

			case BadActorNameEditPart.VISUAL_ID:
				return new BadActorNameEditPart(view);

			case NormalCaseEditPart.VISUAL_ID:
				return new NormalCaseEditPart(view);

			case NormalCaseNameEditPart.VISUAL_ID:
				return new NormalCaseNameEditPart(view);

			case VulnerabilityCase2EditPart.VISUAL_ID:
				return new VulnerabilityCase2EditPart(view);

			case NormalCaseName2EditPart.VISUAL_ID:
				return new NormalCaseName2EditPart(view);

			case NormalCase2EditPart.VISUAL_ID:
				return new NormalCase2EditPart(view);

			case ThreatCaseName2EditPart.VISUAL_ID:
				return new ThreatCaseName2EditPart(view);

			case ThreatCase2EditPart.VISUAL_ID:
				return new ThreatCase2EditPart(view);

			case VulnerabilityCaseName2EditPart.VISUAL_ID:
				return new VulnerabilityCaseName2EditPart(view);

			case SystemBoxSystemCompartmentEditPart.VISUAL_ID:
				return new SystemBoxSystemCompartmentEditPart(view);

			case NormalCaseMitigatesEditPart.VISUAL_ID:
				return new NormalCaseMitigatesEditPart(view);

			case WrapLabelEditPart.VISUAL_ID:
				return new WrapLabelEditPart(view);

			case NormalCaseIncludesEditPart.VISUAL_ID:
				return new NormalCaseIncludesEditPart(view);

			case WrapLabel2EditPart.VISUAL_ID:
				return new WrapLabel2EditPart(view);

			case GoodActorUsesEditPart.VISUAL_ID:
				return new GoodActorUsesEditPart(view);

			case InsiderActorUsesEditPart.VISUAL_ID:
				return new InsiderActorUsesEditPart(view);

			case NormalCaseMitigates2EditPart.VISUAL_ID:
				return new NormalCaseMitigates2EditPart(view);

			case WrapLabel3EditPart.VISUAL_ID:
				return new WrapLabel3EditPart(view);

			case ThreatCaseExploitsEditPart.VISUAL_ID:
				return new ThreatCaseExploitsEditPart(view);

			case WrapLabel4EditPart.VISUAL_ID:
				return new WrapLabel4EditPart(view);

			case NormalCaseExtendsEditPart.VISUAL_ID:
				return new NormalCaseExtendsEditPart(view);

			case WrapLabel5EditPart.VISUAL_ID:
				return new WrapLabel5EditPart(view);

			case BadActorActsInEditPart.VISUAL_ID:
				return new BadActorActsInEditPart(view);

			case ThreatCaseThreatenEditPart.VISUAL_ID:
				return new ThreatCaseThreatenEditPart(view);

			case WrapLabel6EditPart.VISUAL_ID:
				return new WrapLabel6EditPart(view);

			case NormalCaseGeneralizationEditPart.VISUAL_ID:
				return new NormalCaseGeneralizationEditPart(view);

			case NormalCasePreventVulEditPart.VISUAL_ID:
				return new NormalCasePreventVulEditPart(view);

			case WrapLabel7EditPart.VISUAL_ID:
				return new WrapLabel7EditPart(view);

			case NormalCaseDetectVulEditPart.VISUAL_ID:
				return new NormalCaseDetectVulEditPart(view);

			case WrapLabel8EditPart.VISUAL_ID:
				return new WrapLabel8EditPart(view);
			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	 * @generated
	 */
	public static CellEditorLocator getTextCellEditorLocator(
			ITextAwareEditPart source) {
		if (source.getFigure() instanceof WrapLabel)
			return new TextCellEditorLocator((WrapLabel) source.getFigure());
		else {
			return new LabelCellEditorLocator((Label) source.getFigure());
		}
	}

	/**
	 * @generated
	 */
	static private class TextCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private WrapLabel wrapLabel;

		/**
		 * @generated
		 */
		public TextCellEditorLocator(WrapLabel wrapLabel) {
			this.wrapLabel = wrapLabel;
		}

		/**
		 * @generated
		 */
		public WrapLabel getWrapLabel() {
			return wrapLabel;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getWrapLabel().getTextBounds().getCopy();
			getWrapLabel().translateToAbsolute(rect);
			if (getWrapLabel().isTextWrapped()
					&& getWrapLabel().getText().length() > 0) {
				rect.setSize(new Dimension(text.computeSize(rect.width,
						SWT.DEFAULT)));
			} else {
				int avr = FigureUtilities.getFontMetrics(text.getFont())
						.getAverageCharWidth();
				rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
						SWT.DEFAULT)).expand(avr * 2, 0));
			}
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}

	}

	/**
	 * @generated
	 */
	private static class LabelCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private Label label;

		/**
		 * @generated
		 */
		public LabelCellEditorLocator(Label label) {
			this.label = label;
		}

		/**
		 * @generated
		 */
		public Label getLabel() {
			return label;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getLabel().getTextBounds().getCopy();
			getLabel().translateToAbsolute(rect);
			int avr = FigureUtilities.getFontMetrics(text.getFont())
					.getAverageCharWidth();
			rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
					SWT.DEFAULT)).expand(avr * 2, 0));
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}
	}
}
