package misusecase.diagram.edit.policies;

import misusecase.diagram.edit.commands.BadActorActsInCreateCommand;
import misusecase.diagram.edit.commands.BadActorActsInReorientCommand;
import misusecase.diagram.edit.commands.InsiderActorUsesCreateCommand;
import misusecase.diagram.edit.commands.InsiderActorUsesReorientCommand;
import misusecase.diagram.edit.commands.NormalCaseMitigates2CreateCommand;
import misusecase.diagram.edit.commands.NormalCaseMitigates2ReorientCommand;
import misusecase.diagram.edit.commands.NormalCaseMitigatesCreateCommand;
import misusecase.diagram.edit.commands.NormalCaseMitigatesReorientCommand;
import misusecase.diagram.edit.commands.ThreatCaseExploitsCreateCommand;
import misusecase.diagram.edit.commands.ThreatCaseExploitsReorientCommand;
import misusecase.diagram.edit.commands.ThreatCaseThreatenCreateCommand;
import misusecase.diagram.edit.commands.ThreatCaseThreatenReorientCommand;
import misusecase.diagram.edit.parts.BadActorActsInEditPart;
import misusecase.diagram.edit.parts.InsiderActorUsesEditPart;
import misusecase.diagram.edit.parts.NormalCaseMitigates2EditPart;
import misusecase.diagram.edit.parts.NormalCaseMitigatesEditPart;
import misusecase.diagram.edit.parts.ThreatCaseExploitsEditPart;
import misusecase.diagram.edit.parts.ThreatCaseThreatenEditPart;
import misusecase.diagram.providers.SeaMonsterElementTypes;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.notation.View;

/**
 * @generated
 */
public class ThreatCaseItemSemanticEditPolicy extends
		SeaMonsterBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		CompoundCommand cc = getDestroyEdgesCommand();
		addDestroyShortcutsCommand(cc);
		View view = (View) getHost().getModel();
		if (view.getEAnnotation("Shortcut") != null) { //$NON-NLS-1$
			req.setElementToDestroy(view);
		}
		cc.add(getGEFWrapper(new DestroyElementCommand(req)));
		return cc.unwrap();
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		Command command = req.getTarget() == null ? getStartCreateRelationshipCommand(req)
				: getCompleteCreateRelationshipCommand(req);
		return command != null ? command : super
				.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getStartCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (SeaMonsterElementTypes.NormalCasePrevents_3001 == req
				.getElementType()) {
			return null;
		}
		if (SeaMonsterElementTypes.InsiderActorUses_3004 == req
				.getElementType()) {
			return null;
		}
		if (SeaMonsterElementTypes.NormalCaseDetects_3005 == req
				.getElementType()) {
			return null;
		}
		if (SeaMonsterElementTypes.ThreatCaseExploits_3006 == req
				.getElementType()) {
			return getGEFWrapper(new ThreatCaseExploitsCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (SeaMonsterElementTypes.BadActorActsIn_3008 == req.getElementType()) {
			return null;
		}
		if (SeaMonsterElementTypes.ThreatCaseThreaten_3009 == req
				.getElementType()) {
			return getGEFWrapper(new ThreatCaseThreatenCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCompleteCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (SeaMonsterElementTypes.NormalCasePrevents_3001 == req
				.getElementType()) {
			return getGEFWrapper(new NormalCaseMitigatesCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (SeaMonsterElementTypes.InsiderActorUses_3004 == req
				.getElementType()) {
			return getGEFWrapper(new InsiderActorUsesCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (SeaMonsterElementTypes.NormalCaseDetects_3005 == req
				.getElementType()) {
			return getGEFWrapper(new NormalCaseMitigates2CreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (SeaMonsterElementTypes.ThreatCaseExploits_3006 == req
				.getElementType()) {
			return null;
		}
		if (SeaMonsterElementTypes.BadActorActsIn_3008 == req.getElementType()) {
			return getGEFWrapper(new BadActorActsInCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (SeaMonsterElementTypes.ThreatCaseThreaten_3009 == req
				.getElementType()) {
			return null;
		}
		return null;
	}

	/**
	 * Returns command to reorient EReference based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientReferenceRelationshipCommand(
			ReorientReferenceRelationshipRequest req) {
		switch (getVisualID(req)) {
		case NormalCaseMitigatesEditPart.VISUAL_ID:
			return getGEFWrapper(new NormalCaseMitigatesReorientCommand(req));
		case InsiderActorUsesEditPart.VISUAL_ID:
			return getGEFWrapper(new InsiderActorUsesReorientCommand(req));
		case NormalCaseMitigates2EditPart.VISUAL_ID:
			return getGEFWrapper(new NormalCaseMitigates2ReorientCommand(req));
		case ThreatCaseExploitsEditPart.VISUAL_ID:
			return getGEFWrapper(new ThreatCaseExploitsReorientCommand(req));
		case BadActorActsInEditPart.VISUAL_ID:
			return getGEFWrapper(new BadActorActsInReorientCommand(req));
		case ThreatCaseThreatenEditPart.VISUAL_ID:
			return getGEFWrapper(new ThreatCaseThreatenReorientCommand(req));
		}
		return super.getReorientReferenceRelationshipCommand(req);
	}

}
