package misusecase.diagram.part;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import misusecase.diagram.providers.SeaMonsterElementTypes;

import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.MarqueeToolEntry;
import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.palette.PaletteEntry;
import org.eclipse.gef.palette.PaletteGroup;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.PanningSelectionToolEntry;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeConnectionTool;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeCreationTool;

/**
 * @generated
 */
public class SeaMonsterPaletteFactory {

	/**
	 * @generated
	 */
	public void fillPalette(PaletteRoot paletteRoot) {
		paletteRoot.add(createAttackTree1Group());
	}

	/**
	 * Creates "AttackTree" palette tool group
	 * @generated
	 */
	private PaletteContainer createAttackTree1Group() {
		PaletteGroup paletteContainer = new PaletteGroup(
				Messages.AttackTree1Group_title);
		paletteContainer.setDescription(Messages.AttackTree1Group_desc);
		paletteContainer.add(createActors1Group());
		paletteContainer.add(createUseCases2Group());
		paletteContainer.add(createLinks3Group());
		paletteContainer.add(createSystemBox4CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "Actors" palette tool group
	 * @generated
	 */
	private PaletteContainer createActors1Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.Actors1Group_title);
		paletteContainer.setDescription(Messages.Actors1Group_desc);
		paletteContainer.add(createActor1CreationTool());
		paletteContainer.add(createCrook2CreationTool());
		paletteContainer.add(createInsider3CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "Use Cases" palette tool group
	 * @generated
	 */
	private PaletteContainer createUseCases2Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.UseCases2Group_title);
		paletteContainer.add(createUseCase1CreationTool());
		paletteContainer.add(createThreat2CreationTool());
		paletteContainer.add(createVulnerability3CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "Links" palette tool group
	 * @generated
	 */
	private PaletteContainer createLinks3Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.Links3Group_title);
		paletteContainer.add(createUse1CreationTool());
		paletteContainer.add(createGeneralize2CreationTool());
		paletteContainer.add(createInclude3CreationTool());
		paletteContainer.add(createExtend4CreationTool());
		paletteContainer.add(createPrevent5CreationTool());
		paletteContainer.add(createDetect6CreationTool());
		paletteContainer.add(createExploit7CreationTool());
		paletteContainer.add(createThreaten8CreationTool());
		return paletteContainer;
	}

	/**
	 * @generated
	 */
	private ToolEntry createSystemBox4CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.SystemBox_1003);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.SystemBox4CreationTool_title,
				Messages.SystemBox4CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.misuseCase/images/misuse-system.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createActor1CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.GoodActor_1004);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Actor1CreationTool_title,
				Messages.Actor1CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.misuseCase/images/misuse-user.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCrook2CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.BadActor_1006);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Crook2CreationTool_title,
				Messages.Crook2CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.misuseCase/images/misuse-badguy.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createInsider3CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.InsiderActor_1005);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Insider3CreationTool_title,
				Messages.Insider3CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.misuseCase/images/misuse-greyguy.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createUseCase1CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(2);
		types.add(SeaMonsterElementTypes.NormalCase_2002);
		types.add(SeaMonsterElementTypes.NormalCase_1007);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.UseCase1CreationTool_title,
				Messages.UseCase1CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.misuseCase/images/misuse-case.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createThreat2CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(2);
		types.add(SeaMonsterElementTypes.ThreatCase_1001);
		types.add(SeaMonsterElementTypes.ThreatCase_2003);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Threat2CreationTool_title,
				Messages.Threat2CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.misuseCase/images/misuse-casethreatattack.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createVulnerability3CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(2);
		types.add(SeaMonsterElementTypes.VulnerabilityCase_1002);
		types.add(SeaMonsterElementTypes.VulnerabilityCase_2001);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Vulnerability3CreationTool_title,
				Messages.Vulnerability3CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.misuseCase/images/misuse-casevulnerability.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createUse1CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(3);
		types.add(SeaMonsterElementTypes.GoodActorUses_3003);
		types.add(SeaMonsterElementTypes.InsiderActorUses_3004);
		types.add(SeaMonsterElementTypes.BadActorActsIn_3008);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Use1CreationTool_title,
				Messages.Use1CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.misuseCase/images/misuse-usesline.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createGeneralize2CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.NormalCaseGeneralization_3010);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Generalize2CreationTool_title,
				Messages.Generalize2CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.misuseCase/images/misuse-generalization.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createInclude3CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.NormalCaseIncludes_3002);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Include3CreationTool_title,
				Messages.Include3CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.misuseCase/images/misuse-dottedline.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createExtend4CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.NormalCaseExtends_3007);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Extend4CreationTool_title,
				Messages.Extend4CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.misuseCase/images/misuse-dottedline.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createPrevent5CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(2);
		types.add(SeaMonsterElementTypes.NormalCasePrevents_3001);
		types.add(SeaMonsterElementTypes.NormalCasePreventVul_3011);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Prevent5CreationTool_title,
				Messages.Prevent5CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.misuseCase/images/misuse-dottedline.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createDetect6CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(2);
		types.add(SeaMonsterElementTypes.NormalCaseDetects_3005);
		types.add(SeaMonsterElementTypes.NormalCaseDetectVul_3012);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Detect6CreationTool_title, null, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.misuseCase/images/misuse-dottedline.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createExploit7CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.ThreatCaseExploits_3006);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Exploit7CreationTool_title,
				Messages.Exploit7CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.misuseCase/images/misuse-dottedline.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createThreaten8CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(SeaMonsterElementTypes.ThreatCaseThreaten_3009);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Threaten8CreationTool_title,
				Messages.Threaten8CreationTool_desc, types);
		entry
				.setSmallIcon(SeaMonsterDiagramEditorPlugin
						.findImageDescriptor("/seaMonster.misuseCase/images/misuse-dottedline.png")); //$NON-NLS-1$
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private static class NodeToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List elementTypes;

		/**
		 * @generated
		 */
		private NodeToolEntry(String title, String description,
				List elementTypes) {
			super(title, description, null, null);
			this.elementTypes = elementTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeCreationTool(elementTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}

	/**
	 * @generated
	 */
	private static class LinkToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List relationshipTypes;

		/**
		 * @generated
		 */
		private LinkToolEntry(String title, String description,
				List relationshipTypes) {
			super(title, description, null, null);
			this.relationshipTypes = relationshipTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeConnectionTool(relationshipTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}
}
