package misusecase.diagram.part;

import misusecase.diagram.edit.parts.BadActorEditPart;
import misusecase.diagram.edit.parts.BadActorNameEditPart;
import misusecase.diagram.edit.parts.GoodActorEditPart;
import misusecase.diagram.edit.parts.GoodActorNameEditPart;
import misusecase.diagram.edit.parts.InsiderActorEditPart;
import misusecase.diagram.edit.parts.InsiderActorNameEditPart;
import misusecase.diagram.edit.parts.LabelEditPart;
import misusecase.diagram.edit.parts.MisuseCaseEditPart;
import misusecase.diagram.edit.parts.ThreatCase2EditPart;
import misusecase.diagram.edit.parts.NormalCaseDetectVulEditPart;
import misusecase.diagram.edit.parts.NormalCaseEditPart;
import misusecase.diagram.edit.parts.NormalCaseExtendsEditPart;
import misusecase.diagram.edit.parts.NormalCaseIncludesEditPart;
import misusecase.diagram.edit.parts.NormalCaseMitigates2EditPart;
import misusecase.diagram.edit.parts.NormalCaseMitigatesEditPart;
import misusecase.diagram.edit.parts.NormalCaseName2EditPart;
import misusecase.diagram.edit.parts.NormalCaseNameEditPart;
import misusecase.diagram.edit.parts.NormalCasePreventVulEditPart;
import misusecase.diagram.edit.parts.SystemBoxEditPart;
import misusecase.diagram.edit.parts.SystemBoxSystemCompartmentEditPart;
import misusecase.diagram.edit.parts.VulnerabilityCase2EditPart;
import misusecase.diagram.edit.parts.ThreatCaseEditPart;
import misusecase.diagram.edit.parts.ThreatCaseExploitsEditPart;
import misusecase.diagram.edit.parts.ThreatCaseName2EditPart;
import misusecase.diagram.edit.parts.ThreatCaseNameEditPart;
import misusecase.diagram.edit.parts.ThreatCaseThreatenEditPart;
import misusecase.diagram.edit.parts.NormalCase2EditPart;
import misusecase.diagram.edit.parts.VulnerabilityCaseEditPart;
import misusecase.diagram.edit.parts.VulnerabilityCaseName2EditPart;
import misusecase.diagram.edit.parts.VulnerabilityCaseNameEditPart;

import misusecase.diagram.edit.parts.WrapLabel2EditPart;
import misusecase.diagram.edit.parts.WrapLabel3EditPart;
import misusecase.diagram.edit.parts.WrapLabel4EditPart;
import misusecase.diagram.edit.parts.WrapLabel5EditPart;
import misusecase.diagram.edit.parts.WrapLabel6EditPart;
import misusecase.diagram.edit.parts.WrapLabel7EditPart;
import misusecase.diagram.edit.parts.WrapLabel8EditPart;
import misusecase.diagram.edit.parts.WrapLabelEditPart;
import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class SeaMonsterVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = SeaMonsterDiagramEditorPlugin
			.getInstance().getBundle().getSymbolicName()
			+ "/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (MisuseCaseEditPart.MODEL_ID.equals(view.getType())) {
				return MisuseCaseEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return misusecase.diagram.part.SeaMonsterVisualIDRegistry
				.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				SeaMonsterDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return String.valueOf(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (SeaMonster.SeaMonsterPackage.eINSTANCE.getMisuseCase()
				.isSuperTypeOf(domainElement.eClass())
				&& isDiagram((SeaMonster.MisuseCase) domainElement)) {
			return MisuseCaseEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null
				|| !MisuseCaseEditPart.MODEL_ID
						.equals(misusecase.diagram.part.SeaMonsterVisualIDRegistry
								.getModelID(containerView))) {
			return -1;
		}
		switch (misusecase.diagram.part.SeaMonsterVisualIDRegistry
				.getVisualID(containerView)) {
		case SystemBoxSystemCompartmentEditPart.VISUAL_ID:
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getVulnerabilityCase()
					.isSuperTypeOf(domainElement.eClass())) {
				return VulnerabilityCase2EditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getNormalCase()
					.isSuperTypeOf(domainElement.eClass())) {
				return NormalCase2EditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getThreatCase()
					.isSuperTypeOf(domainElement.eClass())) {
				return ThreatCase2EditPart.VISUAL_ID;
			}
			break;
		case MisuseCaseEditPart.VISUAL_ID:
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getThreatCase()
					.isSuperTypeOf(domainElement.eClass())) {
				return ThreatCaseEditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getVulnerabilityCase()
					.isSuperTypeOf(domainElement.eClass())) {
				return VulnerabilityCaseEditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getSystemBox()
					.isSuperTypeOf(domainElement.eClass())) {
				return SystemBoxEditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getGoodActor()
					.isSuperTypeOf(domainElement.eClass())) {
				return GoodActorEditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getInsiderActor()
					.isSuperTypeOf(domainElement.eClass())) {
				return InsiderActorEditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getBadActor()
					.isSuperTypeOf(domainElement.eClass())) {
				return BadActorEditPart.VISUAL_ID;
			}
			if (SeaMonster.SeaMonsterPackage.eINSTANCE.getNormalCase()
					.isSuperTypeOf(domainElement.eClass())) {
				return NormalCaseEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = misusecase.diagram.part.SeaMonsterVisualIDRegistry
				.getModelID(containerView);
		if (!MisuseCaseEditPart.MODEL_ID.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (MisuseCaseEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = misusecase.diagram.part.SeaMonsterVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = MisuseCaseEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case ThreatCaseEditPart.VISUAL_ID:
			if (ThreatCaseNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case VulnerabilityCaseEditPart.VISUAL_ID:
			if (VulnerabilityCaseNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SystemBoxEditPart.VISUAL_ID:
			if (LabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SystemBoxSystemCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case GoodActorEditPart.VISUAL_ID:
			if (GoodActorNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case InsiderActorEditPart.VISUAL_ID:
			if (InsiderActorNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case BadActorEditPart.VISUAL_ID:
			if (BadActorNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case NormalCaseEditPart.VISUAL_ID:
			if (NormalCaseNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case VulnerabilityCase2EditPart.VISUAL_ID:
			if (NormalCaseName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case NormalCase2EditPart.VISUAL_ID:
			if (ThreatCaseName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ThreatCase2EditPart.VISUAL_ID:
			if (VulnerabilityCaseName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SystemBoxSystemCompartmentEditPart.VISUAL_ID:
			if (VulnerabilityCase2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (NormalCase2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ThreatCase2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MisuseCaseEditPart.VISUAL_ID:
			if (ThreatCaseEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (VulnerabilityCaseEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SystemBoxEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (GoodActorEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (InsiderActorEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (BadActorEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (NormalCaseEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case NormalCaseMitigatesEditPart.VISUAL_ID:
			if (WrapLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case NormalCaseIncludesEditPart.VISUAL_ID:
			if (WrapLabel2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case NormalCaseMitigates2EditPart.VISUAL_ID:
			if (WrapLabel3EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ThreatCaseExploitsEditPart.VISUAL_ID:
			if (WrapLabel4EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case NormalCaseExtendsEditPart.VISUAL_ID:
			if (WrapLabel5EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ThreatCaseThreatenEditPart.VISUAL_ID:
			if (WrapLabel6EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case NormalCasePreventVulEditPart.VISUAL_ID:
			if (WrapLabel7EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case NormalCaseDetectVulEditPart.VISUAL_ID:
			if (WrapLabel8EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(SeaMonster.MisuseCase element) {
		return true;
	}

}
