package misusecase.diagram.providers;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import misusecase.diagram.edit.parts.BadActorEditPart;
import misusecase.diagram.edit.parts.GoodActorEditPart;
import misusecase.diagram.edit.parts.InsiderActorEditPart;
import misusecase.diagram.edit.parts.MisuseCaseEditPart;
import misusecase.diagram.edit.parts.ThreatCase2EditPart;
import misusecase.diagram.edit.parts.NormalCaseEditPart;
import misusecase.diagram.edit.parts.SystemBoxEditPart;
import misusecase.diagram.edit.parts.VulnerabilityCase2EditPart;
import misusecase.diagram.edit.parts.ThreatCaseEditPart;
import misusecase.diagram.edit.parts.NormalCase2EditPart;
import misusecase.diagram.edit.parts.VulnerabilityCaseEditPart;
import misusecase.diagram.part.Messages;
import misusecase.diagram.part.SeaMonsterDiagramEditorPlugin;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.modelingassistant.ModelingAssistantProvider;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.dialogs.ElementListSelectionDialog;

/**
 * @generated
 */
public class SeaMonsterModelingAssistantProvider extends
		ModelingAssistantProvider {

	/**
	 * @generated
	 */
	public List getTypesForPopupBar(IAdaptable host) {
		IGraphicalEditPart editPart = (IGraphicalEditPart) host
				.getAdapter(IGraphicalEditPart.class);
		if (editPart instanceof SystemBoxEditPart) {
			List types = new ArrayList();
			types.add(SeaMonsterElementTypes.VulnerabilityCase_2001);
			types.add(SeaMonsterElementTypes.NormalCase_2002);
			types.add(SeaMonsterElementTypes.ThreatCase_2003);
			return types;
		}
		if (editPart instanceof MisuseCaseEditPart) {
			List types = new ArrayList();
			types.add(SeaMonsterElementTypes.ThreatCase_1001);
			types.add(SeaMonsterElementTypes.VulnerabilityCase_1002);
			types.add(SeaMonsterElementTypes.SystemBox_1003);
			types.add(SeaMonsterElementTypes.GoodActor_1004);
			types.add(SeaMonsterElementTypes.InsiderActor_1005);
			types.add(SeaMonsterElementTypes.BadActor_1006);
			types.add(SeaMonsterElementTypes.NormalCase_1007);
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnSource(IAdaptable source) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source
				.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof ThreatCaseEditPart) {
			List types = new ArrayList();
			types.add(SeaMonsterElementTypes.ThreatCaseExploits_3006);
			types.add(SeaMonsterElementTypes.ThreatCaseThreaten_3009);
			return types;
		}
		if (sourceEditPart instanceof GoodActorEditPart) {
			List types = new ArrayList();
			types.add(SeaMonsterElementTypes.GoodActorUses_3003);
			return types;
		}
		if (sourceEditPart instanceof InsiderActorEditPart) {
			List types = new ArrayList();
			types.add(SeaMonsterElementTypes.InsiderActorUses_3004);
			return types;
		}
		if (sourceEditPart instanceof BadActorEditPart) {
			List types = new ArrayList();
			types.add(SeaMonsterElementTypes.BadActorActsIn_3008);
			return types;
		}
		if (sourceEditPart instanceof NormalCaseEditPart) {
			List types = new ArrayList();
			types.add(SeaMonsterElementTypes.NormalCasePrevents_3001);
			types.add(SeaMonsterElementTypes.NormalCaseIncludes_3002);
			types.add(SeaMonsterElementTypes.NormalCaseDetects_3005);
			types.add(SeaMonsterElementTypes.NormalCaseExtends_3007);
			types.add(SeaMonsterElementTypes.NormalCaseGeneralization_3010);
			types.add(SeaMonsterElementTypes.NormalCasePreventVul_3011);
			types.add(SeaMonsterElementTypes.NormalCaseDetectVul_3012);
			return types;
		}
		if (sourceEditPart instanceof NormalCase2EditPart) {
			List types = new ArrayList();
			types.add(SeaMonsterElementTypes.NormalCasePrevents_3001);
			types.add(SeaMonsterElementTypes.NormalCaseIncludes_3002);
			types.add(SeaMonsterElementTypes.NormalCaseDetects_3005);
			types.add(SeaMonsterElementTypes.NormalCaseExtends_3007);
			types.add(SeaMonsterElementTypes.NormalCaseGeneralization_3010);
			types.add(SeaMonsterElementTypes.NormalCasePreventVul_3011);
			types.add(SeaMonsterElementTypes.NormalCaseDetectVul_3012);
			return types;
		}
		if (sourceEditPart instanceof ThreatCase2EditPart) {
			List types = new ArrayList();
			types.add(SeaMonsterElementTypes.ThreatCaseExploits_3006);
			types.add(SeaMonsterElementTypes.ThreatCaseThreaten_3009);
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnTarget(IAdaptable target) {
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target
				.getAdapter(IGraphicalEditPart.class);
		if (targetEditPart instanceof ThreatCaseEditPart) {
			List types = new ArrayList();
			types.add(SeaMonsterElementTypes.NormalCasePrevents_3001);
			types.add(SeaMonsterElementTypes.NormalCaseDetects_3005);
			types.add(SeaMonsterElementTypes.BadActorActsIn_3008);
			return types;
		}
		if (targetEditPart instanceof VulnerabilityCaseEditPart) {
			List types = new ArrayList();
			types.add(SeaMonsterElementTypes.ThreatCaseExploits_3006);
			types.add(SeaMonsterElementTypes.NormalCasePreventVul_3011);
			types.add(SeaMonsterElementTypes.NormalCaseDetectVul_3012);
			return types;
		}
		if (targetEditPart instanceof NormalCaseEditPart) {
			List types = new ArrayList();
			types.add(SeaMonsterElementTypes.NormalCaseIncludes_3002);
			types.add(SeaMonsterElementTypes.GoodActorUses_3003);
			types.add(SeaMonsterElementTypes.NormalCaseExtends_3007);
			types.add(SeaMonsterElementTypes.ThreatCaseThreaten_3009);
			types.add(SeaMonsterElementTypes.NormalCaseGeneralization_3010);
			return types;
		}
		if (targetEditPart instanceof VulnerabilityCase2EditPart) {
			List types = new ArrayList();
			types.add(SeaMonsterElementTypes.ThreatCaseExploits_3006);
			types.add(SeaMonsterElementTypes.NormalCasePreventVul_3011);
			types.add(SeaMonsterElementTypes.NormalCaseDetectVul_3012);
			return types;
		}
		if (targetEditPart instanceof NormalCase2EditPart) {
			List types = new ArrayList();
			types.add(SeaMonsterElementTypes.NormalCaseIncludes_3002);
			types.add(SeaMonsterElementTypes.GoodActorUses_3003);
			types.add(SeaMonsterElementTypes.NormalCaseExtends_3007);
			types.add(SeaMonsterElementTypes.ThreatCaseThreaten_3009);
			types.add(SeaMonsterElementTypes.NormalCaseGeneralization_3010);
			return types;
		}
		if (targetEditPart instanceof ThreatCase2EditPart) {
			List types = new ArrayList();
			types.add(SeaMonsterElementTypes.NormalCasePrevents_3001);
			types.add(SeaMonsterElementTypes.NormalCaseDetects_3005);
			types.add(SeaMonsterElementTypes.BadActorActsIn_3008);
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnSourceAndTarget(IAdaptable source,
			IAdaptable target) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source
				.getAdapter(IGraphicalEditPart.class);
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target
				.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof ThreatCaseEditPart) {
			List types = new ArrayList();
			if (targetEditPart instanceof VulnerabilityCaseEditPart) {
				types.add(SeaMonsterElementTypes.ThreatCaseExploits_3006);
			}
			if (targetEditPart instanceof VulnerabilityCase2EditPart) {
				types.add(SeaMonsterElementTypes.ThreatCaseExploits_3006);
			}
			if (targetEditPart instanceof NormalCaseEditPart) {
				types.add(SeaMonsterElementTypes.ThreatCaseThreaten_3009);
			}
			if (targetEditPart instanceof NormalCase2EditPart) {
				types.add(SeaMonsterElementTypes.ThreatCaseThreaten_3009);
			}
			return types;
		}
		if (sourceEditPart instanceof GoodActorEditPart) {
			List types = new ArrayList();
			if (targetEditPart instanceof NormalCaseEditPart) {
				types.add(SeaMonsterElementTypes.GoodActorUses_3003);
			}
			if (targetEditPart instanceof NormalCase2EditPart) {
				types.add(SeaMonsterElementTypes.GoodActorUses_3003);
			}
			return types;
		}
		if (sourceEditPart instanceof InsiderActorEditPart) {
			List types = new ArrayList();
			return types;
		}
		if (sourceEditPart instanceof BadActorEditPart) {
			List types = new ArrayList();
			if (targetEditPart instanceof ThreatCaseEditPart) {
				types.add(SeaMonsterElementTypes.BadActorActsIn_3008);
			}
			if (targetEditPart instanceof ThreatCase2EditPart) {
				types.add(SeaMonsterElementTypes.BadActorActsIn_3008);
			}
			return types;
		}
		if (sourceEditPart instanceof NormalCaseEditPart) {
			List types = new ArrayList();
			if (targetEditPart instanceof ThreatCaseEditPart) {
				types.add(SeaMonsterElementTypes.NormalCasePrevents_3001);
			}
			if (targetEditPart instanceof ThreatCase2EditPart) {
				types.add(SeaMonsterElementTypes.NormalCasePrevents_3001);
			}
			if (targetEditPart instanceof NormalCaseEditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseIncludes_3002);
			}
			if (targetEditPart instanceof NormalCase2EditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseIncludes_3002);
			}
			if (targetEditPart instanceof ThreatCaseEditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseDetects_3005);
			}
			if (targetEditPart instanceof ThreatCase2EditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseDetects_3005);
			}
			if (targetEditPart instanceof NormalCaseEditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseExtends_3007);
			}
			if (targetEditPart instanceof NormalCase2EditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseExtends_3007);
			}
			if (targetEditPart instanceof NormalCaseEditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseGeneralization_3010);
			}
			if (targetEditPart instanceof NormalCase2EditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseGeneralization_3010);
			}
			if (targetEditPart instanceof VulnerabilityCaseEditPart) {
				types.add(SeaMonsterElementTypes.NormalCasePreventVul_3011);
			}
			if (targetEditPart instanceof VulnerabilityCase2EditPart) {
				types.add(SeaMonsterElementTypes.NormalCasePreventVul_3011);
			}
			if (targetEditPart instanceof VulnerabilityCaseEditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseDetectVul_3012);
			}
			if (targetEditPart instanceof VulnerabilityCase2EditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseDetectVul_3012);
			}
			return types;
		}
		if (sourceEditPart instanceof NormalCase2EditPart) {
			List types = new ArrayList();
			if (targetEditPart instanceof ThreatCaseEditPart) {
				types.add(SeaMonsterElementTypes.NormalCasePrevents_3001);
			}
			if (targetEditPart instanceof ThreatCase2EditPart) {
				types.add(SeaMonsterElementTypes.NormalCasePrevents_3001);
			}
			if (targetEditPart instanceof NormalCaseEditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseIncludes_3002);
			}
			if (targetEditPart instanceof NormalCase2EditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseIncludes_3002);
			}
			if (targetEditPart instanceof ThreatCaseEditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseDetects_3005);
			}
			if (targetEditPart instanceof ThreatCase2EditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseDetects_3005);
			}
			if (targetEditPart instanceof NormalCaseEditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseExtends_3007);
			}
			if (targetEditPart instanceof NormalCase2EditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseExtends_3007);
			}
			if (targetEditPart instanceof NormalCaseEditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseGeneralization_3010);
			}
			if (targetEditPart instanceof NormalCase2EditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseGeneralization_3010);
			}
			if (targetEditPart instanceof VulnerabilityCaseEditPart) {
				types.add(SeaMonsterElementTypes.NormalCasePreventVul_3011);
			}
			if (targetEditPart instanceof VulnerabilityCase2EditPart) {
				types.add(SeaMonsterElementTypes.NormalCasePreventVul_3011);
			}
			if (targetEditPart instanceof VulnerabilityCaseEditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseDetectVul_3012);
			}
			if (targetEditPart instanceof VulnerabilityCase2EditPart) {
				types.add(SeaMonsterElementTypes.NormalCaseDetectVul_3012);
			}
			return types;
		}
		if (sourceEditPart instanceof ThreatCase2EditPart) {
			List types = new ArrayList();
			if (targetEditPart instanceof VulnerabilityCaseEditPart) {
				types.add(SeaMonsterElementTypes.ThreatCaseExploits_3006);
			}
			if (targetEditPart instanceof VulnerabilityCase2EditPart) {
				types.add(SeaMonsterElementTypes.ThreatCaseExploits_3006);
			}
			if (targetEditPart instanceof NormalCaseEditPart) {
				types.add(SeaMonsterElementTypes.ThreatCaseThreaten_3009);
			}
			if (targetEditPart instanceof NormalCase2EditPart) {
				types.add(SeaMonsterElementTypes.ThreatCaseThreaten_3009);
			}
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getTypesForSource(IAdaptable target,
			IElementType relationshipType) {
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target
				.getAdapter(IGraphicalEditPart.class);
		if (targetEditPart instanceof ThreatCaseEditPart) {
			List types = new ArrayList();
			if (relationshipType == SeaMonsterElementTypes.NormalCasePrevents_3001) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCasePrevents_3001) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseDetects_3005) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseDetects_3005) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			if (relationshipType == SeaMonsterElementTypes.BadActorActsIn_3008) {
				types.add(SeaMonsterElementTypes.BadActor_1006);
			}
			return types;
		}
		if (targetEditPart instanceof VulnerabilityCaseEditPart) {
			List types = new ArrayList();
			if (relationshipType == SeaMonsterElementTypes.ThreatCaseExploits_3006) {
				types.add(SeaMonsterElementTypes.ThreatCase_1001);
			}
			if (relationshipType == SeaMonsterElementTypes.ThreatCaseExploits_3006) {
				types.add(SeaMonsterElementTypes.ThreatCase_2003);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCasePreventVul_3011) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCasePreventVul_3011) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseDetectVul_3012) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseDetectVul_3012) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			return types;
		}
		if (targetEditPart instanceof NormalCaseEditPart) {
			List types = new ArrayList();
			if (relationshipType == SeaMonsterElementTypes.NormalCaseIncludes_3002) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseIncludes_3002) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			if (relationshipType == SeaMonsterElementTypes.GoodActorUses_3003) {
				types.add(SeaMonsterElementTypes.GoodActor_1004);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseExtends_3007) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseExtends_3007) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			if (relationshipType == SeaMonsterElementTypes.ThreatCaseThreaten_3009) {
				types.add(SeaMonsterElementTypes.ThreatCase_1001);
			}
			if (relationshipType == SeaMonsterElementTypes.ThreatCaseThreaten_3009) {
				types.add(SeaMonsterElementTypes.ThreatCase_2003);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseGeneralization_3010) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseGeneralization_3010) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			return types;
		}
		if (targetEditPart instanceof VulnerabilityCase2EditPart) {
			List types = new ArrayList();
			if (relationshipType == SeaMonsterElementTypes.ThreatCaseExploits_3006) {
				types.add(SeaMonsterElementTypes.ThreatCase_1001);
			}
			if (relationshipType == SeaMonsterElementTypes.ThreatCaseExploits_3006) {
				types.add(SeaMonsterElementTypes.ThreatCase_2003);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCasePreventVul_3011) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCasePreventVul_3011) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseDetectVul_3012) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseDetectVul_3012) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			return types;
		}
		if (targetEditPart instanceof NormalCase2EditPart) {
			List types = new ArrayList();
			if (relationshipType == SeaMonsterElementTypes.NormalCaseIncludes_3002) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseIncludes_3002) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			if (relationshipType == SeaMonsterElementTypes.GoodActorUses_3003) {
				types.add(SeaMonsterElementTypes.GoodActor_1004);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseExtends_3007) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseExtends_3007) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			if (relationshipType == SeaMonsterElementTypes.ThreatCaseThreaten_3009) {
				types.add(SeaMonsterElementTypes.ThreatCase_1001);
			}
			if (relationshipType == SeaMonsterElementTypes.ThreatCaseThreaten_3009) {
				types.add(SeaMonsterElementTypes.ThreatCase_2003);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseGeneralization_3010) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseGeneralization_3010) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			return types;
		}
		if (targetEditPart instanceof ThreatCase2EditPart) {
			List types = new ArrayList();
			if (relationshipType == SeaMonsterElementTypes.NormalCasePrevents_3001) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCasePrevents_3001) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseDetects_3005) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseDetects_3005) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			if (relationshipType == SeaMonsterElementTypes.BadActorActsIn_3008) {
				types.add(SeaMonsterElementTypes.BadActor_1006);
			}
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getTypesForTarget(IAdaptable source,
			IElementType relationshipType) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source
				.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof ThreatCaseEditPart) {
			List types = new ArrayList();
			if (relationshipType == SeaMonsterElementTypes.ThreatCaseExploits_3006) {
				types.add(SeaMonsterElementTypes.VulnerabilityCase_1002);
			}
			if (relationshipType == SeaMonsterElementTypes.ThreatCaseExploits_3006) {
				types.add(SeaMonsterElementTypes.VulnerabilityCase_2001);
			}
			if (relationshipType == SeaMonsterElementTypes.ThreatCaseThreaten_3009) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.ThreatCaseThreaten_3009) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			return types;
		}
		if (sourceEditPart instanceof GoodActorEditPart) {
			List types = new ArrayList();
			if (relationshipType == SeaMonsterElementTypes.GoodActorUses_3003) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.GoodActorUses_3003) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			return types;
		}
		if (sourceEditPart instanceof InsiderActorEditPart) {
			List types = new ArrayList();
			return types;
		}
		if (sourceEditPart instanceof BadActorEditPart) {
			List types = new ArrayList();
			if (relationshipType == SeaMonsterElementTypes.BadActorActsIn_3008) {
				types.add(SeaMonsterElementTypes.ThreatCase_1001);
			}
			if (relationshipType == SeaMonsterElementTypes.BadActorActsIn_3008) {
				types.add(SeaMonsterElementTypes.ThreatCase_2003);
			}
			return types;
		}
		if (sourceEditPart instanceof NormalCaseEditPart) {
			List types = new ArrayList();
			if (relationshipType == SeaMonsterElementTypes.NormalCasePrevents_3001) {
				types.add(SeaMonsterElementTypes.ThreatCase_1001);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCasePrevents_3001) {
				types.add(SeaMonsterElementTypes.ThreatCase_2003);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseIncludes_3002) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseIncludes_3002) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseDetects_3005) {
				types.add(SeaMonsterElementTypes.ThreatCase_1001);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseDetects_3005) {
				types.add(SeaMonsterElementTypes.ThreatCase_2003);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseExtends_3007) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseExtends_3007) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseGeneralization_3010) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseGeneralization_3010) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCasePreventVul_3011) {
				types.add(SeaMonsterElementTypes.VulnerabilityCase_1002);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCasePreventVul_3011) {
				types.add(SeaMonsterElementTypes.VulnerabilityCase_2001);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseDetectVul_3012) {
				types.add(SeaMonsterElementTypes.VulnerabilityCase_1002);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseDetectVul_3012) {
				types.add(SeaMonsterElementTypes.VulnerabilityCase_2001);
			}
			return types;
		}
		if (sourceEditPart instanceof NormalCase2EditPart) {
			List types = new ArrayList();
			if (relationshipType == SeaMonsterElementTypes.NormalCasePrevents_3001) {
				types.add(SeaMonsterElementTypes.ThreatCase_1001);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCasePrevents_3001) {
				types.add(SeaMonsterElementTypes.ThreatCase_2003);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseIncludes_3002) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseIncludes_3002) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseDetects_3005) {
				types.add(SeaMonsterElementTypes.ThreatCase_1001);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseDetects_3005) {
				types.add(SeaMonsterElementTypes.ThreatCase_2003);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseExtends_3007) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseExtends_3007) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseGeneralization_3010) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseGeneralization_3010) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCasePreventVul_3011) {
				types.add(SeaMonsterElementTypes.VulnerabilityCase_1002);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCasePreventVul_3011) {
				types.add(SeaMonsterElementTypes.VulnerabilityCase_2001);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseDetectVul_3012) {
				types.add(SeaMonsterElementTypes.VulnerabilityCase_1002);
			}
			if (relationshipType == SeaMonsterElementTypes.NormalCaseDetectVul_3012) {
				types.add(SeaMonsterElementTypes.VulnerabilityCase_2001);
			}
			return types;
		}
		if (sourceEditPart instanceof ThreatCase2EditPart) {
			List types = new ArrayList();
			if (relationshipType == SeaMonsterElementTypes.ThreatCaseExploits_3006) {
				types.add(SeaMonsterElementTypes.VulnerabilityCase_1002);
			}
			if (relationshipType == SeaMonsterElementTypes.ThreatCaseExploits_3006) {
				types.add(SeaMonsterElementTypes.VulnerabilityCase_2001);
			}
			if (relationshipType == SeaMonsterElementTypes.ThreatCaseThreaten_3009) {
				types.add(SeaMonsterElementTypes.NormalCase_1007);
			}
			if (relationshipType == SeaMonsterElementTypes.ThreatCaseThreaten_3009) {
				types.add(SeaMonsterElementTypes.NormalCase_2002);
			}
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public EObject selectExistingElementForSource(IAdaptable target,
			IElementType relationshipType) {
		return selectExistingElement(target, getTypesForSource(target,
				relationshipType));
	}

	/**
	 * @generated
	 */
	public EObject selectExistingElementForTarget(IAdaptable source,
			IElementType relationshipType) {
		return selectExistingElement(source, getTypesForTarget(source,
				relationshipType));
	}

	/**
	 * @generated
	 */
	protected EObject selectExistingElement(IAdaptable host, Collection types) {
		if (types.isEmpty()) {
			return null;
		}
		IGraphicalEditPart editPart = (IGraphicalEditPart) host
				.getAdapter(IGraphicalEditPart.class);
		if (editPart == null) {
			return null;
		}
		Diagram diagram = (Diagram) editPart.getRoot().getContents().getModel();
		Collection elements = new HashSet();
		for (Iterator it = diagram.getElement().eAllContents(); it.hasNext();) {
			EObject element = (EObject) it.next();
			if (isApplicableElement(element, types)) {
				elements.add(element);
			}
		}
		if (elements.isEmpty()) {
			return null;
		}
		return selectElement((EObject[]) elements.toArray(new EObject[elements
				.size()]));
	}

	/**
	 * @generated
	 */
	protected boolean isApplicableElement(EObject element, Collection types) {
		IElementType type = ElementTypeRegistry.getInstance().getElementType(
				element);
		return types.contains(type);
	}

	/**
	 * @generated
	 */
	protected EObject selectElement(EObject[] elements) {
		Shell shell = Display.getCurrent().getActiveShell();
		ILabelProvider labelProvider = new AdapterFactoryLabelProvider(
				SeaMonsterDiagramEditorPlugin.getInstance()
						.getItemProvidersAdapterFactory());
		ElementListSelectionDialog dialog = new ElementListSelectionDialog(
				shell, labelProvider);
		dialog.setMessage(Messages.SeaMonsterModelingAssistantProviderMessage);
		dialog.setTitle(Messages.SeaMonsterModelingAssistantProviderTitle);
		dialog.setMultipleSelection(false);
		dialog.setElements(elements);
		EObject selected = null;
		if (dialog.open() == Window.OK) {
			selected = (EObject) dialog.getFirstResult();
		}
		return selected;
	}
}
